/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         CISAparse
#define yylex           CISAlex
#define yyerror         CISAerror
#define yydebug         CISAdebug
#define yynerrs         CISAnerrs
#define yylval          CISAlval
#define yychar          CISAchar

/* First part of user prologue.  */
#line 9 "CISA.y"

#include <stdio.h>
#include <math.h>
#include <string>
#include <vector>

#include "visa_igc_common_header.h"
#include "Common_ISA.h"
#include "Common_ISA_util.h"
#include "Common_ISA_framework.h"
#include "JitterDataStruct.h"
#include "VISAKernel.h"

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size);

//VISA_Type variable_declaration_and_type_check(char *var, Common_ISA_Var_Class type);
void CISAerror(CISA_IR_Builder* builder, char const* msg);
int yylex(CISA_IR_Builder *pBuilder);
extern int CISAlineno;

static bool streq(const char *sym0, const char *sym1);
static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value);
static VISA_Align AlignBytesToVisaAlignment(int bytes);
static int DataTypeSizeOf(VISA_Type type);
static bool ParseEMask(const char* sym, VISA_EMask_Ctrl &emask);




//
// check if the cond is true.
// if cond is false, then print errorMessage (syntax error) and YYABORT
#define MUST_HOLD(cond, errorMessage) \
  {if (!(cond)) {pBuilder->RecordParseError(CISAlineno, errorMessage); YYABORT;}}
#define PARSE_ERROR_AT(LINE,...)\
  {pBuilder->RecordParseError(LINE, __VA_ARGS__); YYABORT;}
#define PARSE_ERROR(...)\
    PARSE_ERROR_AT(CISAlineno, __VA_ARGS__)

// Use this to wrap API calls that return false, nullptr, or 0 on failure
// It's assumed that the API call reported the parse error
#define ABORT_ON_FAIL(X) \
    do \
        if (!(X)) \
            YYABORT;\
    while (0)
#define TRACE(S) \
    do { \
      if (CISAout && pBuilder->debugParse()) \
          fprintf(CISAout, "line %d: %s", CISAlineno, S); \
    } while (0)

std::deque<const char*> switchLabels;
char * switch_label_array[32];
std::vector<VISA_opnd*> RTRWOperandsVec;
int num_parameters;

VISA_RawOpnd* rawOperandArray[16];

// global var for non-kernel attribute option.
// The var needs to be cleared before each use.
std::vector<attr_gen_struct*> AttrOptVar;


#line 148 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "CISA.tab.hpp"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_ALIGN_KEYWORD = 3,              /* ALIGN_KEYWORD  */
  YYSYMBOL_ATOMIC_SUB_OP = 4,              /* ATOMIC_SUB_OP  */
  YYSYMBOL_DIRECTIVE_DECL = 5,             /* DIRECTIVE_DECL  */
  YYSYMBOL_DIRECTIVE_FUNC = 6,             /* DIRECTIVE_FUNC  */
  YYSYMBOL_DIRECTIVE_FUNCDECL = 7,         /* DIRECTIVE_FUNCDECL  */
  YYSYMBOL_DIRECTIVE_GLOBAL_FUNC = 8,      /* DIRECTIVE_GLOBAL_FUNC  */
  YYSYMBOL_DIRECTIVE_IMPLICIT = 9,         /* DIRECTIVE_IMPLICIT  */
  YYSYMBOL_DIRECTIVE_INPUT = 10,           /* DIRECTIVE_INPUT  */
  YYSYMBOL_DIRECTIVE_KERNEL = 11,          /* DIRECTIVE_KERNEL  */
  YYSYMBOL_DIRECTIVE_KERNEL_ATTR = 12,     /* DIRECTIVE_KERNEL_ATTR  */
  YYSYMBOL_DIRECTIVE_PARAMETER = 13,       /* DIRECTIVE_PARAMETER  */
  YYSYMBOL_DIRECTIVE_VERSION = 14,         /* DIRECTIVE_VERSION  */
  YYSYMBOL_ALIAS_EQ = 15,                  /* ALIAS_EQ  */
  YYSYMBOL_ALIGN_EQ = 16,                  /* ALIGN_EQ  */
  YYSYMBOL_ATTR_EQ = 17,                   /* ATTR_EQ  */
  YYSYMBOL_OFFSET_EQ = 18,                 /* OFFSET_EQ  */
  YYSYMBOL_NUM_ELTS_EQ = 19,               /* NUM_ELTS_EQ  */
  YYSYMBOL_V_NAME_EQ = 20,                 /* V_NAME_EQ  */
  YYSYMBOL_SIZE_EQ = 21,                   /* SIZE_EQ  */
  YYSYMBOL_V_TYPE_EQ_G = 22,               /* V_TYPE_EQ_G  */
  YYSYMBOL_V_TYPE_EQ_P = 23,               /* V_TYPE_EQ_P  */
  YYSYMBOL_V_TYPE_EQ_A = 24,               /* V_TYPE_EQ_A  */
  YYSYMBOL_V_TYPE_EQ_S = 25,               /* V_TYPE_EQ_S  */
  YYSYMBOL_V_TYPE_EQ_T = 26,               /* V_TYPE_EQ_T  */
  YYSYMBOL_CPS = 27,                       /* CPS  */
  YYSYMBOL_NON_UNIFORM_SAMPLER = 28,       /* NON_UNIFORM_SAMPLER  */
  YYSYMBOL_PIXEL_NULL_MASK = 29,           /* PIXEL_NULL_MASK  */
  YYSYMBOL_RAW_SEND_STRING = 30,           /* RAW_SEND_STRING  */
  YYSYMBOL_RAW_SENDC_STRING = 31,          /* RAW_SENDC_STRING  */
  YYSYMBOL_RAW_SENDS_STRING = 32,          /* RAW_SENDS_STRING  */
  YYSYMBOL_RAW_SENDS_EOT_STRING = 33,      /* RAW_SENDS_EOT_STRING  */
  YYSYMBOL_RAW_SENDSC_STRING = 34,         /* RAW_SENDSC_STRING  */
  YYSYMBOL_RAW_SENDSC_EOT_STRING = 35,     /* RAW_SENDSC_EOT_STRING  */
  YYSYMBOL_SAT = 36,                       /* SAT  */
  YYSYMBOL_SRCMOD_ABS = 37,                /* SRCMOD_ABS  */
  YYSYMBOL_SRCMOD_NEG = 38,                /* SRCMOD_NEG  */
  YYSYMBOL_SRCMOD_NEGABS = 39,             /* SRCMOD_NEGABS  */
  YYSYMBOL_SRCMOD_NOT = 40,                /* SRCMOD_NOT  */
  YYSYMBOL_BFN_OP = 41,                    /* BFN_OP  */
  YYSYMBOL_DPAS_OP = 42,                   /* DPAS_OP  */
  YYSYMBOL_SVM_ALIGNED = 43,               /* SVM_ALIGNED  */
  YYSYMBOL_SVM_UNALIGNED = 44,             /* SVM_UNALIGNED  */
  YYSYMBOL_NBARRIER_SIGNAL = 45,           /* NBARRIER_SIGNAL  */
  YYSYMBOL_NBARRIER_WAIT = 46,             /* NBARRIER_WAIT  */
  YYSYMBOL_ITYPE = 47,                     /* ITYPE  */
  YYSYMBOL_DECL_DATA_TYPE = 48,            /* DECL_DATA_TYPE  */
  YYSYMBOL_DFTYPE = 49,                    /* DFTYPE  */
  YYSYMBOL_FTYPE = 50,                     /* FTYPE  */
  YYSYMBOL_HFTYPE = 51,                    /* HFTYPE  */
  YYSYMBOL_VTYPE = 52,                     /* VTYPE  */
  YYSYMBOL_COND_MOD = 53,                  /* COND_MOD  */
  YYSYMBOL_LANGLE = 54,                    /* LANGLE  */
  YYSYMBOL_RANGLE = 55,                    /* RANGLE  */
  YYSYMBOL_LBRACK = 56,                    /* LBRACK  */
  YYSYMBOL_RBRACK = 57,                    /* RBRACK  */
  YYSYMBOL_IND_LBRACK = 58,                /* IND_LBRACK  */
  YYSYMBOL_LPAREN = 59,                    /* LPAREN  */
  YYSYMBOL_RPAREN = 60,                    /* RPAREN  */
  YYSYMBOL_LBRACE = 61,                    /* LBRACE  */
  YYSYMBOL_RBRACE = 62,                    /* RBRACE  */
  YYSYMBOL_DOT = 63,                       /* DOT  */
  YYSYMBOL_COMMA = 64,                     /* COMMA  */
  YYSYMBOL_SEMI = 65,                      /* SEMI  */
  YYSYMBOL_COLON = 66,                     /* COLON  */
  YYSYMBOL_SLASH = 67,                     /* SLASH  */
  YYSYMBOL_PERCENT = 68,                   /* PERCENT  */
  YYSYMBOL_EQUALS = 69,                    /* EQUALS  */
  YYSYMBOL_PLUS = 70,                      /* PLUS  */
  YYSYMBOL_MINUS = 71,                     /* MINUS  */
  YYSYMBOL_TIMES = 72,                     /* TIMES  */
  YYSYMBOL_AMP = 73,                       /* AMP  */
  YYSYMBOL_CIRC = 74,                      /* CIRC  */
  YYSYMBOL_PIPE = 75,                      /* PIPE  */
  YYSYMBOL_TILDE = 76,                     /* TILDE  */
  YYSYMBOL_BANG = 77,                      /* BANG  */
  YYSYMBOL_QUESTION = 78,                  /* QUESTION  */
  YYSYMBOL_LEQ = 79,                       /* LEQ  */
  YYSYMBOL_GEQ = 80,                       /* GEQ  */
  YYSYMBOL_EQ = 81,                        /* EQ  */
  YYSYMBOL_NEQ = 82,                       /* NEQ  */
  YYSYMBOL_SHL = 83,                       /* SHL  */
  YYSYMBOL_SHRS = 84,                      /* SHRS  */
  YYSYMBOL_SHRZ = 85,                      /* SHRZ  */
  YYSYMBOL_LABEL = 86,                     /* LABEL  */
  YYSYMBOL_IDENT = 87,                     /* IDENT  */
  YYSYMBOL_BUILTIN_NULL = 88,              /* BUILTIN_NULL  */
  YYSYMBOL_BUILTIN = 89,                   /* BUILTIN  */
  YYSYMBOL_STRING_LIT = 90,                /* STRING_LIT  */
  YYSYMBOL_NEWLINE = 91,                   /* NEWLINE  */
  YYSYMBOL_RTWRITE_OPTION = 92,            /* RTWRITE_OPTION  */
  YYSYMBOL_MEDIA_MODE = 93,                /* MEDIA_MODE  */
  YYSYMBOL_OWORD_MODIFIER = 94,            /* OWORD_MODIFIER  */
  YYSYMBOL_SAMPLER_CHANNEL = 95,           /* SAMPLER_CHANNEL  */
  YYSYMBOL_CHANNEL_OUTPUT = 96,            /* CHANNEL_OUTPUT  */
  YYSYMBOL_EXECMODE = 97,                  /* EXECMODE  */
  YYSYMBOL_CNTRL = 98,                     /* CNTRL  */
  YYSYMBOL_FENCE_OPTIONS = 99,             /* FENCE_OPTIONS  */
  YYSYMBOL_ADDR_ADD_OP = 100,              /* ADDR_ADD_OP  */
  YYSYMBOL_UNARY_LOGIC_OP = 101,           /* UNARY_LOGIC_OP  */
  YYSYMBOL_BINARY_LOGIC_OP = 102,          /* BINARY_LOGIC_OP  */
  YYSYMBOL_TERNARY_LOGIC_OP = 103,         /* TERNARY_LOGIC_OP  */
  YYSYMBOL_QUATERNARY_LOGIC_OP = 104,      /* QUATERNARY_LOGIC_OP  */
  YYSYMBOL_SEL_OP = 105,                   /* SEL_OP  */
  YYSYMBOL_MIN_OP = 106,                   /* MIN_OP  */
  YYSYMBOL_MAX_OP = 107,                   /* MAX_OP  */
  YYSYMBOL_ANTI_TRIG_OP = 108,             /* ANTI_TRIG_OP  */
  YYSYMBOL_MATH2_OP = 109,                 /* MATH2_OP  */
  YYSYMBOL_MATH3_OP = 110,                 /* MATH3_OP  */
  YYSYMBOL_ARITH2_OP = 111,                /* ARITH2_OP  */
  YYSYMBOL_ARITH3_OP = 112,                /* ARITH3_OP  */
  YYSYMBOL_ARITH4_OP = 113,                /* ARITH4_OP  */
  YYSYMBOL_ARITH4_OP2 = 114,               /* ARITH4_OP2  */
  YYSYMBOL_CMP_OP = 115,                   /* CMP_OP  */
  YYSYMBOL_SVM_OP = 116,                   /* SVM_OP  */
  YYSYMBOL_SVM_SCATTER_OP = 117,           /* SVM_SCATTER_OP  */
  YYSYMBOL_SVM_GATHER4SCALED_OP = 118,     /* SVM_GATHER4SCALED_OP  */
  YYSYMBOL_SVM_SCATTER4SCALED_OP = 119,    /* SVM_SCATTER4SCALED_OP  */
  YYSYMBOL_SVM_ATOMIC_OP = 120,            /* SVM_ATOMIC_OP  */
  YYSYMBOL_OWORD_OP = 121,                 /* OWORD_OP  */
  YYSYMBOL_MEDIA_OP = 122,                 /* MEDIA_OP  */
  YYSYMBOL_SCATTER_OP = 123,               /* SCATTER_OP  */
  YYSYMBOL_SCATTER_TYPED_OP = 124,         /* SCATTER_TYPED_OP  */
  YYSYMBOL_SCATTER_SCALED_OP = 125,        /* SCATTER_SCALED_OP  */
  YYSYMBOL_SCATTER4_SCALED_OP = 126,       /* SCATTER4_SCALED_OP  */
  YYSYMBOL_BARRIER_OP = 127,               /* BARRIER_OP  */
  YYSYMBOL_SBARRIER_SIGNAL = 128,          /* SBARRIER_SIGNAL  */
  YYSYMBOL_SBARRIER_WAIT = 129,            /* SBARRIER_WAIT  */
  YYSYMBOL_DWORD_ATOMIC_OP = 130,          /* DWORD_ATOMIC_OP  */
  YYSYMBOL_TYPED_ATOMIC_OP = 131,          /* TYPED_ATOMIC_OP  */
  YYSYMBOL_SAMPLE_OP = 132,                /* SAMPLE_OP  */
  YYSYMBOL_SAMPLE_UNORM_OP = 133,          /* SAMPLE_UNORM_OP  */
  YYSYMBOL_VME_IME_OP = 134,               /* VME_IME_OP  */
  YYSYMBOL_VME_SIC_OP = 135,               /* VME_SIC_OP  */
  YYSYMBOL_VME_FBR_OP = 136,               /* VME_FBR_OP  */
  YYSYMBOL_BRANCH_OP = 137,                /* BRANCH_OP  */
  YYSYMBOL_RET_OP = 138,                   /* RET_OP  */
  YYSYMBOL_IFCALL = 139,                   /* IFCALL  */
  YYSYMBOL_FCALL = 140,                    /* FCALL  */
  YYSYMBOL_FADDR = 141,                    /* FADDR  */
  YYSYMBOL_SWITCHJMP_OP = 142,             /* SWITCHJMP_OP  */
  YYSYMBOL_MOVS_OP = 143,                  /* MOVS_OP  */
  YYSYMBOL_SETP_OP = 144,                  /* SETP_OP  */
  YYSYMBOL_MOV_OP = 145,                   /* MOV_OP  */
  YYSYMBOL_FILE_OP = 146,                  /* FILE_OP  */
  YYSYMBOL_LOC_OP = 147,                   /* LOC_OP  */
  YYSYMBOL_CACHE_FLUSH_OP = 148,           /* CACHE_FLUSH_OP  */
  YYSYMBOL_WAIT_OP = 149,                  /* WAIT_OP  */
  YYSYMBOL_FENCE_GLOBAL_OP = 150,          /* FENCE_GLOBAL_OP  */
  YYSYMBOL_FENCE_LOCAL_OP = 151,           /* FENCE_LOCAL_OP  */
  YYSYMBOL_FENCE_SW_OP = 152,              /* FENCE_SW_OP  */
  YYSYMBOL_YIELD_OP = 153,                 /* YIELD_OP  */
  YYSYMBOL_SAMPLE_3D_OP = 154,             /* SAMPLE_3D_OP  */
  YYSYMBOL_LOAD_3D_OP = 155,               /* LOAD_3D_OP  */
  YYSYMBOL_SAMPLE4_3D_OP = 156,            /* SAMPLE4_3D_OP  */
  YYSYMBOL_RESINFO_OP_3D = 157,            /* RESINFO_OP_3D  */
  YYSYMBOL_SAMPLEINFO_OP_3D = 158,         /* SAMPLEINFO_OP_3D  */
  YYSYMBOL_RTWRITE_OP_3D = 159,            /* RTWRITE_OP_3D  */
  YYSYMBOL_URBWRITE_OP_3D = 160,           /* URBWRITE_OP_3D  */
  YYSYMBOL_LIFETIME_START_OP = 161,        /* LIFETIME_START_OP  */
  YYSYMBOL_LIFETIME_END_OP = 162,          /* LIFETIME_END_OP  */
  YYSYMBOL_AVS_OP = 163,                   /* AVS_OP  */
  YYSYMBOL_CALL_OP = 164,                  /* CALL_OP  */
  YYSYMBOL_PRED_CNTL = 165,                /* PRED_CNTL  */
  YYSYMBOL_F32_LIT = 166,                  /* F32_LIT  */
  YYSYMBOL_F64_LIT = 167,                  /* F64_LIT  */
  YYSYMBOL_DEC_LIT = 168,                  /* DEC_LIT  */
  YYSYMBOL_HEX_LIT = 169,                  /* HEX_LIT  */
  YYSYMBOL_BUILTIN_SIZEOF = 170,           /* BUILTIN_SIZEOF  */
  YYSYMBOL_BUILTIN_DISPATCH_SIMD_SIZE = 171, /* BUILTIN_DISPATCH_SIMD_SIZE  */
  YYSYMBOL_QW_SCATTER_OP = 172,            /* QW_SCATTER_OP  */
  YYSYMBOL_LSC_CACHING_OPT = 173,          /* LSC_CACHING_OPT  */
  YYSYMBOL_LSC_ADDR_SIZE_TK = 174,         /* LSC_ADDR_SIZE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK = 175,        /* LSC_DATA_SHAPE_TK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_CHMASK = 176, /* LSC_DATA_SHAPE_TK_CHMASK  */
  YYSYMBOL_LSC_DATA_SHAPE_TK_BLOCK2D = 177, /* LSC_DATA_SHAPE_TK_BLOCK2D  */
  YYSYMBOL_LSC_AM_FLAT = 178,              /* LSC_AM_FLAT  */
  YYSYMBOL_LSC_AM_BTI = 179,               /* LSC_AM_BTI  */
  YYSYMBOL_LSC_AM_BSS = 180,               /* LSC_AM_BSS  */
  YYSYMBOL_LSC_AM_SS = 181,                /* LSC_AM_SS  */
  YYSYMBOL_LSC_AM_ARG = 182,               /* LSC_AM_ARG  */
  YYSYMBOL_LSC_FENCE_OP_TYPE = 183,        /* LSC_FENCE_OP_TYPE  */
  YYSYMBOL_LSC_FENCE_SCOPE = 184,          /* LSC_FENCE_SCOPE  */
  YYSYMBOL_LSC_SFID_UNTYPED_TOKEN = 185,   /* LSC_SFID_UNTYPED_TOKEN  */
  YYSYMBOL_LSC_SFID_TYPED_TOKEN = 186,     /* LSC_SFID_TYPED_TOKEN  */
  YYSYMBOL_LSC_LOAD_MNEMONIC = 187,        /* LSC_LOAD_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_STRIDED_MNEMONIC = 188, /* LSC_LOAD_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_LOAD_BLOCK2D_MNEMONIC = 189, /* LSC_LOAD_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_STORE_MNEMONIC = 190,       /* LSC_STORE_MNEMONIC  */
  YYSYMBOL_LSC_STORE_STRIDED_MNEMONIC = 191, /* LSC_STORE_STRIDED_MNEMONIC  */
  YYSYMBOL_LSC_STORE_BLOCK2D_MNEMONIC = 192, /* LSC_STORE_BLOCK2D_MNEMONIC  */
  YYSYMBOL_LSC_ATOMIC_MNEMONIC = 193,      /* LSC_ATOMIC_MNEMONIC  */
  YYSYMBOL_LSC_READ_STATE_INFO_MNEMONIC = 194, /* LSC_READ_STATE_INFO_MNEMONIC  */
  YYSYMBOL_LSC_FENCE_MNEMONIC = 195,       /* LSC_FENCE_MNEMONIC  */
  YYSYMBOL_FCVT_OP = 196,                  /* FCVT_OP  */
  YYSYMBOL_YYACCEPT = 197,                 /* $accept  */
  YYSYMBOL_Listing = 198,                  /* Listing  */
  YYSYMBOL_ListingHeader = 199,            /* ListingHeader  */
  YYSYMBOL_Statements = 200,               /* Statements  */
  YYSYMBOL_Newlines = 201,                 /* Newlines  */
  YYSYMBOL_NewlinesOpt = 202,              /* NewlinesOpt  */
  YYSYMBOL_Statement = 203,                /* Statement  */
  YYSYMBOL_Scope = 204,                    /* Scope  */
  YYSYMBOL_ScopeStart = 205,               /* ScopeStart  */
  YYSYMBOL_ScopeEnd = 206,                 /* ScopeEnd  */
  YYSYMBOL_IdentOrStringLit = 207,         /* IdentOrStringLit  */
  YYSYMBOL_DirectiveKernel = 208,          /* DirectiveKernel  */
  YYSYMBOL_DirectiveGlobalFunction = 209,  /* DirectiveGlobalFunction  */
  YYSYMBOL_DirectiveVersion = 210,         /* DirectiveVersion  */
  YYSYMBOL_DirectiveDecl = 211,            /* DirectiveDecl  */
  YYSYMBOL_DeclFunction = 212,             /* DeclFunction  */
  YYSYMBOL_DeclVariable = 213,             /* DeclVariable  */
  YYSYMBOL_DeclAddress = 214,              /* DeclAddress  */
  YYSYMBOL_DeclPredicate = 215,            /* DeclPredicate  */
  YYSYMBOL_DeclSampler = 216,              /* DeclSampler  */
  YYSYMBOL_VNameEqOpt = 217,               /* VNameEqOpt  */
  YYSYMBOL_DeclSurface = 218,              /* DeclSurface  */
  YYSYMBOL_DirectiveInput = 219,           /* DirectiveInput  */
  YYSYMBOL_DirectiveImplicitInput = 220,   /* DirectiveImplicitInput  */
  YYSYMBOL_InputOffset = 221,              /* InputOffset  */
  YYSYMBOL_InputSize = 222,                /* InputSize  */
  YYSYMBOL_DirectiveParameter = 223,       /* DirectiveParameter  */
  YYSYMBOL_DirectiveAttr = 224,            /* DirectiveAttr  */
  YYSYMBOL_DirectiveFunc = 225,            /* DirectiveFunc  */
  YYSYMBOL_AlignAttrOpt = 226,             /* AlignAttrOpt  */
  YYSYMBOL_Align = 227,                    /* Align  */
  YYSYMBOL_AliasAttrOpt = 228,             /* AliasAttrOpt  */
  YYSYMBOL_OneAttr = 229,                  /* OneAttr  */
  YYSYMBOL_AttrOpt = 230,                  /* AttrOpt  */
  YYSYMBOL_GenAttrOpt = 231,               /* GenAttrOpt  */
  YYSYMBOL_Instruction = 232,              /* Instruction  */
  YYSYMBOL_Label = 233,                    /* Label  */
  YYSYMBOL_LogicInstruction = 234,         /* LogicInstruction  */
  YYSYMBOL_UnaryLogicInstruction = 235,    /* UnaryLogicInstruction  */
  YYSYMBOL_MathInstruction_2OPND = 236,    /* MathInstruction_2OPND  */
  YYSYMBOL_MathInstruction_3OPND = 237,    /* MathInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_2OPND = 238,   /* ArithInstruction_2OPND  */
  YYSYMBOL_ArithInstruction_3OPND = 239,   /* ArithInstruction_3OPND  */
  YYSYMBOL_ArithInstruction_4OPND = 240,   /* ArithInstruction_4OPND  */
  YYSYMBOL_DpasInstruction = 241,          /* DpasInstruction  */
  YYSYMBOL_BfnInstruction = 242,           /* BfnInstruction  */
  YYSYMBOL_QwScatterInstruction = 243,     /* QwScatterInstruction  */
  YYSYMBOL_FCvtInstruction = 244,          /* FCvtInstruction  */
  YYSYMBOL_AntiTrigInstruction = 245,      /* AntiTrigInstruction  */
  YYSYMBOL_AddrAddInstruction = 246,       /* AddrAddInstruction  */
  YYSYMBOL_SetpInstruction = 247,          /* SetpInstruction  */
  YYSYMBOL_SelInstruction = 248,           /* SelInstruction  */
  YYSYMBOL_MinInstruction = 249,           /* MinInstruction  */
  YYSYMBOL_MaxInstruction = 250,           /* MaxInstruction  */
  YYSYMBOL_MovInstruction = 251,           /* MovInstruction  */
  YYSYMBOL_MovsInstruction = 252,          /* MovsInstruction  */
  YYSYMBOL_CmpInstruction = 253,           /* CmpInstruction  */
  YYSYMBOL_MediaInstruction = 254,         /* MediaInstruction  */
  YYSYMBOL_MediaInstructionPlaneID = 255,  /* MediaInstructionPlaneID  */
  YYSYMBOL_ScatterInstruction = 256,       /* ScatterInstruction  */
  YYSYMBOL_ScatterTypedInstruction = 257,  /* ScatterTypedInstruction  */
  YYSYMBOL_Scatter4ScaledInstruction = 258, /* Scatter4ScaledInstruction  */
  YYSYMBOL_ScatterScaledInstruction = 259, /* ScatterScaledInstruction  */
  YYSYMBOL_SynchronizationInstruction = 260, /* SynchronizationInstruction  */
  YYSYMBOL_DwordAtomicInstruction = 261,   /* DwordAtomicInstruction  */
  YYSYMBOL_TypedAtomicInstruction = 262,   /* TypedAtomicInstruction  */
  YYSYMBOL_Atomic16Opt = 263,              /* Atomic16Opt  */
  YYSYMBOL_SampleUnormInstruction = 264,   /* SampleUnormInstruction  */
  YYSYMBOL_SampleInstruction = 265,        /* SampleInstruction  */
  YYSYMBOL_Sample3dInstruction = 266,      /* Sample3dInstruction  */
  YYSYMBOL_Sample3DInstruction = 267,      /* Sample3DInstruction  */
  YYSYMBOL_CPSEnableOpt = 268,             /* CPSEnableOpt  */
  YYSYMBOL_NonUniformSamplerEnableOpt = 269, /* NonUniformSamplerEnableOpt  */
  YYSYMBOL_Load3dInstruction = 270,        /* Load3dInstruction  */
  YYSYMBOL_Load3DInstruction = 271,        /* Load3DInstruction  */
  YYSYMBOL_Gather43dInstruction = 272,     /* Gather43dInstruction  */
  YYSYMBOL_Gather43DInstruction = 273,     /* Gather43DInstruction  */
  YYSYMBOL_PixelNullMaskEnableOpt = 274,   /* PixelNullMaskEnableOpt  */
  YYSYMBOL_ResInfo3dInstruction = 275,     /* ResInfo3dInstruction  */
  YYSYMBOL_SampleInfo3dInstruction = 276,  /* SampleInfo3dInstruction  */
  YYSYMBOL_RTWriteOperands = 277,          /* RTWriteOperands  */
  YYSYMBOL_RTWriteInstruction = 278,       /* RTWriteInstruction  */
  YYSYMBOL_RTWInstruction = 279,           /* RTWInstruction  */
  YYSYMBOL_RTWriteModeOpt = 280,           /* RTWriteModeOpt  */
  YYSYMBOL_URBWriteInstruction = 281,      /* URBWriteInstruction  */
  YYSYMBOL_AVSInstruction = 282,           /* AVSInstruction  */
  YYSYMBOL_VMEInstruction = 283,           /* VMEInstruction  */
  YYSYMBOL_OwordInstruction = 284,         /* OwordInstruction  */
  YYSYMBOL_SvmInstruction = 285,           /* SvmInstruction  */
  YYSYMBOL_AtomicBitwidthOpt = 286,        /* AtomicBitwidthOpt  */
  YYSYMBOL_LscInstruction = 287,           /* LscInstruction  */
  YYSYMBOL_LscUntypedLoad = 288,           /* LscUntypedLoad  */
  YYSYMBOL_LscUntypedStridedLoad = 289,    /* LscUntypedStridedLoad  */
  YYSYMBOL_LscUntypedBlock2dLoad = 290,    /* LscUntypedBlock2dLoad  */
  YYSYMBOL_LscUntypedStore = 291,          /* LscUntypedStore  */
  YYSYMBOL_LscUntypedStridedStore = 292,   /* LscUntypedStridedStore  */
  YYSYMBOL_LscUntypedBlock2dStore = 293,   /* LscUntypedBlock2dStore  */
  YYSYMBOL_LscUntypedAtomic = 294,         /* LscUntypedAtomic  */
  YYSYMBOL_LscTypedLoad = 295,             /* LscTypedLoad  */
  YYSYMBOL_LscTypedStore = 296,            /* LscTypedStore  */
  YYSYMBOL_LscTypedAtomic = 297,           /* LscTypedAtomic  */
  YYSYMBOL_LscTypedReadStateInfo = 298,    /* LscTypedReadStateInfo  */
  YYSYMBOL_LscFence = 299,                 /* LscFence  */
  YYSYMBOL_LscSfid = 300,                  /* LscSfid  */
  YYSYMBOL_LscCacheOpts = 301,             /* LscCacheOpts  */
  YYSYMBOL_LscUntypedAddrOperand = 302,    /* LscUntypedAddrOperand  */
  YYSYMBOL_LscUntypedStridedAddrOperand = 303, /* LscUntypedStridedAddrOperand  */
  YYSYMBOL_LscUntypedBlock2dAddrOperand = 304, /* LscUntypedBlock2dAddrOperand  */
  YYSYMBOL_LscTypedOneAddrOperand = 305,   /* LscTypedOneAddrOperand  */
  YYSYMBOL_LscTypedTwoAddrOperand = 306,   /* LscTypedTwoAddrOperand  */
  YYSYMBOL_LscTypedThreeAddrOperand = 307, /* LscTypedThreeAddrOperand  */
  YYSYMBOL_LscTypedFourAddrOperand = 308,  /* LscTypedFourAddrOperand  */
  YYSYMBOL_LscTypedAddrOperand = 309,      /* LscTypedAddrOperand  */
  YYSYMBOL_LscAddrImmOffsetOpt = 310,      /* LscAddrImmOffsetOpt  */
  YYSYMBOL_LscAddrImmScaleOpt = 311,       /* LscAddrImmScaleOpt  */
  YYSYMBOL_LscAddrModelOpt = 312,          /* LscAddrModelOpt  */
  YYSYMBOL_LscRegAddrModel = 313,          /* LscRegAddrModel  */
  YYSYMBOL_LscRegAddrModelKind = 314,      /* LscRegAddrModelKind  */
  YYSYMBOL_LscVectorOpRegOrImm = 315,      /* LscVectorOpRegOrImm  */
  YYSYMBOL_LscVectorOpImm = 316,           /* LscVectorOpImm  */
  YYSYMBOL_LscVectorOpReg = 317,           /* LscVectorOpReg  */
  YYSYMBOL_LscDataOperand = 318,           /* LscDataOperand  */
  YYSYMBOL_LscDataOperand2D = 319,         /* LscDataOperand2D  */
  YYSYMBOL_LscPayloadReg = 320,            /* LscPayloadReg  */
  YYSYMBOL_LscPayloadNonNullReg = 321,     /* LscPayloadNonNullReg  */
  YYSYMBOL_SwitchLabels = 322,             /* SwitchLabels  */
  YYSYMBOL_BranchInstruction = 323,        /* BranchInstruction  */
  YYSYMBOL_FILE = 324,                     /* FILE  */
  YYSYMBOL_LOC = 325,                      /* LOC  */
  YYSYMBOL_RawSendInstruction = 326,       /* RawSendInstruction  */
  YYSYMBOL_LifetimeStartInst = 327,        /* LifetimeStartInst  */
  YYSYMBOL_LifetimeEndInst = 328,          /* LifetimeEndInst  */
  YYSYMBOL_RawSendsInstruction = 329,      /* RawSendsInstruction  */
  YYSYMBOL_NullaryInstruction = 330,       /* NullaryInstruction  */
  YYSYMBOL_OwordModifier = 331,            /* OwordModifier  */
  YYSYMBOL_Predicate = 332,                /* Predicate  */
  YYSYMBOL_PredSign = 333,                 /* PredSign  */
  YYSYMBOL_PredCtrlOpt = 334,              /* PredCtrlOpt  */
  YYSYMBOL_SatModOpt = 335,                /* SatModOpt  */
  YYSYMBOL_SrcModifier = 336,              /* SrcModifier  */
  YYSYMBOL_ConditionalModifier = 337,      /* ConditionalModifier  */
  YYSYMBOL_VecDstOperand_A = 338,          /* VecDstOperand_A  */
  YYSYMBOL_VecDstOperand_G = 339,          /* VecDstOperand_G  */
  YYSYMBOL_VecDstOperand_G_I = 340,        /* VecDstOperand_G_I  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A_AO = 341, /* VecSrcOperand_G_I_IMM_A_AO  */
  YYSYMBOL_VecSrcOperand_G_I_IMM_A = 342,  /* VecSrcOperand_G_I_IMM_A  */
  YYSYMBOL_VecSrcOperand_G_I_IMM = 343,    /* VecSrcOperand_G_I_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM = 344,      /* VecSrcOperand_G_IMM  */
  YYSYMBOL_VecSrcOperand_G_IMM_AO = 345,   /* VecSrcOperand_G_IMM_AO  */
  YYSYMBOL_VecSrcOperand_G_A = 346,        /* VecSrcOperand_G_A  */
  YYSYMBOL_VecSrcOperand_G_A_AO = 347,     /* VecSrcOperand_G_A_AO  */
  YYSYMBOL_VecSrcOperand_G = 348,          /* VecSrcOperand_G  */
  YYSYMBOL_VecSrcOpndSimple = 349,         /* VecSrcOpndSimple  */
  YYSYMBOL_VMEOpndIME = 350,               /* VMEOpndIME  */
  YYSYMBOL_VMEOpndFBR = 351,               /* VMEOpndFBR  */
  YYSYMBOL_SrcStateOperand = 352,          /* SrcStateOperand  */
  YYSYMBOL_DstStateOperand = 353,          /* DstStateOperand  */
  YYSYMBOL_RawOperand = 354,               /* RawOperand  */
  YYSYMBOL_RawOperandNonNull = 355,        /* RawOperandNonNull  */
  YYSYMBOL_RawOperandOffsetSuffix = 356,   /* RawOperandOffsetSuffix  */
  YYSYMBOL_RawOperandArray = 357,          /* RawOperandArray  */
  YYSYMBOL_DstAddrOperand = 358,           /* DstAddrOperand  */
  YYSYMBOL_DstGeneralOperand = 359,        /* DstGeneralOperand  */
  YYSYMBOL_DstIndirectOperand = 360,       /* DstIndirectOperand  */
  YYSYMBOL_SrcAddrOfOperand = 361,         /* SrcAddrOfOperand  */
  YYSYMBOL_AddrOfVar = 362,                /* AddrOfVar  */
  YYSYMBOL_SrcAddrOperand = 363,           /* SrcAddrOperand  */
  YYSYMBOL_SrcGeneralOperand = 364,        /* SrcGeneralOperand  */
  YYSYMBOL_SrcImmOperand = 365,            /* SrcImmOperand  */
  YYSYMBOL_FloatLit = 366,                 /* FloatLit  */
  YYSYMBOL_DoubleFloatLit = 367,           /* DoubleFloatLit  */
  YYSYMBOL_SrcIndirectOperand = 368,       /* SrcIndirectOperand  */
  YYSYMBOL_DstRegion = 369,                /* DstRegion  */
  YYSYMBOL_SrcRegionDirect = 370,          /* SrcRegionDirect  */
  YYSYMBOL_SrcRegionIndirect = 371,        /* SrcRegionIndirect  */
  YYSYMBOL_IndirectVarAccess = 372,        /* IndirectVarAccess  */
  YYSYMBOL_TwoDimOffset = 373,             /* TwoDimOffset  */
  YYSYMBOL_PredVar = 374,                  /* PredVar  */
  YYSYMBOL_AddrVarAccess = 375,            /* AddrVarAccess  */
  YYSYMBOL_AddrVarAccessWithWidth = 376,   /* AddrVarAccessWithWidth  */
  YYSYMBOL_SIMDMode = 377,                 /* SIMDMode  */
  YYSYMBOL_ElemNum = 378,                  /* ElemNum  */
  YYSYMBOL_ExecSize = 379,                 /* ExecSize  */
  YYSYMBOL_ExecSizeInt = 380,              /* ExecSizeInt  */
  YYSYMBOL_Var = 381,                      /* Var  */
  YYSYMBOL_VarNonNull = 382,               /* VarNonNull  */
  YYSYMBOL_IntExp = 383,                   /* IntExp  */
  YYSYMBOL_IntExpCond = 384,               /* IntExpCond  */
  YYSYMBOL_IntExpAND = 385,                /* IntExpAND  */
  YYSYMBOL_IntExpXOR = 386,                /* IntExpXOR  */
  YYSYMBOL_IntExpOR = 387,                 /* IntExpOR  */
  YYSYMBOL_IntExpCmp = 388,                /* IntExpCmp  */
  YYSYMBOL_IntExpRel = 389,                /* IntExpRel  */
  YYSYMBOL_IntExpNRA = 390,                /* IntExpNRA  */
  YYSYMBOL_IntExpShift = 391,              /* IntExpShift  */
  YYSYMBOL_IntExpAdd = 392,                /* IntExpAdd  */
  YYSYMBOL_IntExpMul = 393,                /* IntExpMul  */
  YYSYMBOL_IntExpUnr = 394,                /* IntExpUnr  */
  YYSYMBOL_IntExpPrim = 395,               /* IntExpPrim  */
  YYSYMBOL_DataType = 396,                 /* DataType  */
  YYSYMBOL_DataTypeIntOrVector = 397       /* DataTypeIntOrVector  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3033

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  197
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  201
/* YYNRULES -- Number of rules.  */
#define YYNRULES  446
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  1125

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   451


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   628,   628,   633,   635,   635,   637,   637,   638,   638,
     641,   642,   643,   644,   645,   646,   647,   648,   649,   650,
     651,   656,   657,   658,   662,   666,   669,   669,   676,   684,
     692,   699,   700,   701,   702,   703,   704,   706,   713,   721,
     729,   736,   740,   740,   743,   751,   756,   768,   775,   783,
     783,   784,   791,   797,   801,   805,   809,   814,   820,   820,
     822,   826,   832,   840,   846,   851,   856,   862,   866,   870,
     876,   881,   887,   891,   901,   902,   903,   904,   905,   906,
     907,   908,   909,   910,   911,   912,   913,   914,   915,   916,
     917,   918,   919,   920,   921,   922,   923,   924,   925,   926,
     927,   928,   929,   930,   931,   932,   933,   934,   935,   936,
     937,   938,   939,   940,   941,   942,   943,   944,   945,   946,
     947,   948,   949,   950,   953,   957,   963,   968,   974,   982,
     988,   995,  1002,  1009,  1016,  1028,  1035,  1044,  1054,  1060,
    1067,  1073,  1082,  1092,  1099,  1106,  1114,  1123,  1130,  1137,
    1143,  1149,  1155,  1173,  1180,  1190,  1198,  1205,  1212,  1221,
    1230,  1239,  1247,  1250,  1253,  1256,  1259,  1264,  1271,  1279,
    1280,  1286,  1295,  1303,  1310,  1313,  1328,  1328,  1330,  1330,
    1332,  1335,  1348,  1351,  1364,  1364,  1367,  1375,  1383,  1386,
    1390,  1395,  1398,  1410,  1410,  1414,  1422,  1434,  1450,  1456,
    1469,  1477,  1484,  1492,  1498,  1504,  1510,  1516,  1523,  1524,
    1533,  1534,  1535,  1537,  1538,  1539,  1541,  1544,  1545,  1546,
    1547,  1549,  1571,  1602,  1631,  1656,  1680,  1707,  1733,  1765,
    1805,  1845,  1876,  1911,  1916,  1916,  1919,  1920,  1921,  1925,
    1934,  1940,  1948,  1970,  1980,  1992,  2002,  2013,  2023,  2034,
    2044,  2045,  2046,  2047,  2053,  2054,  2055,  2062,  2063,  2066,
    2067,  2068,  2069,  2073,  2078,  2079,  2080,  2082,  2082,  2085,
    2090,  2098,  2106,  2120,  2124,  2130,  2135,  2138,  2142,  2145,
    2150,  2153,  2156,  2163,  2167,  2171,  2175,  2181,  2186,  2193,
    2198,  2203,  2209,  2216,  2223,  2229,  2235,  2243,  2251,  2259,
    2269,  2274,  2279,  2284,  2289,  2294,  2299,  2304,  2309,  2309,
    2315,  2320,  2325,  2325,  2327,  2327,  2330,  2330,  2333,  2334,
    2335,  2336,  2338,  2338,  2343,  2344,  2346,  2347,  2351,  2352,
    2355,  2356,  2359,  2360,  2361,  2364,  2365,  2368,  2369,  2370,
    2373,  2374,  2377,  2378,  2380,  2382,  2392,  2399,  2407,  2415,
    2434,  2446,  2453,  2465,  2470,  2477,  2482,  2490,  2498,  2504,
    2509,  2531,  2535,  2541,  2551,  2559,  2566,  2576,  2582,  2589,
    2593,  2598,  2602,  2608,  2609,  2616,  2624,  2625,  2631,  2641,
    2649,  2658,  2676,  2690,  2693,  2704,  2715,  2720,  2725,  2733,
    2742,  2754,  2768,  2770,  2781,  2793,  2799,  2807,  2816,  2816,
    2817,  2817,  2820,  2822,  2823,  2825,  2826,  2828,  2829,  2831,
    2832,  2834,  2835,  2836,  2838,  2839,  2840,  2841,  2842,  2861,
    2864,  2865,  2866,  2867,  2869,  2870,  2871,  2873,  2874,  2879,
    2884,  2886,  2887,  2888,  2889,  2893,  2894,  2896,  2900,  2904,
    2910,  2919,  2920,  2921,  2922,  2924,  2925
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "ALIGN_KEYWORD",
  "ATOMIC_SUB_OP", "DIRECTIVE_DECL", "DIRECTIVE_FUNC",
  "DIRECTIVE_FUNCDECL", "DIRECTIVE_GLOBAL_FUNC", "DIRECTIVE_IMPLICIT",
  "DIRECTIVE_INPUT", "DIRECTIVE_KERNEL", "DIRECTIVE_KERNEL_ATTR",
  "DIRECTIVE_PARAMETER", "DIRECTIVE_VERSION", "ALIAS_EQ", "ALIGN_EQ",
  "ATTR_EQ", "OFFSET_EQ", "NUM_ELTS_EQ", "V_NAME_EQ", "SIZE_EQ",
  "V_TYPE_EQ_G", "V_TYPE_EQ_P", "V_TYPE_EQ_A", "V_TYPE_EQ_S",
  "V_TYPE_EQ_T", "CPS", "NON_UNIFORM_SAMPLER", "PIXEL_NULL_MASK",
  "RAW_SEND_STRING", "RAW_SENDC_STRING", "RAW_SENDS_STRING",
  "RAW_SENDS_EOT_STRING", "RAW_SENDSC_STRING", "RAW_SENDSC_EOT_STRING",
  "SAT", "SRCMOD_ABS", "SRCMOD_NEG", "SRCMOD_NEGABS", "SRCMOD_NOT",
  "BFN_OP", "DPAS_OP", "SVM_ALIGNED", "SVM_UNALIGNED", "NBARRIER_SIGNAL",
  "NBARRIER_WAIT", "ITYPE", "DECL_DATA_TYPE", "DFTYPE", "FTYPE", "HFTYPE",
  "VTYPE", "COND_MOD", "LANGLE", "RANGLE", "LBRACK", "RBRACK",
  "IND_LBRACK", "LPAREN", "RPAREN", "LBRACE", "RBRACE", "DOT", "COMMA",
  "SEMI", "COLON", "SLASH", "PERCENT", "EQUALS", "PLUS", "MINUS", "TIMES",
  "AMP", "CIRC", "PIPE", "TILDE", "BANG", "QUESTION", "LEQ", "GEQ", "EQ",
  "NEQ", "SHL", "SHRS", "SHRZ", "LABEL", "IDENT", "BUILTIN_NULL",
  "BUILTIN", "STRING_LIT", "NEWLINE", "RTWRITE_OPTION", "MEDIA_MODE",
  "OWORD_MODIFIER", "SAMPLER_CHANNEL", "CHANNEL_OUTPUT", "EXECMODE",
  "CNTRL", "FENCE_OPTIONS", "ADDR_ADD_OP", "UNARY_LOGIC_OP",
  "BINARY_LOGIC_OP", "TERNARY_LOGIC_OP", "QUATERNARY_LOGIC_OP", "SEL_OP",
  "MIN_OP", "MAX_OP", "ANTI_TRIG_OP", "MATH2_OP", "MATH3_OP", "ARITH2_OP",
  "ARITH3_OP", "ARITH4_OP", "ARITH4_OP2", "CMP_OP", "SVM_OP",
  "SVM_SCATTER_OP", "SVM_GATHER4SCALED_OP", "SVM_SCATTER4SCALED_OP",
  "SVM_ATOMIC_OP", "OWORD_OP", "MEDIA_OP", "SCATTER_OP",
  "SCATTER_TYPED_OP", "SCATTER_SCALED_OP", "SCATTER4_SCALED_OP",
  "BARRIER_OP", "SBARRIER_SIGNAL", "SBARRIER_WAIT", "DWORD_ATOMIC_OP",
  "TYPED_ATOMIC_OP", "SAMPLE_OP", "SAMPLE_UNORM_OP", "VME_IME_OP",
  "VME_SIC_OP", "VME_FBR_OP", "BRANCH_OP", "RET_OP", "IFCALL", "FCALL",
  "FADDR", "SWITCHJMP_OP", "MOVS_OP", "SETP_OP", "MOV_OP", "FILE_OP",
  "LOC_OP", "CACHE_FLUSH_OP", "WAIT_OP", "FENCE_GLOBAL_OP",
  "FENCE_LOCAL_OP", "FENCE_SW_OP", "YIELD_OP", "SAMPLE_3D_OP",
  "LOAD_3D_OP", "SAMPLE4_3D_OP", "RESINFO_OP_3D", "SAMPLEINFO_OP_3D",
  "RTWRITE_OP_3D", "URBWRITE_OP_3D", "LIFETIME_START_OP",
  "LIFETIME_END_OP", "AVS_OP", "CALL_OP", "PRED_CNTL", "F32_LIT",
  "F64_LIT", "DEC_LIT", "HEX_LIT", "BUILTIN_SIZEOF",
  "BUILTIN_DISPATCH_SIMD_SIZE", "QW_SCATTER_OP", "LSC_CACHING_OPT",
  "LSC_ADDR_SIZE_TK", "LSC_DATA_SHAPE_TK", "LSC_DATA_SHAPE_TK_CHMASK",
  "LSC_DATA_SHAPE_TK_BLOCK2D", "LSC_AM_FLAT", "LSC_AM_BTI", "LSC_AM_BSS",
  "LSC_AM_SS", "LSC_AM_ARG", "LSC_FENCE_OP_TYPE", "LSC_FENCE_SCOPE",
  "LSC_SFID_UNTYPED_TOKEN", "LSC_SFID_TYPED_TOKEN", "LSC_LOAD_MNEMONIC",
  "LSC_LOAD_STRIDED_MNEMONIC", "LSC_LOAD_BLOCK2D_MNEMONIC",
  "LSC_STORE_MNEMONIC", "LSC_STORE_STRIDED_MNEMONIC",
  "LSC_STORE_BLOCK2D_MNEMONIC", "LSC_ATOMIC_MNEMONIC",
  "LSC_READ_STATE_INFO_MNEMONIC", "LSC_FENCE_MNEMONIC", "FCVT_OP",
  "$accept", "Listing", "ListingHeader", "Statements", "Newlines",
  "NewlinesOpt", "Statement", "Scope", "ScopeStart", "ScopeEnd",
  "IdentOrStringLit", "DirectiveKernel", "DirectiveGlobalFunction",
  "DirectiveVersion", "DirectiveDecl", "DeclFunction", "DeclVariable",
  "DeclAddress", "DeclPredicate", "DeclSampler", "VNameEqOpt",
  "DeclSurface", "DirectiveInput", "DirectiveImplicitInput", "InputOffset",
  "InputSize", "DirectiveParameter", "DirectiveAttr", "DirectiveFunc",
  "AlignAttrOpt", "Align", "AliasAttrOpt", "OneAttr", "AttrOpt",
  "GenAttrOpt", "Instruction", "Label", "LogicInstruction",
  "UnaryLogicInstruction", "MathInstruction_2OPND",
  "MathInstruction_3OPND", "ArithInstruction_2OPND",
  "ArithInstruction_3OPND", "ArithInstruction_4OPND", "DpasInstruction",
  "BfnInstruction", "QwScatterInstruction", "FCvtInstruction",
  "AntiTrigInstruction", "AddrAddInstruction", "SetpInstruction",
  "SelInstruction", "MinInstruction", "MaxInstruction", "MovInstruction",
  "MovsInstruction", "CmpInstruction", "MediaInstruction",
  "MediaInstructionPlaneID", "ScatterInstruction",
  "ScatterTypedInstruction", "Scatter4ScaledInstruction",
  "ScatterScaledInstruction", "SynchronizationInstruction",
  "DwordAtomicInstruction", "TypedAtomicInstruction", "Atomic16Opt",
  "SampleUnormInstruction", "SampleInstruction", "Sample3dInstruction",
  "Sample3DInstruction", "CPSEnableOpt", "NonUniformSamplerEnableOpt",
  "Load3dInstruction", "Load3DInstruction", "Gather43dInstruction",
  "Gather43DInstruction", "PixelNullMaskEnableOpt", "ResInfo3dInstruction",
  "SampleInfo3dInstruction", "RTWriteOperands", "RTWriteInstruction",
  "RTWInstruction", "RTWriteModeOpt", "URBWriteInstruction",
  "AVSInstruction", "VMEInstruction", "OwordInstruction", "SvmInstruction",
  "AtomicBitwidthOpt", "LscInstruction", "LscUntypedLoad",
  "LscUntypedStridedLoad", "LscUntypedBlock2dLoad", "LscUntypedStore",
  "LscUntypedStridedStore", "LscUntypedBlock2dStore", "LscUntypedAtomic",
  "LscTypedLoad", "LscTypedStore", "LscTypedAtomic",
  "LscTypedReadStateInfo", "LscFence", "LscSfid", "LscCacheOpts",
  "LscUntypedAddrOperand", "LscUntypedStridedAddrOperand",
  "LscUntypedBlock2dAddrOperand", "LscTypedOneAddrOperand",
  "LscTypedTwoAddrOperand", "LscTypedThreeAddrOperand",
  "LscTypedFourAddrOperand", "LscTypedAddrOperand", "LscAddrImmOffsetOpt",
  "LscAddrImmScaleOpt", "LscAddrModelOpt", "LscRegAddrModel",
  "LscRegAddrModelKind", "LscVectorOpRegOrImm", "LscVectorOpImm",
  "LscVectorOpReg", "LscDataOperand", "LscDataOperand2D", "LscPayloadReg",
  "LscPayloadNonNullReg", "SwitchLabels", "BranchInstruction", "FILE",
  "LOC", "RawSendInstruction", "LifetimeStartInst", "LifetimeEndInst",
  "RawSendsInstruction", "NullaryInstruction", "OwordModifier",
  "Predicate", "PredSign", "PredCtrlOpt", "SatModOpt", "SrcModifier",
  "ConditionalModifier", "VecDstOperand_A", "VecDstOperand_G",
  "VecDstOperand_G_I", "VecSrcOperand_G_I_IMM_A_AO",
  "VecSrcOperand_G_I_IMM_A", "VecSrcOperand_G_I_IMM",
  "VecSrcOperand_G_IMM", "VecSrcOperand_G_IMM_AO", "VecSrcOperand_G_A",
  "VecSrcOperand_G_A_AO", "VecSrcOperand_G", "VecSrcOpndSimple",
  "VMEOpndIME", "VMEOpndFBR", "SrcStateOperand", "DstStateOperand",
  "RawOperand", "RawOperandNonNull", "RawOperandOffsetSuffix",
  "RawOperandArray", "DstAddrOperand", "DstGeneralOperand",
  "DstIndirectOperand", "SrcAddrOfOperand", "AddrOfVar", "SrcAddrOperand",
  "SrcGeneralOperand", "SrcImmOperand", "FloatLit", "DoubleFloatLit",
  "SrcIndirectOperand", "DstRegion", "SrcRegionDirect",
  "SrcRegionIndirect", "IndirectVarAccess", "TwoDimOffset", "PredVar",
  "AddrVarAccess", "AddrVarAccessWithWidth", "SIMDMode", "ElemNum",
  "ExecSize", "ExecSizeInt", "Var", "VarNonNull", "IntExp", "IntExpCond",
  "IntExpAND", "IntExpXOR", "IntExpOR", "IntExpCmp", "IntExpRel",
  "IntExpNRA", "IntExpShift", "IntExpAdd", "IntExpMul", "IntExpUnr",
  "IntExpPrim", "DataType", "DataTypeIntOrVector", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-1000)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-436)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
     -72, -1000,    38,   -41,    55, -1000, -1000,   -71,   -72, -1000,
      47,  2766,   -29,    46,    21,    69,    21,    85,   114,    21,
     136,   147,   110,   241,   241,   183, -1000, -1000,   110,   196,
     -10,   203,   209,   251, -1000, -1000, -1000,   221,   265,   322,
     299,   331,    21,   110,   110,   110,   255,   231, -1000,  1305,
     295,   303, -1000, -1000,   309,   311,   347,   349,   362,    90,
     434,   -72, -1000, -1000,  2426, -1000, -1000, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000, -1000,  2839, -1000,   407,
   -1000, -1000, -1000, -1000, -1000,   464,   464, -1000,   435,   482,
     -31,   351, -1000, -1000, -1000, -1000,   299,   382,   165,   382,
     382, -1000, -1000, -1000, -1000, -1000,   238,   399,   -24, -1000,
       4,   241, -1000, -1000, -1000, -1000, -1000, -1000,   451,   449,
   -1000,    31, -1000, -1000, -1000,   299,   299, -1000,   110,   110,
     110,   241, -1000,   110,   449,   341,   110,   452,   414,   344,
     299,   351,   241,   299,     4,   241,   299,   299, -1000, -1000,
     299, -1000, -1000, -1000, -1000, -1000,   110,   110, -1000, -1000,
     299, -1000, -1000,   348, -1000,   110,  1205, -1000, -1000,  2596,
     110,   110,   251,   251,   251,   251,   434,   434,   434,   434,
     434,   434,   434,   434,   434,   434,   434,   434,   434,   434,
     110,   450,   437,   440,   526,   442,   475,   445,   537,   540,
     110,   110,   110,   110,   434,   516,   516,   516,   455,   110,
     110,   491,   141,   370,   374,   155,   375,   380,   171,   383,
     519,   551,   552,   555,   556,   382,   227,   482,   193,   382,
     559, -1000,   520,   515,   518,   351, -1000,   522,   -18,   523,
     382, -1000, -1000,   527, -1000,     8,   509,   511, -1000,   284,
       5, -1000,    19,   199, -1000,   364, -1000, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000,   502, -1000,   451,   449,
   -1000,   382, -1000,   256,   382,   536, -1000, -1000, -1000,   426,
   -1000,   330, -1000, -1000,   534,     4,   241,   241,   351,   299,
     299, -1000,   203,   427,   299,   299,   532,   351,   351,   533,
     351, -1000, -1000, -1000,   544,   129,   541,   299,   241, -1000,
     172,   241,   299,   299,   299,   415,   299, -1000, -1000,   -72,
   -1000,   432,   436,   251,   251,   251,   251,   110,   110,   110,
     110,   110,   110,   110,   110,   110,   110,   110,   110,   110,
     110,     4,   438,   110,   110,   546,   110,   439,   110,   547,
     547,    21, -1000,   241,   517,   110, -1000,   584,   521,   525,
   -1000,   110,   444,    21,   453,   454,   454,   454,   454,   454,
     454,   454,   454,   454,   454,   367,   594,   382,   382,   382,
     382, -1000,   557,   559, -1000, -1000, -1000, -1000, -1000, -1000,
   -1000,   456,   458,   351,   -36, -1000, -1000,   382,   382, -1000,
     382,   382,   382,   382,   382,   382,   382,   382,   382,   382,
     382,   382,   382,   382,   382,   382,   382,   382,   562,   256,
     536,   356,   178, -1000, -1000, -1000, -1000, -1000,   553,   382,
   -1000, -1000,   563,   299, -1000,   943, -1000, -1000,   572, -1000,
   -1000,   573,   382,   241,   241,   129,   351,   351, -1000,   241,
    1111,   299,   571,   367,   299,   465,   351,   351,   241,   351,
     382,   256, -1000,   544,   -35, -1000,   575, -1000, -1000,   576,
     382, -1000,   351,   351,   241, -1000,  1305,   589,   484,   485,
     251,   251,   251,   251,     4,     4,     4,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     4,     4,     4,   591,
     241,   241,   487,   110,   299,   110,   299,   488,   110,   110,
   -1000,   490,   492,     4, -1000,   633,   110,   110,   299,   494,
   -1000,   110,   493,   110,   110,   110,   110,   110,   110,   110,
     110,   110,   110,   518,   285, -1000, -1000,   522,   382,   559,
     559,   643,   643,   577, -1000,   607, -1000,   299,   382, -1000,
     611,   610,   509,    14,   511, -1000, -1000, -1000, -1000, -1000,
   -1000, -1000,   199,   199,   381,   381,   381, -1000, -1000, -1000,
   -1000, -1000, -1000,   503,   382,   382,   382,   608, -1000, -1000,
   -1000, -1000, -1000, -1000,   382,   382,   612,   241,   241, -1000,
   -1000,   351,    49,   241,   241,   241, -1000,   351,   351,   241,
     614,   351, -1000,   613,   351,   620, -1000, -1000,   -35,   -35,
     616,   382,   382,   201,   351, -1000,   241, -1000, -1000,   512,
     524,   251,   251,   110,   110,   241,   241,   299,   241,   299,
     241,   241,   241,   241,   241,   241,   241,   241,   241,   241,
     241,   241,   535,   351,   351, -1000,   351,   351,   299,   241,
   -1000,   299,   299,   538,   542,    36,    36,   181, -1000,   588,
     241,   241, -1000,   351,   299, -1000,   367,   367,   367,   367,
     264,   285,   264,   501,   367,   367, -1000, -1000, -1000, -1000,
     625,   671, -1000, -1000,   601,   559,   559,   621, -1000,    57,
   -1000, -1000,   449,   629, -1000, -1000,   382,   636,   631,   640,
     654,   208,   639, -1000, -1000, -1000,   241,   351,   351,   351,
     351,   241, -1000,   351,   241, -1000, -1000, -1000, -1000, -1000,
     652,   222, -1000, -1000,   241,  1305,  1305,   110,   110,  1305,
    1305,   241, -1000, -1000,   241,   299,   241,   241,   241,   241,
     241, -1000, -1000,   241, -1000,   241,   241,   241,   110,   351,
     351,   351,   351,   241,   351,   351,   351, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000,   573,   110,   299,   299,
    1371,   351,   351,   264,   286,   285,   264,   501,   539, -1000,
   -1000,   367,   658, -1000, -1000, -1000, -1000, -1000,   367,   659,
   -1000,   367,   661,   662,   367,   264,   285,    59,    29,   704,
   -1000, -1000, -1000, -1000,   214, -1000,   577, -1000, -1000, -1000,
   -1000,   382, -1000, -1000,   382,   351, -1000,   351,   351,   351,
     241,   351,   660, -1000,   241,   351,   351,  1305,  1305,  1305,
    1305,   241, -1000, -1000,   241,   241, -1000, -1000, -1000, -1000,
   -1000,   241, -1000,   351, -1000, -1000,   351,   351,   351,   351,
     351,   351,   241,   351,   299, -1000, -1000,   351,   351, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000, -1000,   382, -1000,   304,
   -1000,   382,   299, -1000,   367,   367,   663, -1000, -1000,   250,
   -1000, -1000, -1000, -1000, -1000,   667,   559, -1000, -1000, -1000,
     669,   670, -1000, -1000, -1000,   351,   241,   351, -1000,   241,
     351,   351,  1305,  1305,   351,   351, -1000, -1000,   241, -1000,
     351,   351,   351,   351, -1000,   351,   351,   299, -1000,   351,
     351, -1000,   304,   226,    70, -1000,   522,   304,   664,   367,
     367, -1000,   382,   554,    65, -1000, -1000, -1000, -1000,   351,
   -1000,   241, -1000, -1000,   351,   351,   351,   351, -1000, -1000,
   -1000,   351, -1000,   351,   351,   299,   351, -1000, -1000,   409,
     382,   558,   385,   409,    59, -1000, -1000,   665, -1000, -1000,
     672, -1000,   241,   351,   351,   351,   351, -1000, -1000,   351,
     351, -1000,   351,   382,    -6,   674, -1000,   673,    93,   121,
     677,   382,   382,   628,   351,   351, -1000, -1000,   351, -1000,
     381, -1000,   560,   645,   561,   389,    59,    59,   678,   688,
     241, -1000, -1000,   351,   351, -1000,   692, -1000,   693,   125,
     701,   695, -1000, -1000,   675, -1000,   676,   679,   586,   398,
     587,    59,   241,   705,   709, -1000,   711,   712, -1000,   706,
     351,   597,   599,   602,   603,    59, -1000, -1000, -1000, -1000,
   -1000,   714,    59,   722, -1000
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       8,     7,     0,     9,     0,     1,     6,     0,     8,     3,
       0,   310,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   312,    24,   124,     0,   322,
       0,   308,     0,     0,   162,   163,   164,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   300,     0,
     303,   305,   307,   302,     0,     0,     0,     0,     0,     0,
     316,     8,     5,    20,     0,    11,    12,    10,    36,    31,
      32,    33,    34,    35,    14,    13,    15,    17,    16,    18,
      19,    74,    76,    77,    78,    79,    80,    81,   119,   120,
     121,   123,    82,    83,   104,   101,   102,   103,   100,    99,
      84,    85,    87,    88,    90,    89,    91,    93,    94,    96,
      95,   109,   174,   110,   180,   111,   182,   112,   113,   114,
     191,   115,    98,    97,    86,    75,   122,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,    92,
     105,   106,   107,   116,   117,   108,   118,     0,    30,     0,
      26,    27,    57,    37,    29,    49,    49,    28,    55,     0,
       0,     0,   319,   318,   320,   321,     0,     0,     0,     0,
       0,   400,   399,   401,   373,   376,   435,   436,     0,   440,
       0,     0,   332,   344,   334,   369,   371,   333,     0,     0,
     398,     0,   434,   166,   313,     0,     0,   323,     0,     0,
       0,     0,   309,     0,     0,     0,     0,   392,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   290,   291,
       0,   301,   335,   336,   304,   306,     0,     0,   294,   295,
       0,   234,   235,     0,   317,     0,   310,     2,    23,   310,
       0,     0,     0,     0,     0,     0,   316,   316,   316,   316,
     316,   316,   316,   316,   316,   316,   316,   316,   316,   316,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   316,   184,   184,   184,   193,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    72,    46,    56,     0,
      72,   397,     0,     0,     0,     0,   350,     0,     0,     0,
       0,   435,   436,     0,   402,   404,   406,   408,   410,   413,
     418,   419,   423,   426,   430,   436,   370,   372,   431,   432,
     433,   377,   374,   378,   375,   368,     0,   438,     0,     0,
     165,     0,   383,     0,     0,     0,   445,   446,   367,   314,
     389,     0,   324,   357,     0,     0,     0,     0,     0,     0,
       0,   394,   308,     0,     0,     0,     0,     0,     0,     0,
       0,   289,   326,   327,     0,     0,     0,     0,     0,   325,
       0,     0,     0,     0,     0,     0,     0,     4,    25,     8,
      21,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   208,     0,     0,     0,   169,
     169,     0,   285,     0,     0,     0,   185,   176,     0,     0,
     194,     0,     0,     0,     0,   236,   236,   236,   236,   236,
     236,   236,   236,   236,   236,     0,     0,     0,     0,     0,
       0,    50,     0,    72,    48,    45,    53,    54,    51,    52,
     395,     0,     0,     0,     0,   352,   387,     0,     0,   437,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   418,   442,   443,   444,   379,   441,     0,     0,
     365,   315,     0,     0,   342,     0,   340,   343,   361,   341,
     364,     0,     0,     0,     0,   389,     0,     0,   203,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   359,     0,   280,   151,     0,   152,   150,     0,
       0,   143,     0,     0,     0,   233,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     283,     0,     0,     0,   177,   178,     0,     0,     0,     0,
     284,     0,   237,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   399,     0,   276,   277,   398,     0,    72,
      72,    42,    42,     0,    47,     0,   351,     0,     0,   353,
       0,     0,   405,     0,   407,   409,   411,   412,   414,   415,
     416,   417,   424,   425,   420,   421,   422,   428,   429,   427,
     439,   380,   366,     0,     0,   385,     0,     0,   311,   363,
     142,   337,   339,   338,     0,     0,     0,     0,     0,   201,
     202,     0,   157,     0,     0,     0,   393,     0,     0,     0,
       0,     0,   198,     0,     0,     0,   360,   358,   280,   280,
       0,     0,     0,     0,     0,   187,     0,   140,    22,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   209,     0,     0,     0,     0,
     170,     0,     0,     0,     0,     0,     0,     0,   179,     0,
       0,     0,   188,     0,     0,   238,     0,     0,     0,     0,
     259,     0,   259,     0,     0,     0,   266,   264,   265,   232,
       0,    58,    40,    39,     0,    72,    72,    69,    71,     0,
     396,   137,     0,     0,   386,   390,     0,     0,     0,     0,
       0,     0,     0,   154,   153,   200,     0,     0,     0,     0,
       0,     0,   346,     0,     0,   199,   381,   281,   282,   286,
       0,     0,   349,   186,     0,     0,     0,     0,     0,     0,
       0,     0,   129,   130,     0,     0,     0,     0,     0,     0,
       0,   141,   131,     0,   133,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   288,   287,   148,
     328,   330,   329,   331,   147,   149,   389,     0,     0,     0,
     192,     0,     0,   259,     0,     0,   259,     0,     0,   260,
     261,     0,     0,   262,   250,   251,   252,   253,     0,     0,
     241,     0,     0,     0,     0,   259,     0,     0,     0,    64,
      59,    43,    41,    44,     0,    73,     0,   345,   354,   403,
     384,     0,   388,   362,     0,     0,   156,     0,     0,     0,
       0,     0,     0,   348,     0,     0,     0,     0,     0,     0,
       0,     0,   125,   126,     0,     0,   144,   145,   146,   132,
     134,     0,   136,     0,   206,   207,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   189,   190,     0,     0,   222,
     273,   274,   229,   223,   224,   275,   225,   257,   230,     0,
     226,   257,     0,   227,     0,     0,     0,   268,   267,   270,
     269,    63,    60,    61,    62,     0,    72,    68,    67,    70,
       0,     0,   155,   158,   173,     0,     0,     0,   347,     0,
       0,     0,     0,     0,     0,     0,   138,   127,     0,   135,
       0,     0,     0,     0,   160,     0,     0,     0,   355,     0,
       0,   139,     0,     0,     0,   278,   279,     0,     0,     0,
       0,   263,     0,     0,     0,    38,   382,   391,   172,     0,
     197,     0,   292,   293,     0,     0,     0,     0,   128,   204,
     205,     0,   161,     0,     0,     0,   181,   355,   195,   254,
     258,     0,     0,   254,     0,   228,   231,     0,   271,    66,
       0,   171,     0,     0,     0,     0,     0,   159,   167,     0,
       0,   356,   183,     0,     0,     0,   243,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   298,   299,     0,   355,
     255,   256,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   296,   297,     0,   175,   239,     0,   245,     0,     0,
       0,     0,   272,    65,     0,   168,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   247,     0,     0,   240,     0,
       0,     0,     0,     0,     0,     0,   196,   244,   246,   248,
     249,     0,     0,     0,   242
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
   -1000, -1000, -1000,   543,   -50,     0,   545, -1000, -1000,   233,
       2, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
     176, -1000, -1000, -1000,   627,   195, -1000, -1000, -1000, -1000,
   -1000, -1000,   -87, -1000,  -287, -1000, -1000, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000,   373, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000, -1000,   218, -1000, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000,   -64,  -714,   -56,   -53, -1000, -1000,
   -1000, -1000,  -794,  -236,  -141,  -715,  -592, -1000,  -838, -1000,
    -140,  -690,   -63,  -438,  -961,  -182, -1000, -1000, -1000, -1000,
   -1000, -1000, -1000, -1000,   441, -1000, -1000, -1000,   884,    -4,
   -1000,   223,   418,  -346,    81, -1000,    44,  -545, -1000, -1000,
   -1000,    73, -1000, -1000, -1000,   430, -1000,  1292,  -915, -1000,
    -999, -1000,  -199, -1000,  -326, -1000,   459, -1000,    79,   637,
     641, -1000,  -358,  -323,   474,    82,  -194,  -197, -1000,  -191,
   -1000,  -202,  2093,   352,   -40,   862,   -52,    48,   346,   345,
     350,   353,    24,  -335, -1000,  -480,  -466,   617,  -235,  -452,
     632
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     2,     8,    61,     3,     4,    62,    63,    64,   390,
     152,    65,    66,     9,    67,    68,    69,    70,    71,    72,
     755,    73,    74,    75,   296,   300,    76,    77,    78,   869,
     870,   956,   758,   759,   454,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   663,   102,
     103,   104,   105,   106,   107,   108,   578,   109,   110,   111,
     112,   585,   729,   113,   114,   115,   116,   427,   117,   118,
     840,   119,   120,   431,   121,   122,   123,   124,   125,   573,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   233,   593,   860,   861,   864,   854,   855,
     856,   857,   858,  1055,   992,   852,   853,   750,   946,   947,
     948,   843,   847,   844,   994,   680,   139,   140,   141,   142,
     143,   144,   145,   146,   203,   147,   195,   502,   235,   180,
     198,   351,   377,   371,   829,   830,   831,   221,   650,   504,
     505,   182,   761,   210,   213,   535,   378,   605,   306,   465,
    1026,   352,   372,   373,   832,   508,   833,   183,   184,   185,
     186,   187,   532,   342,   343,   188,   345,   349,   308,   510,
     364,   206,   161,   302,   189,   190,   950,   314,   315,   316,
     317,   318,   319,   320,   321,   322,   323,   191,   192,   496,
     497
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     211,   687,   634,   635,   636,   353,   492,   604,    11,   513,
     360,   236,   749,   459,   632,   633,   531,   379,   154,     1,
     381,   157,   500,   618,   995,   507,   851,   862,  1052,   678,
     951,  1029,   952,   199,   200,   336,  1033,   641,     5,   466,
     393,   394,   395,   396,   214,   220,   467,   845,   846,   160,
       6,   932,   679,   167,   865,   866,   171,   172,   173,   476,
     477,   237,   166,   337,   239,   568,  1039,   181,   193,     7,
    1084,  1058,   945,   162,   163,   164,   165,   995,   346,   676,
     766,   470,   995,   347,   478,   479,   471,   470,   167,   480,
     481,   171,   172,   173,   166,   167,  -435,    10,   331,   332,
     310,  -435,   482,   483,   484,   169,   170,   168,   150,   503,
      12,   151,   169,   170,  1089,   313,   953,   995,   167,   875,
     303,   876,   222,   171,   172,   173,   309,  1031,   223,   929,
     310,   862,   619,   149,  1032,   169,   170,   301,  1107,   148,
     339,   628,   629,   630,   631,   490,   171,   172,   173,   859,
    1074,   944,   171,   172,   173,   350,   354,  1075,   514,   153,
     995,   936,   311,   312,   178,   179,   614,   642,   938,   160,
     367,   940,   155,   370,   375,   677,   380,   350,  1072,   652,
     339,   533,  1098,   530,   995,  1076,   533,   379,   344,  1099,
     384,   550,   551,   552,   553,   675,  1060,   311,   312,   178,
     179,   156,   174,   175,   176,   177,   178,   179,   695,   696,
     698,   700,   701,   702,   703,   704,   705,   706,   707,   708,
     709,   710,   711,   158,   167,   340,   530,   311,   312,   178,
     179,   540,   476,   645,   159,   530,   310,   726,  1090,  1091,
     655,   169,   170,   451,   452,   358,   457,   458,   299,   197,
     895,   896,   167,   859,   899,   900,   369,   478,   479,   376,
     194,   792,   338,  1109,   310,   646,   485,   486,   772,   169,
     170,   487,   646,   167,   859,   231,   232,  1121,   162,   163,
     164,   165,   893,   456,  1123,   310,   646,   331,   332,   491,
     169,   170,   498,   485,   486,   925,   374,   202,  1030,   166,
     167,   848,   204,   346,   957,   493,   494,   495,   347,  1002,
     629,   511,   168,  1003,   205,   515,   207,   169,   170,   519,
     520,   533,   752,   753,   523,   524,   435,   436,   171,   172,
     173,   174,   175,   176,   325,   178,   179,   536,   539,   236,
     439,   440,   542,   543,   544,   218,   375,   220,   691,   692,
     693,   694,   972,   973,   974,   975,   443,   444,   697,   699,
     208,   311,   312,   178,   179,   474,   475,   162,   163,   164,
     165,   375,   594,   595,   596,   597,   598,   599,   600,   601,
     602,   209,   311,   312,   178,   179,   171,   172,   173,   547,
     212,   171,   353,   173,   224,   609,   610,   611,   612,   219,
     516,   517,   225,   503,   226,   606,   227,   174,   175,   176,
     177,   178,   179,   333,   334,   620,   621,   171,   172,   173,
     643,   644,   537,   580,   506,   541,   848,  1014,  1015,   290,
     291,   292,   293,   294,   228,   590,   229,   374,   171,   304,
     173,   167,   849,   746,   747,   748,   850,   647,   333,   334,
     335,   480,   481,   310,   171,   603,   173,   230,   169,   170,
     656,   930,   931,   649,   746,   747,   748,   581,   872,   873,
     234,   993,   171,  1057,   173,   993,   171,  1088,   173,  1053,
    1054,   665,   295,   668,   669,   171,  1106,   173,   683,   797,
     798,   453,   455,   374,   428,   429,   787,   788,   626,   627,
     803,   220,   805,   299,   298,   341,   999,  1000,   344,   361,
     365,   363,   366,   412,   375,   515,   515,   375,   375,   375,
     375,   375,   375,   375,   375,   375,   375,   375,   375,   835,
     415,   385,   413,   533,   717,   414,   719,   416,   417,   958,
     418,   419,   220,   727,   420,   426,   960,   430,   732,   961,
     311,   312,   178,   179,   434,   437,   751,   657,   658,   438,
     441,  1035,  1036,   661,   664,   442,   763,   446,   877,   445,
     447,   448,   673,  1070,   449,   450,   452,   762,   651,   461,
     460,   462,   468,   472,   653,   464,   473,   469,   686,   488,
     499,   501,   768,   512,   769,   522,   525,   528,   530,   545,
     534,   548,   770,   771,   582,   549,   569,   575,   903,   572,
     577,   584,   589,   608,   713,   714,   586,   646,   613,   222,
     587,   591,   640,   648,   301,   223,   616,   592,   654,   790,
     791,   666,   655,   670,   681,   682,   374,   374,   374,   374,
     374,   374,   374,   374,   374,   374,   374,   374,   374,   374,
     374,   388,   689,   690,   712,   715,   720,   350,   723,   350,
     724,   728,   733,   754,   757,   374,   735,   760,   764,  1005,
     765,   767,   772,   644,   782,   786,   789,   784,   823,   863,
     795,   825,   826,   837,   867,   511,   836,   868,   871,   878,
     874,   880,   796,   884,   842,   881,   606,   606,   606,   606,
     882,   773,   774,   818,   606,   606,   827,   776,   777,   778,
     828,   883,   893,   781,   937,   939,   935,   941,   942,   955,
     968,  1004,  1038,  1001,  1006,  1007,  1080,  1079,  1034,  1061,
     794,  1072,  1056,  1086,  1085,  1087,  1062,  1073,  1092,   801,
     802,  1077,   804,  1093,   806,   807,   808,   809,   810,   811,
     812,   813,   814,   815,   816,   817,  1096,  1097,  1100,  1101,
    1105,  1108,  1111,   824,  1103,   350,  1112,  1104,  1113,  1114,
    1115,  1117,  1102,  1118,   838,   839,  1119,  1120,  1122,  1124,
     688,   387,   389,   297,   324,   328,   329,   330,   756,   959,
     933,   220,   220,   579,   934,   220,   220,  1059,   923,   924,
     997,   943,   998,   521,   546,   326,   725,   834,   538,   327,
     509,   606,   489,   615,   879,   622,   954,   623,   606,  1071,
     885,   606,   624,   348,   606,   890,   625,   949,   892,     0,
       0,     0,     0,     0,     0,     0,   220,     0,   894,     0,
       0,     0,     0,     0,     0,   901,     0,     0,   902,     0,
     904,   905,   906,   907,   908,     0,     0,   909,     0,   910,
     911,   912,     0,     0,     0,     0,     0,   918,   222,   222,
       0,     0,   222,   222,   223,   223,     0,     0,   223,   223,
       0,     0,     0,     0,   989,     0,     0,     0,     0,     0,
       0,     0,     0,   220,   220,   220,   220,     0,     0,     0,
       0,     0,   949,     0,   606,   606,     0,     0,     0,     0,
       0,     0,   324,   222,     0,   324,   324,     0,     0,   223,
       0,     0,     0,     0,     0,     0,     0,   328,     0,     0,
       0,     0,     0,     0,   966,     0,     0,     0,   969,     0,
       0,     0,     0,     0,     0,   976,     0,  1025,   977,   978,
    1037,     0,     0,     0,     0,   979,     0,     0,   324,   606,
     606,   324,     0,     0,  1040,     0,   987,     0,   220,   220,
     222,   222,   222,   222,     0,     0,   223,   223,   223,   223,
     162,   163,   164,   165,     0,  1050,     0,     0,     0,     0,
       0,     0,     0,     0,   949,     0,     0,     0,     0,     0,
       0,     0,   167,     0,     0,     0,     0,     0,     0,  1078,
    1009,     0,     0,  1011,   168,     0,   503,     0,     0,   169,
     170,     0,  1018,   307,     0,     0,     0,     0,     0,     0,
     171,   172,   173,     0,     0,     0,   949,   949,     0,     0,
       0,     0,     0,     0,     0,   222,   222,     0,     0,     0,
       0,   223,   223,     0,     0,  1042,     0,     0,     0,     0,
       0,   949,     0,     0,   324,   324,   324,   324,     0,     0,
       0,     0,     0,   307,     0,   949,     0,     0,     0,     0,
       0,     0,   949,     0,   324,   324,  1063,   324,   324,   324,
     324,   324,   324,   324,   324,   324,   324,   324,   324,   324,
     324,   324,   637,   638,   639,     0,     0,     0,     0,   174,
     175,   176,   177,   178,   179,     0,   324,     0,     0,     0,
       0,     0,     0,     0,  1094,     0,     0,     0,     0,   324,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,     0,     0,  1110,   324,   162,   163,
     164,   165,     0,     0,     0,     0,     0,   324,   425,     0,
       0,     0,     0,     0,     0,     0,     0,   307,     0,   166,
     167,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   168,     0,     0,     0,     0,   169,   170,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   171,   172,
     173,     0,     0,     0,     0,    -9,     0,     0,     0,     0,
      13,    14,    15,    16,    17,    18,    19,    20,    21,     0,
     307,     0,     0,     0,     0,   324,     0,     0,     0,   307,
     307,     0,   307,     0,     0,   324,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    22,     0,     0,
      23,    24,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   324,   324,   324,    25,     0,    26,    -9,     0,     0,
       0,   324,   324,     0,     0,     0,     0,   174,   175,   662,
     177,   178,   179,     0,     0,     0,     0,     0,     0,     0,
       0,    27,     0,     0,     0,     0,     6,     0,   324,   324,
       0,     0,     0,     0,     0,    28,     0,   607,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      29,    30,     0,     0,     0,   307,    31,    32,    33,     0,
       0,     0,    34,    35,    36,     0,     0,    37,    38,    39,
      40,    41,   162,   163,   164,   165,    42,    43,    44,    45,
       0,    46,    47,    48,    49,    50,    51,    52,    53,     0,
       0,     0,    54,    55,   167,     0,    56,    57,    58,     0,
       0,     0,     0,     0,     0,     0,   168,     0,   307,   307,
       0,   169,   170,   324,     0,   607,     0,     0,   307,   307,
       0,   307,   171,   172,   173,     0,     0,     0,     0,     0,
      59,    60,     0,     0,   307,   307,     0,     0,   162,   163,
     164,   165,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     167,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   168,     0,     0,     0,     0,   169,   170,     0,
       0,     0,     0,   305,     0,     0,     0,     0,   171,   603,
     173,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   174,   175,   176,   177,   178,   179,     0,     0,     0,
       0,     0,     0,     0,   324,   324,     0,     0,     0,     0,
       0,   324,     0,     0,     0,     0,     0,     0,   324,     0,
       0,   324,     0,   368,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   307,     0,     0,     0,     0,     0,   307,
     307,     0,     0,   307,     0,     0,   307,   174,   175,   176,
     177,   178,   179,     0,     0,     0,   307,     0,     0,     0,
       0,     0,     0,     0,   324,     0,     0,     0,   324,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   307,   307,     0,   307,   307,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   307,     0,   463,   607,   607,
     607,   607,     0,     0,     0,     0,   607,   607,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   324,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   307,
     307,   307,   307,     0,     0,   307,     0,   639,     0,     0,
     518,   324,     0,     0,     0,     0,     0,     0,     0,   526,
     527,     0,   529,     0,     0,     0,     0,     0,     0,     0,
     324,     0,     0,     0,     0,     0,     0,     0,   324,   324,
       0,   307,   307,   307,   307,     0,   307,   307,   307,     0,
       0,     0,     0,   324,   324,     0,     0,     0,     0,     0,
       0,     0,   607,   307,   307,     0,     0,     0,     0,     0,
       0,     0,     0,   607,     0,     0,     0,     0,   324,     0,
     607,     0,     0,   607,     0,     0,   607,     0,     0,     0,
       0,     0,   324,     0,     0,     0,     0,     0,     0,   324,
       0,     0,     0,     0,     0,     0,     0,   307,     0,   307,
     307,   307,     0,   307,     0,   617,     0,   307,   307,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   307,     0,     0,   307,   307,
     307,   307,   307,   307,     0,   307,     0,     0,     0,   307,
     307,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   996,     0,     0,     0,     0,   607,   607,   659,   660,
       0,     0,     0,     0,     0,   667,     0,     0,   671,   672,
       0,   674,     0,     0,     0,     0,     0,   307,     0,   307,
       0,     0,   307,   307,   684,   685,   307,   307,     0,     0,
       0,     0,   307,   307,   307,   307,     0,   307,   307,     0,
       0,   307,   307,     0,   996,     0,     0,     0,     0,   996,
       0,   607,   607,     0,     0,     0,     0,     0,     0,     0,
       0,   307,     0,     0,     0,     0,   307,   307,   307,   307,
       0,     0,     0,   307,     0,   307,   307,     0,   307,     0,
       0,     0,     0,     0,   996,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   307,   307,   307,   307,     0,
       0,   307,   307,     0,   307,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   307,   307,     0,     0,
     307,     0,     0,     0,     0,     0,     0,   996,     0,     0,
       0,     0,     0,     0,     0,   307,   307,     0,     0,     0,
       0,     0,     0,   775,     0,     0,     0,     0,     0,   779,
     780,   996,     0,   783,     0,     0,   785,     0,     0,     0,
       0,     0,   307,     0,     0,     0,   793,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   819,   820,     0,   821,   822,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   841,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   886,
     887,   888,   889,     0,     0,   891,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   914,   915,   916,   917,     0,   919,   920,   921,     0,
       0,   196,     0,   201,     0,     0,     0,     0,     0,     0,
       0,     0,   926,   927,   928,     0,   215,   216,   217,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   962,     0,   963,
     964,   965,     0,   967,     0,     0,     0,   970,   971,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   980,     0,     0,   981,   982,
     983,   984,   985,   986,     0,   988,     0,     0,     0,   990,
     991,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,  1008,     0,  1010,
       0,     0,  1012,  1013,     0,     0,  1016,  1017,     0,     0,
       0,     0,  1019,  1020,  1021,  1022,     0,  1023,  1024,     0,
       0,  1027,  1028,     0,     0,     0,     0,     0,     0,     0,
       0,   355,   356,   357,     0,     0,   359,     0,     0,   362,
       0,  1041,     0,     0,     0,     0,  1043,  1044,  1045,  1046,
       0,     0,     0,  1047,     0,  1048,  1049,     0,  1051,   382,
     383,     0,     0,     0,     0,     0,     0,     0,   386,     0,
       0,     0,     0,   391,   392,  1064,  1065,  1066,  1067,     0,
       0,  1068,  1069,     0,  1051,     0,     0,     0,     0,     0,
       0,     0,     0,   411,     0,     0,  1081,  1082,     0,     0,
    1083,     0,     0,   421,   422,   423,   424,     0,     0,     0,
       0,     0,   432,   433,     0,  1095,  1051,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,  1116,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   238,     0,     0,
       0,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    -8,    -8,    -8,    -8,
      -8,    -8,     0,     0,     0,     0,     0,    -8,    -8,     0,
       0,    -8,    -8,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    -8,     0,    -8,    -8,     0,
     554,   555,   556,   557,   558,   559,   560,   561,   562,   563,
     564,   565,   566,   567,     0,     0,   570,   571,     0,   574,
       0,   576,    -8,     0,     0,     0,     0,     1,   583,     0,
       0,     0,     0,     0,   588,     0,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,     0,     0,     0,     0,     0,     0,     0,    -8,     0,
       0,    13,    14,    15,    16,    17,    18,    19,    20,    21,
       0,     0,     0,    -8,    -8,    -8,    -8,    -8,    -8,    -8,
      -8,    -8,    -8,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,    23,    24,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    25,     0,    26,   388,     0,
       0,     0,     0,     0,     0,     0,   716,     0,   718,     0,
       0,   721,   722,     0,     0,     0,     0,     0,     0,   730,
     731,     0,    27,     0,   734,     0,   736,   737,   738,   739,
     740,   741,   742,   743,   744,   745,    28,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    29,    30,     0,     0,     0,     0,    31,    32,    33,
       0,     0,     0,    34,    35,    36,     0,     0,    37,    38,
      39,    40,    41,     0,     0,     0,     0,    42,    43,    44,
      45,     0,    46,    47,    48,    49,    50,    51,    52,    53,
       0,     0,     0,    54,    55,     0,     0,    56,    57,    58,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    13,    14,    15,    16,    17,    18,    19,    20,    21,
       0,     0,     0,     0,     0,     0,   799,   800,     0,     0,
       0,    59,    60,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    22,     0,
       0,    23,    24,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    25,     0,    26,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    27,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    28,     0,     0,   240,
     241,   242,   243,   244,   245,     0,     0,     0,     0,     0,
     246,    29,    30,     0,     0,     0,     0,    31,    32,    33,
     897,   898,     0,    34,    35,    36,     0,     0,    37,    38,
      39,    40,    41,     0,     0,     0,     0,    42,    43,    44,
      45,   913,    46,    47,    48,    49,    50,    51,    52,    53,
       0,     0,     0,    54,    55,     0,     0,    56,    57,    58,
     922,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     247,   248,   249,   250,   251,   252,   253,   254,   255,   256,
     257,   258,   259,   260,     0,     0,   261,   262,   263,   264,
       0,    59,    60,   265,   266,   267,     0,     0,     0,   268,
     269,     0,     0,     0,     0,     0,   270,   271,   272,   273,
       0,     0,     0,     0,   274,     0,     0,     0,     0,     0,
       0,     0,     0,   275,   276,   277,     0,     0,   278,   279,
       0,     0,     0,   280,     0,     0,     0,     0,     0,     0,
       0,   281,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   282,   283,   284,   285,
     286,   287,   288,   289
};

static const yytype_int16 yycheck[] =
{
      40,   546,   482,   483,   484,   196,   341,   445,     8,   355,
     204,    61,   604,   300,   480,   481,   374,   216,    16,    91,
     217,    19,   345,    59,   939,   351,   740,   742,  1027,    64,
       1,   992,     3,    43,    44,    59,   997,   489,     0,    57,
     242,   243,   244,   245,    42,    49,    64,   737,   738,    59,
      91,   845,    87,    59,   744,   745,    87,    88,    89,    54,
      55,    61,    58,    87,    64,   411,     1,    23,    24,    14,
    1069,  1032,   866,    37,    38,    39,    40,   992,    47,   531,
      66,    73,   997,    52,    79,    80,    78,    73,    59,    70,
      71,    87,    88,    89,    58,    59,    47,   168,    49,    50,
      71,    52,    83,    84,    85,    76,    77,    71,    87,    73,
      63,    90,    76,    77,  1075,   167,    87,  1032,    59,    62,
     160,    64,    49,    87,    88,    89,   166,    57,    49,   843,
      71,   846,   168,    87,    64,    76,    77,   168,  1099,   168,
     180,   476,   477,   478,   479,   339,    87,    88,    89,   741,
      57,   865,    87,    88,    89,   195,   196,    64,   355,    90,
    1075,   851,   168,   169,   170,   171,   453,   490,   858,    59,
     210,   861,    87,   213,   214,   533,   216,   217,    57,   505,
     220,   375,    57,    54,  1099,    64,   380,   386,    59,    64,
     230,   393,   394,   395,   396,   530,  1034,   168,   169,   170,
     171,    87,   166,   167,   168,   169,   170,   171,   554,   555,
     556,   557,   558,   559,   560,   561,   562,   563,   564,   565,
     566,   567,   568,    87,    59,   181,    54,   168,   169,   170,
     171,    59,    54,    55,    87,    54,    71,   583,  1076,  1077,
      59,    76,    77,   295,    17,   201,   298,   299,    21,    53,
     795,   796,    59,   845,   799,   800,   212,    79,    80,   215,
      77,    60,   180,  1101,    71,    64,    67,    68,    60,    76,
      77,    72,    64,    59,   866,   185,   186,  1115,    37,    38,
      39,    40,    60,    90,  1122,    71,    64,    49,    50,   341,
      76,    77,   344,    67,    68,   840,   214,    94,    72,    58,
      59,   739,    93,    47,    90,    49,    50,    51,    52,    59,
     645,   351,    71,    63,    63,   355,    95,    76,    77,   359,
     360,   515,   609,   610,   364,   365,   185,   186,    87,    88,
      89,   166,   167,   168,   169,   170,   171,   377,   378,   389,
     185,   186,   382,   383,   384,    90,   386,   351,   550,   551,
     552,   553,   897,   898,   899,   900,   185,   186,   555,   556,
      95,   168,   169,   170,   171,    81,    82,    37,    38,    39,
      40,   411,   436,   437,   438,   439,   440,   441,   442,   443,
     444,    59,   168,   169,   170,   171,    87,    88,    89,   389,
      59,    87,   583,    89,    99,   447,   448,   449,   450,   168,
     356,   357,    99,    73,    95,   445,    95,   166,   167,   168,
     169,   170,   171,    49,    50,   467,   468,    87,    88,    89,
      64,    65,   378,   421,   351,   381,   864,   972,   973,    22,
      23,    24,    25,    26,    87,   433,    87,   355,    87,    88,
      89,    59,   178,   179,   180,   181,   182,   499,    49,    50,
      51,    70,    71,    71,    87,    88,    89,    95,    76,    77,
     512,   175,   176,   503,   179,   180,   181,   423,   755,   756,
      36,   937,    87,    88,    89,   941,    87,    88,    89,    70,
      71,   521,    18,   523,   524,    87,    88,    89,   540,   691,
     692,   296,   297,   411,   276,   277,   678,   679,   474,   475,
     697,   505,   699,    21,    69,    54,   944,   945,    59,   168,
      96,    59,   168,    63,   554,   555,   556,   557,   558,   559,
     560,   561,   562,   563,   564,   565,   566,   567,   568,   726,
       4,   183,    95,   727,   574,    95,   576,    95,    63,   874,
      95,     4,   546,   583,     4,    29,   881,    92,   588,   884,
     168,   169,   170,   171,    63,   185,   608,   513,   514,   185,
     185,   999,  1000,   519,   520,   185,   618,    48,   762,   186,
      19,    19,   528,  1053,    19,    19,    17,   617,   505,    64,
      60,    63,    59,    74,   505,    63,    75,    60,   544,    87,
      54,   165,   644,    59,   646,   168,    64,    64,    54,   184,
      59,   169,   654,   655,    87,   169,   168,   168,   805,    63,
      63,    27,   168,    19,   570,   571,    95,    64,    61,   546,
      95,   168,    60,    60,   168,   546,   168,   173,    56,   681,
     682,    60,    59,   168,    59,    59,   554,   555,   556,   557,
     558,   559,   560,   561,   562,   563,   564,   565,   566,   567,
     568,    62,   168,   168,    63,   168,   168,   697,   168,   699,
     168,    28,   168,    20,    87,   583,   173,    60,    57,   956,
      60,   168,    60,    65,    60,    55,    60,    64,   718,   178,
     168,   721,   722,    95,    59,   725,   726,    16,    87,    60,
      69,    55,   168,    54,   734,    64,   736,   737,   738,   739,
      60,   657,   658,   168,   744,   745,   168,   663,   664,   665,
     168,    57,    60,   669,    56,    56,   177,    56,    56,    15,
      60,    54,   168,    60,    55,    55,    98,  1062,    64,    64,
     686,    57,   174,    88,   174,   174,    64,    64,    60,   695,
     696,    64,   698,    55,   700,   701,   702,   703,   704,   705,
     706,   707,   708,   709,   710,   711,    64,    64,    57,    64,
     174,   174,    57,   719,    88,   805,    57,    88,    57,    57,
      64,   174,    97,   174,   730,   731,   174,   174,    64,    57,
     547,   236,   239,   156,   167,   168,   169,   170,   612,   876,
     846,   795,   796,   420,   847,   799,   800,  1033,   838,   839,
     941,   864,   942,   362,   386,   168,   583,   726,   378,   168,
     351,   851,   338,   461,   766,   470,   868,   471,   858,  1054,
     776,   861,   472,   191,   864,   781,   473,   867,   784,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   840,    -1,   794,    -1,
      -1,    -1,    -1,    -1,    -1,   801,    -1,    -1,   804,    -1,
     806,   807,   808,   809,   810,    -1,    -1,   813,    -1,   815,
     816,   817,    -1,    -1,    -1,    -1,    -1,   823,   795,   796,
      -1,    -1,   799,   800,   795,   796,    -1,    -1,   799,   800,
      -1,    -1,    -1,    -1,   924,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   897,   898,   899,   900,    -1,    -1,    -1,
      -1,    -1,   942,    -1,   944,   945,    -1,    -1,    -1,    -1,
      -1,    -1,   295,   840,    -1,   298,   299,    -1,    -1,   840,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   310,    -1,    -1,
      -1,    -1,    -1,    -1,   890,    -1,    -1,    -1,   894,    -1,
      -1,    -1,    -1,    -1,    -1,   901,    -1,   987,   904,   905,
    1002,    -1,    -1,    -1,    -1,   911,    -1,    -1,   341,   999,
    1000,   344,    -1,    -1,  1004,    -1,   922,    -1,   972,   973,
     897,   898,   899,   900,    -1,    -1,   897,   898,   899,   900,
      37,    38,    39,    40,    -1,  1025,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1034,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    59,    -1,    -1,    -1,    -1,    -1,    -1,  1061,
     966,    -1,    -1,   969,    71,    -1,    73,    -1,    -1,    76,
      77,    -1,   978,   161,    -1,    -1,    -1,    -1,    -1,    -1,
      87,    88,    89,    -1,    -1,    -1,  1076,  1077,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   972,   973,    -1,    -1,    -1,
      -1,   972,   973,    -1,    -1,  1011,    -1,    -1,    -1,    -1,
      -1,  1101,    -1,    -1,   447,   448,   449,   450,    -1,    -1,
      -1,    -1,    -1,   211,    -1,  1115,    -1,    -1,    -1,    -1,
      -1,    -1,  1122,    -1,   467,   468,  1042,   470,   471,   472,
     473,   474,   475,   476,   477,   478,   479,   480,   481,   482,
     483,   484,   485,   486,   487,    -1,    -1,    -1,    -1,   166,
     167,   168,   169,   170,   171,    -1,   499,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,  1080,    -1,    -1,    -1,    -1,   512,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,    -1,    -1,  1102,   530,    37,    38,
      39,    40,    -1,    -1,    -1,    -1,    -1,   540,   274,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   305,    -1,    58,
      59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    71,    -1,    -1,    -1,    -1,    76,    77,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    87,    88,
      89,    -1,    -1,    -1,    -1,     0,    -1,    -1,    -1,    -1,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    -1,
     358,    -1,    -1,    -1,    -1,   608,    -1,    -1,    -1,   367,
     368,    -1,   370,    -1,    -1,   618,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,    -1,
      45,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   644,   645,   646,    59,    -1,    61,    62,    -1,    -1,
      -1,   654,   655,    -1,    -1,    -1,    -1,   166,   167,   168,
     169,   170,   171,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    86,    -1,    -1,    -1,    -1,    91,    -1,   681,   682,
      -1,    -1,    -1,    -1,    -1,   100,    -1,   445,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     115,   116,    -1,    -1,    -1,   463,   121,   122,   123,    -1,
      -1,    -1,   127,   128,   129,    -1,    -1,   132,   133,   134,
     135,   136,    37,    38,    39,    40,   141,   142,   143,   144,
      -1,   146,   147,   148,   149,   150,   151,   152,   153,    -1,
      -1,    -1,   157,   158,    59,    -1,   161,   162,   163,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    71,    -1,   516,   517,
      -1,    76,    77,   766,    -1,   523,    -1,    -1,   526,   527,
      -1,   529,    87,    88,    89,    -1,    -1,    -1,    -1,    -1,
     195,   196,    -1,    -1,   542,   543,    -1,    -1,    37,    38,
      39,    40,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      59,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    71,    -1,    -1,    -1,    -1,    76,    77,    -1,
      -1,    -1,    -1,   161,    -1,    -1,    -1,    -1,    87,    88,
      89,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   166,   167,   168,   169,   170,   171,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   867,   868,    -1,    -1,    -1,    -1,
      -1,   874,    -1,    -1,    -1,    -1,    -1,    -1,   881,    -1,
      -1,   884,    -1,   211,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   661,    -1,    -1,    -1,    -1,    -1,   667,
     668,    -1,    -1,   671,    -1,    -1,   674,   166,   167,   168,
     169,   170,   171,    -1,    -1,    -1,   684,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   937,    -1,    -1,    -1,   941,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   713,   714,    -1,   716,   717,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   733,    -1,   305,   736,   737,
     738,   739,    -1,    -1,    -1,    -1,   744,   745,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1002,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,
     778,   779,   780,    -1,    -1,   783,    -1,  1030,    -1,    -1,
     358,  1034,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   367,
     368,    -1,   370,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    1053,    -1,    -1,    -1,    -1,    -1,    -1,    -1,  1061,  1062,
      -1,   819,   820,   821,   822,    -1,   824,   825,   826,    -1,
      -1,    -1,    -1,  1076,  1077,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   840,   841,   842,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   851,    -1,    -1,    -1,    -1,  1101,    -1,
     858,    -1,    -1,   861,    -1,    -1,   864,    -1,    -1,    -1,
      -1,    -1,  1115,    -1,    -1,    -1,    -1,    -1,    -1,  1122,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   885,    -1,   887,
     888,   889,    -1,   891,    -1,   463,    -1,   895,   896,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   913,    -1,    -1,   916,   917,
     918,   919,   920,   921,    -1,   923,    -1,    -1,    -1,   927,
     928,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   939,    -1,    -1,    -1,    -1,   944,   945,   516,   517,
      -1,    -1,    -1,    -1,    -1,   523,    -1,    -1,   526,   527,
      -1,   529,    -1,    -1,    -1,    -1,    -1,   965,    -1,   967,
      -1,    -1,   970,   971,   542,   543,   974,   975,    -1,    -1,
      -1,    -1,   980,   981,   982,   983,    -1,   985,   986,    -1,
      -1,   989,   990,    -1,   992,    -1,    -1,    -1,    -1,   997,
      -1,   999,  1000,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,  1009,    -1,    -1,    -1,    -1,  1014,  1015,  1016,  1017,
      -1,    -1,    -1,  1021,    -1,  1023,  1024,    -1,  1026,    -1,
      -1,    -1,    -1,    -1,  1032,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1043,  1044,  1045,  1046,    -1,
      -1,  1049,  1050,    -1,  1052,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,  1064,  1065,    -1,    -1,
    1068,    -1,    -1,    -1,    -1,    -1,    -1,  1075,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,  1083,  1084,    -1,    -1,    -1,
      -1,    -1,    -1,   661,    -1,    -1,    -1,    -1,    -1,   667,
     668,  1099,    -1,   671,    -1,    -1,   674,    -1,    -1,    -1,
      -1,    -1,  1110,    -1,    -1,    -1,   684,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   713,   714,    -1,   716,   717,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   733,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   777,
     778,   779,   780,    -1,    -1,   783,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   819,   820,   821,   822,    -1,   824,   825,   826,    -1,
      -1,    28,    -1,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   840,   841,   842,    -1,    43,    44,    45,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   885,    -1,   887,
     888,   889,    -1,   891,    -1,    -1,    -1,   895,   896,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   913,    -1,    -1,   916,   917,
     918,   919,   920,   921,    -1,   923,    -1,    -1,    -1,   927,
     928,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   965,    -1,   967,
      -1,    -1,   970,   971,    -1,    -1,   974,   975,    -1,    -1,
      -1,    -1,   980,   981,   982,   983,    -1,   985,   986,    -1,
      -1,   989,   990,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   198,   199,   200,    -1,    -1,   203,    -1,    -1,   206,
      -1,  1009,    -1,    -1,    -1,    -1,  1014,  1015,  1016,  1017,
      -1,    -1,    -1,  1021,    -1,  1023,  1024,    -1,  1026,   226,
     227,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   235,    -1,
      -1,    -1,    -1,   240,   241,  1043,  1044,  1045,  1046,    -1,
      -1,  1049,  1050,    -1,  1052,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   260,    -1,    -1,  1064,  1065,    -1,    -1,
    1068,    -1,    -1,   270,   271,   272,   273,    -1,    -1,    -1,
      -1,    -1,   279,   280,    -1,  1083,  1084,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,  1110,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,     1,    -1,    -1,
      -1,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    30,    31,    32,    33,
      34,    35,    -1,    -1,    -1,    -1,    -1,    41,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    59,    -1,    61,    62,    -1,
     397,   398,   399,   400,   401,   402,   403,   404,   405,   406,
     407,   408,   409,   410,    -1,    -1,   413,   414,    -1,   416,
      -1,   418,    86,    -1,    -1,    -1,    -1,    91,   425,    -1,
      -1,    -1,    -1,    -1,   431,    -1,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   172,    -1,
      -1,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    -1,    -1,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    59,    -1,    61,    62,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   573,    -1,   575,    -1,
      -1,   578,   579,    -1,    -1,    -1,    -1,    -1,    -1,   586,
     587,    -1,    86,    -1,   591,    -1,   593,   594,   595,   596,
     597,   598,   599,   600,   601,   602,   100,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   115,   116,    -1,    -1,    -1,    -1,   121,   122,   123,
      -1,    -1,    -1,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,    -1,    -1,    -1,   141,   142,   143,
     144,    -1,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,    -1,    -1,   157,   158,    -1,    -1,   161,   162,   163,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      -1,    -1,    -1,    -1,    -1,    -1,   693,   694,    -1,    -1,
      -1,   195,   196,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    42,    -1,
      -1,    45,    46,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    59,    -1,    61,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    86,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   100,    -1,    -1,    30,
      31,    32,    33,    34,    35,    -1,    -1,    -1,    -1,    -1,
      41,   115,   116,    -1,    -1,    -1,    -1,   121,   122,   123,
     797,   798,    -1,   127,   128,   129,    -1,    -1,   132,   133,
     134,   135,   136,    -1,    -1,    -1,    -1,   141,   142,   143,
     144,   818,   146,   147,   148,   149,   150,   151,   152,   153,
      -1,    -1,    -1,   157,   158,    -1,    -1,   161,   162,   163,
     837,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,    -1,    -1,   117,   118,   119,   120,
      -1,   195,   196,   124,   125,   126,    -1,    -1,    -1,   130,
     131,    -1,    -1,    -1,    -1,    -1,   137,   138,   139,   140,
      -1,    -1,    -1,    -1,   145,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   154,   155,   156,    -1,    -1,   159,   160,
      -1,    -1,    -1,   164,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   172,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   187,   188,   189,   190,
     191,   192,   193,   194
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    91,   198,   201,   202,     0,    91,    14,   199,   210,
     168,   202,    63,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    42,    45,    46,    59,    61,    86,   100,   115,
     116,   121,   122,   123,   127,   128,   129,   132,   133,   134,
     135,   136,   141,   142,   143,   144,   146,   147,   148,   149,
     150,   151,   152,   153,   157,   158,   161,   162,   163,   195,
     196,   200,   203,   204,   205,   208,   209,   211,   212,   213,
     214,   215,   216,   218,   219,   220,   223,   224,   225,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   256,   257,   258,   259,   260,   261,   262,   264,
     265,   266,   267,   270,   271,   272,   273,   275,   276,   278,
     279,   281,   282,   283,   284,   285,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   323,
     324,   325,   326,   327,   328,   329,   330,   332,   168,    87,
      87,    90,   207,    90,   207,    87,    87,   207,    87,    87,
      59,   379,    37,    38,    39,    40,    58,    59,    71,    76,
      77,    87,    88,    89,   166,   167,   168,   169,   170,   171,
     336,   343,   348,   364,   365,   366,   367,   368,   372,   381,
     382,   394,   395,   343,    77,   333,   379,    53,   337,    43,
      44,   379,    94,   331,    93,    63,   378,    95,    95,    59,
     350,   381,    59,   351,   207,   379,   379,   379,    90,   168,
     336,   344,   348,   365,    99,    99,    95,    95,    87,    87,
      95,   185,   186,   300,    36,   335,   201,   202,     1,   202,
      30,    31,    32,    33,    34,    35,    41,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   117,   118,   119,   120,   124,   125,   126,   130,   131,
     137,   138,   139,   140,   145,   154,   155,   156,   159,   160,
     164,   172,   187,   188,   189,   190,   191,   192,   193,   194,
      22,    23,    24,    25,    26,    18,   221,   221,    69,    21,
     222,   168,   380,   381,    88,   354,   355,   382,   375,   381,
      71,   168,   169,   383,   384,   385,   386,   387,   388,   389,
     390,   391,   392,   393,   394,   169,   366,   367,   394,   394,
     394,    49,    50,    49,    50,    51,    59,    87,   372,   381,
     343,    54,   370,   371,    59,   373,    47,    52,   397,   374,
     381,   338,   358,   376,   381,   379,   379,   379,   343,   379,
     373,   168,   379,    59,   377,    96,   168,   381,   354,   343,
     381,   340,   359,   360,   372,   381,   343,   339,   353,   359,
     381,   374,   379,   379,   381,   183,   379,   203,    62,   200,
     206,   379,   379,   378,   378,   378,   378,   335,   335,   335,
     335,   335,   335,   335,   335,   335,   335,   335,   335,   335,
     335,   379,    63,    95,    95,     4,    95,    63,    95,     4,
       4,   379,   379,   379,   379,   335,    29,   274,   274,   274,
      92,   280,   379,   379,    63,   185,   186,   185,   185,   185,
     186,   185,   185,   185,   186,   186,    48,    19,    19,    19,
      19,   383,    17,   222,   231,   222,    90,   383,   383,   231,
      60,    64,    63,   354,    63,   356,    57,    64,    59,    60,
      73,    78,    74,    75,    81,    82,    54,    55,    79,    80,
      70,    71,    83,    84,    85,    67,    68,    72,    87,   371,
     373,   383,   390,    49,    50,    51,   396,   397,   383,    54,
     370,   165,   334,    73,   346,   347,   348,   361,   362,   363,
     376,   381,    59,   340,   374,   381,   343,   343,   354,   381,
     381,   331,   168,   381,   381,    64,   354,   354,    64,   354,
      54,   369,   369,   373,    59,   352,   381,   343,   352,   381,
      59,   343,   381,   381,   381,   184,   339,   202,   169,   169,
     378,   378,   378,   378,   379,   379,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   379,   379,   340,   168,
     379,   379,    63,   286,   379,   168,   379,    63,   263,   263,
     207,   343,    87,   379,    27,   268,    95,    95,   379,   168,
     207,   168,   173,   301,   301,   301,   301,   301,   301,   301,
     301,   301,   301,    88,   320,   354,   381,   382,    19,   383,
     383,   383,   383,    61,   231,   380,   168,   354,    59,   168,
     383,   383,   386,   385,   387,   388,   389,   389,   390,   390,
     390,   390,   393,   393,   392,   392,   392,   394,   394,   394,
      60,   396,   370,    64,    65,    55,    64,   383,    60,   381,
     345,   348,   361,   365,    56,    59,   383,   343,   343,   354,
     354,   343,   168,   255,   343,   381,    60,   354,   381,   381,
     168,   354,   354,   343,   354,   390,   396,   369,    64,    87,
     322,    59,    59,   383,   354,   354,   343,   344,   206,   168,
     168,   378,   378,   378,   378,   340,   340,   374,   340,   374,
     340,   340,   340,   340,   340,   340,   340,   340,   340,   340,
     340,   340,    63,   343,   343,   168,   379,   381,   379,   381,
     168,   379,   379,   168,   168,   338,   340,   381,    28,   269,
     379,   379,   381,   168,   379,   173,   379,   379,   379,   379,
     379,   379,   379,   379,   379,   379,   179,   180,   181,   313,
     314,   383,   231,   231,    20,   217,   217,    87,   229,   230,
      60,   349,   381,   383,    57,    60,    66,   168,   383,   383,
     383,   383,    60,   343,   343,   354,   343,   343,   343,   354,
     354,   343,    60,   354,    64,   354,    55,   322,   322,    60,
     383,   383,    60,   354,   343,   168,   168,   378,   378,   379,
     379,   343,   343,   374,   343,   374,   343,   343,   343,   343,
     343,   343,   343,   343,   343,   343,   343,   343,   168,   354,
     354,   354,   354,   381,   343,   381,   381,   168,   168,   341,
     342,   343,   361,   363,   341,   374,   381,    95,   343,   343,
     277,   354,   381,   318,   320,   318,   318,   319,   320,   178,
     182,   302,   312,   313,   305,   306,   307,   308,   309,   313,
     302,   303,   312,   178,   304,   318,   318,    59,    16,   226,
     227,    87,   231,   231,    69,    62,    64,   373,    60,   384,
      55,    64,    60,    57,    54,   343,   354,   354,   354,   354,
     343,   354,   343,    60,   343,   344,   344,   379,   379,   344,
     344,   343,   343,   374,   343,   343,   343,   343,   343,   343,
     343,   343,   343,   379,   354,   354,   354,   354,   343,   354,
     354,   354,   379,   381,   381,   344,   354,   354,   354,   302,
     175,   176,   309,   303,   304,   177,   318,    56,   318,    56,
     318,    56,    56,   319,   302,   309,   315,   316,   317,   381,
     383,     1,     3,    87,   383,    15,   228,    90,   390,   229,
     390,   390,   354,   354,   354,   354,   343,   354,    60,   343,
     354,   354,   344,   344,   344,   344,   343,   343,   343,   343,
     354,   354,   354,   354,   354,   354,   354,   343,   354,   381,
     354,   354,   311,   393,   321,   355,   382,   311,   317,   320,
     320,    60,    59,    63,    54,   231,    55,    55,   354,   343,
     354,   343,   354,   354,   344,   344,   354,   354,   343,   354,
     354,   354,   354,   354,   354,   381,   357,   354,   354,   321,
      72,    57,    64,   321,    64,   320,   320,   383,   168,     1,
     381,   354,   343,   354,   354,   354,   354,   354,   354,   354,
     381,   354,   357,    70,    71,   310,   174,    88,   321,   310,
     315,    64,    64,   343,   354,   354,   354,   354,   354,   354,
     392,   395,    57,    64,    57,    64,    64,    64,   383,   390,
      98,   354,   354,   354,   357,   174,    88,   174,    88,   321,
     315,   315,    60,    55,   343,   354,    64,    64,    57,    64,
      57,    64,    97,    88,    88,   174,    88,   321,   174,   315,
     343,    57,    57,    57,    57,    64,   354,   174,   174,   174,
     174,   315,    64,   315,    57
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int16 yyr1[] =
{
       0,   197,   198,   199,   200,   200,   201,   201,   202,   202,
     203,   203,   203,   203,   203,   203,   203,   203,   203,   203,
     203,   204,   204,   204,   205,   206,   207,   207,   208,   209,
     210,   211,   211,   211,   211,   211,   211,   212,   213,   214,
     215,   216,   217,   217,   218,   219,   219,   220,   220,   221,
     221,   222,   223,   224,   224,   224,   224,   225,   226,   226,
     227,   227,   227,   227,   228,   228,   228,   229,   229,   229,
     230,   230,   231,   231,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   232,   232,   232,   232,   232,   232,
     232,   232,   232,   232,   233,   234,   234,   234,   234,   235,
     235,   236,   237,   238,   239,   240,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   251,   251,
     252,   252,   252,   253,   253,   254,   254,   255,   256,   257,
     258,   259,   260,   260,   260,   260,   260,   261,   262,   263,
     263,   264,   265,   265,   266,   267,   268,   268,   269,   269,
     270,   271,   272,   273,   274,   274,   275,   276,   277,   277,
     277,   278,   279,   280,   280,   281,   282,   283,   283,   283,
     284,   285,   285,   285,   285,   285,   285,   285,   286,   286,
     287,   287,   287,   287,   287,   287,   287,   287,   287,   287,
     287,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   300,   301,   301,   301,   302,
     303,   303,   304,   305,   305,   306,   306,   307,   307,   308,
     309,   309,   309,   309,   310,   310,   310,   311,   311,   312,
     312,   312,   312,   313,   314,   314,   314,   315,   315,   316,
     317,   317,   317,   318,   318,   319,   320,   320,   321,   321,
     322,   322,   322,   323,   323,   323,   323,   323,   323,   323,
     324,   325,   326,   326,   327,   328,   329,   329,   329,   329,
     330,   330,   330,   330,   330,   330,   330,   330,   331,   331,
     332,   332,   333,   333,   334,   334,   335,   335,   336,   336,
     336,   336,   337,   337,   338,   339,   340,   340,   341,   341,
     342,   342,   343,   343,   343,   344,   344,   345,   345,   345,
     346,   346,   347,   347,   348,   349,   350,   351,   352,   353,
     354,   354,   355,   356,   356,   357,   357,   358,   359,   359,
     360,   361,   361,   362,   363,   364,   364,   365,   365,   365,
     365,   365,   365,   366,   366,   366,   367,   367,   367,   368,
     368,   369,   370,   371,   371,   371,   372,   372,   373,   374,
     375,   376,   377,   377,   378,   379,   379,   380,   381,   381,
     382,   382,   383,   384,   384,   385,   385,   386,   386,   387,
     387,   388,   388,   388,   389,   389,   389,   389,   389,   390,
     391,   391,   391,   391,   392,   392,   392,   393,   393,   393,
     393,   394,   394,   394,   394,   395,   395,   395,   395,   395,
     395,   396,   396,   396,   396,   397,   397
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     5,     1,     3,     1,     2,     1,     0,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     5,     2,     1,     1,     1,     1,     2,     2,
       4,     1,     1,     1,     1,     1,     1,     2,     9,     6,
       6,     7,     0,     2,     7,     4,     3,     5,     4,     0,
       2,     2,     4,     4,     4,     2,     3,     2,     0,     1,
       2,     2,     2,     2,     0,     6,     3,     3,     3,     1,
       3,     1,     0,     4,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     7,     7,     8,     9,     6,
       6,     6,     7,     6,     7,     8,     7,     6,     8,     8,
       5,     6,     5,     4,     7,     7,     7,     6,     6,     6,
       4,     4,     4,     6,     6,     8,     7,     1,     8,    10,
       8,     9,     1,     1,     1,     3,     2,    10,    13,     0,
       2,    10,     9,     8,     1,    12,     0,     1,     0,     1,
       1,     9,     1,    10,     0,     1,     6,     5,     0,     2,
       2,     1,     6,     0,     1,     9,    16,     9,     5,     6,
       6,     5,     5,     4,     9,     9,     7,     7,     0,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     7,     7,     7,     7,     7,     7,     9,     7,
       7,     9,     5,     4,     1,     1,     0,     1,     2,     7,
       9,     1,    14,     5,    11,     7,    11,     9,    11,    11,
       1,     1,     1,     1,     0,     2,     2,     0,     2,     0,
       1,     1,     1,     4,     1,     1,     1,     1,     1,     1,
       1,     3,     6,     2,     2,     2,     1,     1,     1,     1,
       0,     2,     2,     4,     4,     3,     6,     6,     6,     3,
       2,     2,     9,     9,     2,     2,    12,    12,    11,    11,
       1,     2,     1,     1,     2,     1,     2,     1,     0,     1,
       0,     5,     0,     1,     0,     1,     0,     1,     1,     1,
       1,     1,     0,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     5,     7,     4,     4,
       1,     3,     2,     2,     4,     0,     2,     1,     3,     2,
       3,     1,     4,     2,     1,     3,     4,     2,     2,     1,
       2,     1,     2,     1,     2,     2,     1,     2,     2,     3,
       4,     3,     7,     1,     5,     3,     5,     3,     5,     1,
       4,     7,     0,     3,     2,     3,     5,     1,     1,     1,
       1,     1,     1,     5,     1,     3,     1,     3,     1,     3,
       1,     3,     3,     1,     3,     3,     3,     3,     1,     1,
       3,     3,     3,     1,     3,     3,     1,     3,     3,     3,
       1,     2,     2,     2,     1,     1,     1,     3,     2,     4,
       1,     1,     1,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (pBuilder, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, pBuilder); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (pBuilder);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, CISA_IR_Builder* pBuilder)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, pBuilder);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, CISA_IR_Builder* pBuilder)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], pBuilder);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, pBuilder); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, CISA_IR_Builder* pBuilder)
{
  YY_USE (yyvaluep);
  YY_USE (pBuilder);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (CISA_IR_Builder* pBuilder)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (pBuilder);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* Listing: NewlinesOpt ListingHeader NewlinesOpt Statements NewlinesOpt  */
#line 628 "CISA.y"
                                                                      {
        TRACE("** Listing Complete\n");
        pBuilder->CISA_post_file_parse();
    }
#line 3031 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 23: /* Scope: ScopeStart error  */
#line 658 "CISA.y"
                       {
        PARSE_ERROR_AT((int)(yyvsp[-1].intval), "unclosed scope");
    }
#line 3039 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 24: /* ScopeStart: LBRACE  */
#line 662 "CISA.y"
           {
        pBuilder->CISA_push_decl_scope();
        (yyval.intval) = CISAlineno;
    }
#line 3048 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 25: /* ScopeEnd: RBRACE  */
#line 666 "CISA.y"
                 {pBuilder->CISA_pop_decl_scope();}
#line 3054 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 28: /* DirectiveKernel: DIRECTIVE_KERNEL IdentOrStringLit  */
#line 677 "CISA.y"
    {
        VISAKernel *cisa_kernel = NULL;
        pBuilder->AddKernel(cisa_kernel, (yyvsp[0].string));
    }
#line 3063 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 29: /* DirectiveGlobalFunction: DIRECTIVE_GLOBAL_FUNC IdentOrStringLit  */
#line 685 "CISA.y"
  {
      VISAFunction *cisa_kernel = NULL;
      pBuilder->AddFunction(cisa_kernel, (yyvsp[0].string));
  }
#line 3072 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 30: /* DirectiveVersion: DIRECTIVE_VERSION DEC_LIT DOT DEC_LIT  */
#line 693 "CISA.y"
   {
       pBuilder->CISA_IR_setVersion((unsigned char)(yyvsp[-2].intval), (unsigned char)(yyvsp[0].intval));
   }
#line 3080 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 37: /* DeclFunction: DIRECTIVE_FUNCDECL STRING_LIT  */
#line 707 "CISA.y"
    {
        // do nothing as it's informational only
    }
#line 3088 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 38: /* DeclVariable: DIRECTIVE_DECL IDENT V_TYPE_EQ_G DECL_DATA_TYPE NUM_ELTS_EQ IntExp AlignAttrOpt AliasAttrOpt GenAttrOpt  */
#line 714 "CISA.y"
    {
       ABORT_ON_FAIL(pBuilder->CISA_general_variable_decl(
           (yyvsp[-7].string), (unsigned int)(yyvsp[-3].intval), (yyvsp[-5].type), (yyvsp[-2].align), (yyvsp[-1].alias).aliasname, (yyvsp[-1].alias).offset, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
    }
#line 3098 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 39: /* DeclAddress: DIRECTIVE_DECL IDENT V_TYPE_EQ_A NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 722 "CISA.y"
   {
       ABORT_ON_FAIL(
           pBuilder->CISA_addr_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), ISA_TYPE_UW, AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3108 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 40: /* DeclPredicate: DIRECTIVE_DECL IDENT V_TYPE_EQ_P NUM_ELTS_EQ IntExp GenAttrOpt  */
#line 730 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_predicate_variable_decl((yyvsp[-4].string), (unsigned int)(yyvsp[-1].intval), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3117 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 41: /* DeclSampler: DIRECTIVE_DECL IDENT V_TYPE_EQ_S NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 737 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_sampler_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), CISAlineno));
   }
#line 3125 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 42: /* VNameEqOpt: %empty  */
#line 740 "CISA.y"
                    {(yyval.string) = "";}
#line 3131 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 43: /* VNameEqOpt: V_NAME_EQ IDENT  */
#line 740 "CISA.y"
                                                 {(yyval.string) = (yyvsp[0].string);}
#line 3137 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 44: /* DeclSurface: DIRECTIVE_DECL IDENT V_TYPE_EQ_T NUM_ELTS_EQ IntExp VNameEqOpt GenAttrOpt  */
#line 744 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_surface_variable_decl((yyvsp[-5].string), (int)(yyvsp[-2].intval), (yyvsp[-1].string), AttrOptVar, CISAlineno));
       AttrOptVar.clear();
   }
#line 3146 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 45: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset InputSize  */
#line 752 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 3154 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 46: /* DirectiveInput: DIRECTIVE_INPUT IDENT InputOffset  */
#line 757 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-1].string), (short)(yyvsp[0].intval), (unsigned short)size, CISAlineno));
    }
#line 3165 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 47: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset InputSize GenAttrOpt  */
#line 769 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_implicit_input_directive(
            (yyvsp[-4].string), (yyvsp[-3].string), (short)(yyvsp[-2].intval), (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 3174 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 48: /* DirectiveImplicitInput: DIRECTIVE_IMPLICIT IDENT InputOffset GenAttrOpt  */
#line 776 "CISA.y"
    {
        int64_t size = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-2].string), size));
        MUST_HOLD(size < 0x10000, "declaration size is too large");
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), (short)(yyvsp[-1].intval), (unsigned short)size, CISAlineno));
    }
#line 3185 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 49: /* InputOffset: %empty  */
#line 783 "CISA.y"
                    {(yyval.intval) = 0;}
#line 3191 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 50: /* InputOffset: OFFSET_EQ IntExp  */
#line 783 "CISA.y"
                                                 {(yyval.intval) = (yyvsp[0].intval);}
#line 3197 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 51: /* InputSize: SIZE_EQ IntExp  */
#line 784 "CISA.y"
                          {(yyval.intval) = (yyvsp[0].intval);}
#line 3203 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 52: /* DirectiveParameter: DIRECTIVE_PARAMETER IDENT InputSize GenAttrOpt  */
#line 791 "CISA.y"
                                                   {
        ABORT_ON_FAIL(pBuilder->CISA_input_directive((yyvsp[-2].string), 0, (unsigned short)(yyvsp[-1].intval), CISAlineno));
    }
#line 3211 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 53: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS STRING_LIT  */
#line 797 "CISA.y"
                                                  {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-2].string), (yyvsp[0].string), CISAlineno));
    }
#line 3219 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 54: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS IntExp  */
#line 801 "CISA.y"
                                              {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directiveNum((yyvsp[-2].string), (uint32_t)(yyvsp[0].intval), CISAlineno));
    }
#line 3227 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 55: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT  */
#line 805 "CISA.y"
                                {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[0].string), nullptr, CISAlineno));
    }
#line 3235 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 56: /* DirectiveAttr: DIRECTIVE_KERNEL_ATTR IDENT EQUALS  */
#line 809 "CISA.y"
                                       {
        ABORT_ON_FAIL(pBuilder->CISA_attr_directive((yyvsp[-1].string), nullptr, CISAlineno));
    }
#line 3243 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 57: /* DirectiveFunc: DIRECTIVE_FUNC IdentOrStringLit  */
#line 815 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_function_directive((yyvsp[0].string), CISAlineno));
    }
#line 3251 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 58: /* AlignAttrOpt: %empty  */
#line 820 "CISA.y"
                     {(yyval.align) = ALIGN_BYTE;}
#line 3257 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 60: /* Align: ALIGN_EQ ALIGN_KEYWORD  */
#line 822 "CISA.y"
                           { // 2GRF, 32word, ...
        (yyval.align) = (yyvsp[0].align);
    }
#line 3265 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 61: /* Align: ALIGN_EQ IDENT  */
#line 826 "CISA.y"
                   { // e.g. byte, word, dword, qword, GRF, GRFx2
       if (!ParseAlign(pBuilder, (yyvsp[0].string), (yyval.align))) {
           PARSE_ERROR((yyvsp[0].string), ": invalid align value");
       }
    }
#line 3275 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 62: /* Align: ALIGN_EQ IntExp  */
#line 832 "CISA.y"
                    {
        // e.g. %sizeof(GRF) or %sizeof(DECL)
        (yyval.align) = AlignBytesToVisaAlignment((int)(yyvsp[0].intval));
        if ((yyval.align) == ALIGN_UNDEF) {
            PARSE_ERROR("invalid align size (must be 1, 2, 4, 8, ..., 128)");
        }
    }
#line 3287 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 63: /* Align: ALIGN_EQ error  */
#line 840 "CISA.y"
                   {
        PARSE_ERROR("syntax error in align attribute");
    }
#line 3295 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 64: /* AliasAttrOpt: %empty  */
#line 847 "CISA.y"
    {
       (yyval.alias).aliasname = NULL;
       (yyval.alias).offset = 0;
    }
#line 3304 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 65: /* AliasAttrOpt: ALIAS_EQ LANGLE Var COMMA IntExpNRA RANGLE  */
#line 852 "CISA.y"
    {
       (yyval.alias).aliasname = (yyvsp[-3].string);
       (yyval.alias).offset = (int)(yyvsp[-1].intval);
    }
#line 3313 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 66: /* AliasAttrOpt: ALIAS_EQ LANGLE error  */
#line 857 "CISA.y"
    {
       PARSE_ERROR("syntax error in alias attribute");
    }
#line 3321 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 67: /* OneAttr: IDENT EQUALS IntExpNRA  */
#line 863 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), (yyvsp[0].intval), nullptr);
    }
#line 3329 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 68: /* OneAttr: IDENT EQUALS STRING_LIT  */
#line 867 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[-2].string), 0, (yyvsp[0].string));
    }
#line 3337 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 69: /* OneAttr: IDENT  */
#line 871 "CISA.y"
    {
      (yyval.pattr_gen) = pBuilder->CISA_Create_Attr((yyvsp[0].string), 0, nullptr);
    }
#line 3345 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 70: /* AttrOpt: AttrOpt COMMA OneAttr  */
#line 877 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3353 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 71: /* AttrOpt: OneAttr  */
#line 882 "CISA.y"
    {
      AttrOptVar.push_back((yyvsp[0].pattr_gen));
    }
#line 3361 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 72: /* GenAttrOpt: %empty  */
#line 888 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 3369 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 73: /* GenAttrOpt: ATTR_EQ LBRACE AttrOpt RBRACE  */
#line 892 "CISA.y"
    {
        (yyval.intval) = 1;
    }
#line 3377 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 124: /* Label: LABEL  */
#line 953 "CISA.y"
             {pBuilder->CISA_create_label((yyvsp[0].string), CISAlineno);}
#line 3383 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 125: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 958 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3392 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 126: /* LogicInstruction: Predicate BINARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar PredVar  */
#line 964 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].vISADecl), (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), CISAlineno);
    }
#line 3400 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 127: /* LogicInstruction: Predicate TERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 969 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3409 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 128: /* LogicInstruction: Predicate QUATERNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 975 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-8].pred_reg), (yyvsp[-7].opcode), (yyvsp[-6].sat), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3418 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 129: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 983 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, NULL, CISAlineno);
    }
#line 3427 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 130: /* UnaryLogicInstruction: Predicate UNARY_LOGIC_OP SatModOpt ExecSize PredVar PredVar  */
#line 989 "CISA.y"
    {
        pBuilder->CISA_create_logic_instruction((yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].vISADecl), (yyvsp[0].vISADecl), NULL, CISAlineno);
    }
#line 3436 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 131: /* MathInstruction_2OPND: Predicate MATH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 996 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3445 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 132: /* MathInstruction_3OPND: Predicate MATH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1003 "CISA.y"
    {
        pBuilder->CISA_create_math_instruction((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3454 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 133: /* ArithInstruction_2OPND: Predicate ARITH2_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1010 "CISA.y"
    {
        pBuilder->CISA_create_arith_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, NULL, CISAlineno);
    }
#line 3463 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 134: /* ArithInstruction_3OPND: Predicate ARITH3_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1017 "CISA.y"
    {
        MUST_HOLD(!(((yyvsp[-5].opcode) == ISA_LINE) && ((yyvsp[-1].genOperand).type == OPERAND_IMMEDIATE || (yyvsp[-1].genOperand).type == OPERAND_INDIRECT)),
            "wrong type of src0 operand");
        pBuilder->CISA_create_arith_instruction(
            (yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3475 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 135: /* ArithInstruction_4OPND: Predicate ARITH4_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1029 "CISA.y"
     {
         pBuilder->CISA_create_arith_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].opcode), (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3484 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 136: /* ArithInstruction_4OPND: Predicate ARITH4_OP2 ExecSize VecDstOperand_G_I VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1036 "CISA.y"
     {
        pBuilder->CISA_create_arith_instruction2((yyvsp[-6].pred_reg), (yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
     }
#line 3493 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 137: /* DpasInstruction: DPAS_OP ExecSize RawOperand RawOperand RawOperand VecSrcOpndSimple  */
#line 1045 "CISA.y"
    {
        pBuilder->CISA_create_dpas_instruction(
            (yyvsp[-5].dpas_info).opcode, (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].genOperand).cisa_gen_opnd,
            (yyvsp[-5].dpas_info).src2Precision, (yyvsp[-5].dpas_info).src1Precision, (yyvsp[-5].dpas_info).depth, (yyvsp[-5].dpas_info).count, CISAlineno);
    }
#line 3504 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 138: /* BfnInstruction: Predicate BFN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1055 "CISA.y"
    {
        pBuilder->CISA_create_bfn_instruction((yyvsp[-7].pred_reg), (yyvsp[-6].bfn_info).func_ctrl , (yyvsp[-5].sat), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size,
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3513 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 139: /* QwScatterInstruction: Predicate QW_SCATTER_OP DOT DEC_LIT ExecSize Var RawOperand RawOperand  */
#line 1061 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_qword_scatter_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (uint32_t)(yyvsp[-4].intval), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3522 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 140: /* FCvtInstruction: FCVT_OP SatModOpt ExecSize VecDstOperand_G VecSrcOperand_G_IMM  */
#line 1068 "CISA.y"
    {
        pBuilder->CISA_create_fcvt_instruction((yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3530 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 141: /* AntiTrigInstruction: Predicate ANTI_TRIG_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM  */
#line 1074 "CISA.y"
    {
        pBuilder->CISA_create_invtri_inst((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].sat), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3539 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 142: /* AddrAddInstruction: ADDR_ADD_OP ExecSize VecDstOperand_A VecSrcOperand_G_A_AO VecSrcOperand_G_IMM_AO  */
#line 1083 "CISA.y"
    {
        // a grammatically problematic instruction
        //   addr_add (M1_NM, 1) A0(0)<1> &V127 - 0x10...
        //                                        ^^^^ next operand or V127 offset
        pBuilder->CISA_create_address_instruction((yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3551 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 143: /* SetpInstruction: SETP_OP ExecSize PredVar VecSrcOperand_G_I_IMM  */
#line 1093 "CISA.y"
    {
        pBuilder->CISA_create_setp_instruction(
            (yyvsp[-3].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].vISADecl), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3560 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 144: /* SelInstruction: Predicate SEL_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1100 "CISA.y"
    {
        pBuilder->CISA_create_sel_instruction((yyvsp[-5].opcode), (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3569 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 145: /* MinInstruction: Predicate MIN_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1107 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(0, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3578 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 146: /* MaxInstruction: Predicate MAX_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1115 "CISA.y"
    {
        pBuilder->CISA_create_fminmax_instruction(
            1, ISA_FMINMAX, (yyvsp[-4].sat), (yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3588 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 147: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM_A_AO  */
#line 1124 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno));
    }
#line 3598 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 148: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_A VecSrcOperand_G_I_IMM_A_AO  */
#line 1131 "CISA.y"
    {
        pBuilder->CISA_create_mov_instruction(
            (yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-3].sat),
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3608 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 149: /* MovInstruction: Predicate MOV_OP SatModOpt ExecSize VecDstOperand_G_I PredVar  */
#line 1138 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_mov_instruction((yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].vISADecl), CISAlineno));
    }
#line 3616 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 150: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand SrcStateOperand  */
#line 1144 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3625 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 151: /* MovsInstruction: MOVS_OP ExecSize VecDstOperand_G SrcStateOperand  */
#line 1150 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].StateVar).cisa_gen_opnd, CISAlineno);
    }
#line 3634 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 152: /* MovsInstruction: MOVS_OP ExecSize DstStateOperand VecSrcOperand_G_I_IMM  */
#line 1156 "CISA.y"
    {
        pBuilder->CISA_create_movs_instruction((yyvsp[-2].emask_exec_size).emask, ISA_MOVS, (yyvsp[-2].emask_exec_size).exec_size,
            (yyvsp[-1].StateVar).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3643 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 153: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize PredVar VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1174 "CISA.y"
    {
        pBuilder->CISA_create_cmp_instruction((yyvsp[-4].cond_mod), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].vISADecl), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3652 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 154: /* CmpInstruction: CMP_OP ConditionalModifier ExecSize VecDstOperand_G_I VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1181 "CISA.y"
    {
        // NOTE: predication not permitted.  Apparently the vISA API doesn't allow for predicated compares
        pBuilder->CISA_create_cmp_instruction(
            (yyvsp[-4].cond_mod), ISA_CMP, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3663 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 155: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var MediaInstructionPlaneID VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1191 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-7].opcode), (yyvsp[-6].media_mode), (yyvsp[-5].offset).row, (yyvsp[-5].offset).elem, (int)(yyvsp[-3].intval), (yyvsp[-4].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3673 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 156: /* MediaInstruction: MEDIA_OP MEDIA_MODE TwoDimOffset Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1199 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_media_instruction(
            (yyvsp[-6].opcode), (yyvsp[-5].media_mode), (yyvsp[-4].offset).row, (yyvsp[-4].offset).elem, (int)0, (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3683 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 157: /* MediaInstructionPlaneID: DEC_LIT  */
#line 1205 "CISA.y"
                                 {
        MUST_HOLD((yyvsp[0].intval) <= 0xF, "PlaneID must less than 0xF");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 3692 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 158: /* ScatterInstruction: SCATTER_OP ElemNum ExecSize OwordModifier Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1213 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_instruction(
            (yyvsp[-7].opcode), (int)(yyvsp[-6].intval), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].oword_mod), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3702 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 159: /* ScatterTypedInstruction: Predicate SCATTER_TYPED_OP SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1222 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_typed_instruction(
            (yyvsp[-8].opcode), (yyvsp[-9].pred_reg), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-5].string),
            (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3712 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 160: /* Scatter4ScaledInstruction: Predicate SCATTER4_SCALED_OP SAMPLER_CHANNEL ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1231 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter4_scaled_instruction(
            (yyvsp[-6].opcode), (yyvsp[-7].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-5].s_channel)), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3722 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 161: /* ScatterScaledInstruction: Predicate SCATTER_SCALED_OP DOT DEC_LIT ExecSize Var VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1240 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_scatter_scaled_instruction(
            (yyvsp[-7].opcode), (yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (uint32_t) (yyvsp[-5].intval), (yyvsp[-3].string),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3732 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 162: /* SynchronizationInstruction: BARRIER_OP  */
#line 1247 "CISA.y"
               {
        pBuilder->CISA_create_sync_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 3740 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 163: /* SynchronizationInstruction: SBARRIER_SIGNAL  */
#line 1250 "CISA.y"
                      {
        pBuilder->CISA_create_sbarrier_instruction(true, CISAlineno);
    }
#line 3748 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 164: /* SynchronizationInstruction: SBARRIER_WAIT  */
#line 1253 "CISA.y"
                    {
        pBuilder->CISA_create_sbarrier_instruction(false, CISAlineno);
    }
#line 3756 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 165: /* SynchronizationInstruction: NBARRIER_SIGNAL VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM  */
#line 1256 "CISA.y"
                                                                  {
        pBuilder->CISA_create_nbarrier(false, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 3764 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 166: /* SynchronizationInstruction: NBARRIER_WAIT VecSrcOperand_G_I_IMM  */
#line 1259 "CISA.y"
                                          {
        pBuilder->CISA_create_nbarrier(true, (yyvsp[0].genOperand).cisa_gen_opnd, NULL, CISAlineno);
    }
#line 3772 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 167: /* DwordAtomicInstruction: Predicate DWORD_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand  */
#line 1265 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_dword_atomic_instruction(
            (yyvsp[-9].pred_reg), (yyvsp[-7].atomic_op), (yyvsp[-6].flag), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3781 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 168: /* TypedAtomicInstruction: Predicate TYPED_ATOMIC_OP ATOMIC_SUB_OP Atomic16Opt ExecSize Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1272 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_typed_atomic_instruction(
            (yyvsp[-12].pred_reg), (yyvsp[-10].atomic_op), (yyvsp[-9].flag), (yyvsp[-8].emask_exec_size).emask, (yyvsp[-8].emask_exec_size).exec_size, (yyvsp[-7].string),
            (yyvsp[-6].RawVar), (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3791 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 169: /* Atomic16Opt: %empty  */
#line 1279 "CISA.y"
             {(yyval.flag) = false;}
#line 3797 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 170: /* Atomic16Opt: DOT DEC_LIT  */
#line 1280 "CISA.y"
                  { // .16
        MUST_HOLD(((yyvsp[0].intval) == 16), "only supports 16");
        (yyval.flag) = true;
    }
#line 3806 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 171: /* SampleUnormInstruction: SAMPLE_UNORM_OP SAMPLER_CHANNEL CHANNEL_OUTPUT Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM RawOperand  */
#line 1287 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sampleunorm_instruction(
            (yyvsp[-9].opcode), ChannelMask::createFromAPI((yyvsp[-8].s_channel)), (yyvsp[-7].s_channel_output), (yyvsp[-6].string), (yyvsp[-5].string),
            (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 3816 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 172: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var Var RawOperand RawOperand RawOperand RawOperand  */
#line 1296 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
            (yyvsp[-8].opcode), ChannelMask::createFromAPI((yyvsp[-7].s_channel)), (int)(yyvsp[-6].intval), (yyvsp[-5].string), (yyvsp[-4].string),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
    }
#line 3826 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 173: /* SampleInstruction: SAMPLE_OP SAMPLER_CHANNEL SIMDMode Var RawOperand RawOperand RawOperand RawOperand  */
#line 1304 "CISA.y"
   {
       ABORT_ON_FAIL(pBuilder->CISA_create_sample_instruction(
           (yyvsp[-7].opcode), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (int)(yyvsp[-5].intval), "", (yyvsp[-4].string),
           (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3836 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 175: /* Sample3DInstruction: Predicate SAMPLE_3D_OP PixelNullMaskEnableOpt CPSEnableOpt NonUniformSamplerEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var Var RawOperand RawOperandArray  */
#line 1316 "CISA.y"
   {
       const bool success = pBuilder->create3DSampleInstruction(
           (yyvsp[-11].pred_reg), (yyvsp[-10].sample3DOp), (yyvsp[-9].pixel_null_mask), (yyvsp[-8].cps), (yyvsp[-7].non_uniform_sampler), ChannelMask::createFromAPI((yyvsp[-6].s_channel)),
           (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3849 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 176: /* CPSEnableOpt: %empty  */
#line 1328 "CISA.y"
                     {(yyval.cps) = false;}
#line 3855 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 177: /* CPSEnableOpt: CPS  */
#line 1328 "CISA.y"
                                          {(yyval.cps) = true;}
#line 3861 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 178: /* NonUniformSamplerEnableOpt: %empty  */
#line 1330 "CISA.y"
                                   {(yyval.non_uniform_sampler) = false;}
#line 3867 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 179: /* NonUniformSamplerEnableOpt: NON_UNIFORM_SAMPLER  */
#line 1330 "CISA.y"
                                                                       {(yyval.non_uniform_sampler) = true;}
#line 3873 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 181: /* Load3DInstruction: Predicate LOAD_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var RawOperand RawOperandArray  */
#line 1338 "CISA.y"
   {
       const bool success = pBuilder->create3DLoadInstruction(
           (yyvsp[-8].pred_reg), (yyvsp[-7].sample3DOp), (yyvsp[-6].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-5].s_channel)),
           (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].string),
           (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3886 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 183: /* Gather43DInstruction: Predicate SAMPLE4_3D_OP PixelNullMaskEnableOpt SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM Var Var RawOperand RawOperandArray  */
#line 1354 "CISA.y"
   {
       const bool success = pBuilder->createSample4Instruction(
          (yyvsp[-9].pred_reg), (yyvsp[-8].sample3DOp), (yyvsp[-7].pixel_null_mask), ChannelMask::createFromAPI((yyvsp[-6].s_channel)), (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size,
          (yyvsp[-4].genOperand).cisa_gen_opnd, (yyvsp[-3].string), (yyvsp[-2].string),
          (yyvsp[-1].RawVar), (unsigned int)(yyvsp[0].intval), rawOperandArray, CISAlineno);

    ABORT_ON_FAIL(success);
   }
#line 3899 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 184: /* PixelNullMaskEnableOpt: %empty  */
#line 1364 "CISA.y"
                               {(yyval.pixel_null_mask) = false;}
#line 3905 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 185: /* PixelNullMaskEnableOpt: PIXEL_NULL_MASK  */
#line 1364 "CISA.y"
                                                               {(yyval.pixel_null_mask) = true;}
#line 3911 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 186: /* ResInfo3dInstruction: RESINFO_OP_3D SAMPLER_CHANNEL ExecSize Var RawOperand RawOperand  */
#line 1368 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_RESINFO, (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-4].s_channel)), (yyvsp[-2].string), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 3921 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 187: /* SampleInfo3dInstruction: SAMPLEINFO_OP_3D SAMPLER_CHANNEL ExecSize Var RawOperand  */
#line 1376 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_info_3d_instruction(
            VISA_3D_SAMPLEINFO, (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            ChannelMask::createFromAPI((yyvsp[-3].s_channel)), (yyvsp[-1].string), NULL, (yyvsp[0].RawVar), CISAlineno));
   }
#line 3931 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 188: /* RTWriteOperands: %empty  */
#line 1384 "CISA.y"
    {
    }
#line 3938 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 189: /* RTWriteOperands: RTWriteOperands VecSrcOperand_G_IMM  */
#line 1387 "CISA.y"
    {
        RTRWOperandsVec.push_back((yyvsp[0].genOperand).cisa_gen_opnd);
    }
#line 3946 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 190: /* RTWriteOperands: RTWriteOperands RawOperand  */
#line 1391 "CISA.y"
    {
        RTRWOperandsVec.push_back((yyvsp[0].RawVar));
    }
#line 3954 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 192: /* RTWInstruction: Predicate RTWRITE_OP_3D RTWriteModeOpt ExecSize Var RTWriteOperands  */
#line 1400 "CISA.y"
   {
       bool result = pBuilder->CISA_create_rtwrite_3d_instruction(
           (yyvsp[-5].pred_reg), (yyvsp[-3].string), (yyvsp[-2].emask_exec_size).emask, (unsigned int)(yyvsp[-2].emask_exec_size).exec_size, (yyvsp[-1].string),
           RTRWOperandsVec, CISAlineno);
       RTRWOperandsVec.clear();
       if (!result)
           YYABORT; // already reported
   }
#line 3967 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 193: /* RTWriteModeOpt: %empty  */
#line 1410 "CISA.y"
                       {(yyval.string) = 0;}
#line 3973 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 195: /* URBWriteInstruction: Predicate URBWRITE_OP_3D ExecSize DEC_LIT DEC_LIT RawOperand RawOperand RawOperand RawOperand  */
#line 1415 "CISA.y"
    {
        pBuilder->CISA_create_urb_write_3d_instruction(
            (yyvsp[-8].pred_reg), (yyvsp[-6].emask_exec_size).emask, (unsigned int)(yyvsp[-6].emask_exec_size).exec_size, (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-4].intval),
            (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 3983 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 196: /* AVSInstruction: AVS_OP SAMPLER_CHANNEL Var Var VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM VecSrcOperand_G_I_IMM CNTRL VecSrcOperand_G_I_IMM EXECMODE VecSrcOperand_G_I_IMM RawOperand  */
#line 1423 "CISA.y"
    {
        pBuilder->CISA_create_avs_instruction(
            ChannelMask::createFromAPI((yyvsp[-14].s_channel)), (yyvsp[-13].string), (yyvsp[-12].string),
            (yyvsp[-11].genOperand).cisa_gen_opnd, (yyvsp[-10].genOperand).cisa_gen_opnd, (yyvsp[-9].genOperand).cisa_gen_opnd, (yyvsp[-8].genOperand).cisa_gen_opnd,
            (yyvsp[-7].genOperand).cisa_gen_opnd, (yyvsp[-6].genOperand).cisa_gen_opnd, (yyvsp[-5].genOperand).cisa_gen_opnd, (yyvsp[-4].cntrl), (yyvsp[-3].genOperand).cisa_gen_opnd,
            (yyvsp[-2].execMode), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 3995 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 197: /* VMEInstruction: VME_IME_OP VMEOpndIME Var RawOperand RawOperand RawOperand RawOperand RawOperand RawOperand  */
#line 1435 "CISA.y"
   {
       //     1 - OP
       //     2 - StreamMode, SearchCtrl
       //     3 - Surface
       //     4 - UNIInput
       //     5 - IMEInput
       //     6 - ref0
       //     7 - ref1
       //     8 - CostCenter
       //     9 - Output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_ime_instruction(
            (yyvsp[-8].opcode), (yyvsp[-7].vmeOpndIvb).streamMode, (yyvsp[-7].vmeOpndIvb).searchCtrl, (yyvsp[-5].RawVar), (yyvsp[-4].RawVar), (yyvsp[-6].string), (yyvsp[-3].RawVar), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4013 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 198: /* VMEInstruction: VME_SIC_OP Var RawOperand RawOperand RawOperand  */
#line 1451 "CISA.y"
   {
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_sic_instruction((yyvsp[-4].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string), (yyvsp[0].RawVar), CISAlineno));
   }
#line 4021 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 199: /* VMEInstruction: VME_FBR_OP VMEOpndFBR Var RawOperand RawOperand RawOperand  */
#line 1457 "CISA.y"
   {
        //    1 - OP
        //    2 - FBRMdMode, FBRSubMbShape, FBRSubPredMode
        //    3 - surface
        //    4 - UNIInput
        //    5 - FBRInput
        //    6 - output
        ABORT_ON_FAIL(pBuilder->CISA_create_vme_fbr_instruction((yyvsp[-5].opcode), (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[-3].string),
            (yyvsp[-4].vmeOpndFbr).cisa_fbrMbMode_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubMbShape_opnd, (yyvsp[-4].vmeOpndFbr).cisa_fbrSubPredMode_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4036 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 200: /* OwordInstruction: OWORD_OP OwordModifier ExecSize Var VecSrcOperand_G_I_IMM RawOperand  */
#line 1470 "CISA.y"
    {
        ABORT_ON_FAIL(
            pBuilder->CISA_create_oword_instruction((yyvsp[-5].opcode), (yyvsp[-4].oword_mod), (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno));
    }
#line 4045 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 201: /* SvmInstruction: SVM_OP SVM_ALIGNED ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1478 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-4].opcode),
(yyvsp[-2].emask_exec_size).exec_size, false, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4054 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 202: /* SvmInstruction: SVM_OP SVM_UNALIGNED ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1485 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-4].opcode),
(yyvsp[-2].emask_exec_size).exec_size, true, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4063 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 203: /* SvmInstruction: SVM_OP ExecSize VecSrcOperand_G_I_IMM RawOperand  */
#line 1493 "CISA.y"
    {
        pBuilder->CISA_create_svm_block_instruction((SVMSubOpcode)(yyvsp[-3].opcode),
(yyvsp[-2].emask_exec_size).exec_size, true, (yyvsp[-1].genOperand).cisa_gen_opnd, (yyvsp[0].RawVar), CISAlineno);
    }
#line 4072 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 204: /* SvmInstruction: Predicate SVM_SCATTER_OP DOT DEC_LIT DOT DEC_LIT ExecSize RawOperand RawOperand  */
#line 1499 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter_instruction((yyvsp[-8].pred_reg), (SVMSubOpcode)(yyvsp[-7].opcode), (yyvsp[-2].emask_exec_size).emask, (yyvsp[-2].emask_exec_size).exec_size,
            (unsigned int)(yyvsp[-5].intval), (unsigned int)(yyvsp[-3].intval), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4081 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 205: /* SvmInstruction: Predicate SVM_ATOMIC_OP ATOMIC_SUB_OP AtomicBitwidthOpt ExecSize RawOperand RawOperand RawOperand RawOperand  */
#line 1505 "CISA.y"
    {
        pBuilder->CISA_create_svm_atomic_instruction((yyvsp[-8].pred_reg), (yyvsp[-4].emask_exec_size).emask, (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-6].atomic_op), (unsigned short)(yyvsp[-5].intval),
            (yyvsp[-3].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), (yyvsp[-2].RawVar), CISAlineno);
    }
#line 4090 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 206: /* SvmInstruction: Predicate SVM_GATHER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1511 "CISA.y"
    {
        pBuilder->CISA_create_svm_gather4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4099 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 207: /* SvmInstruction: Predicate SVM_SCATTER4SCALED_OP SAMPLER_CHANNEL ExecSize VecSrcOperand_G_I_IMM RawOperand RawOperand  */
#line 1517 "CISA.y"
    {
        pBuilder->CISA_create_svm_scatter4_scaled((yyvsp[-6].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, ChannelMask::createFromAPI((yyvsp[-4].s_channel)),
            (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4108 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 208: /* AtomicBitwidthOpt: %empty  */
#line 1523 "CISA.y"
             {(yyval.intval) = 32;}
#line 4114 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 209: /* AtomicBitwidthOpt: DOT DEC_LIT  */
#line 1524 "CISA.y"
                  {
        MUST_HOLD((yyvsp[0].intval) == 16 || (yyvsp[0].intval) == 32 || (yyvsp[0].intval) == 64, "only supports 16 or 64");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 4123 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 222: /* LscUntypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand  */
#line 1574 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0
            nullptr,     // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4147 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 223: /* LscUntypedStridedLoad: Predicate LSC_LOAD_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedStridedAddrOperand  */
#line 1605 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr,     // address
            (yyvsp[-1].lsc_data_operand).shape,    // data
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_data_operand).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[0].lsc_addr_operand).regs[1],  // src0 stride
            nullptr,     // src1
            CISAlineno);
    }
#line 4171 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 224: /* LscUntypedBlock2dLoad: Predicate LSC_LOAD_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand2D LscUntypedBlock2dAddrOperand  */
#line 1634 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_data_operand2d).shape2D,  // data shape
            (yyvsp[-1].lsc_data_operand2d).reg,      // dst
            (yyvsp[0].lsc_addr_operand).regs,     // src0 surface info / addrs
            nullptr,     // src1
            CISAlineno);
    }
#line 4192 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 225: /* LscUntypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedAddrOperand LscDataOperand  */
#line 1659 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0
            (yyvsp[0].lsc_data_operand).reg,      // src1
            nullptr,     // src2
            CISAlineno);
    }
#line 4216 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 226: /* LscUntypedStridedStore: Predicate LSC_STORE_STRIDED_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedStridedAddrOperand LscDataOperand  */
#line 1683 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_strided_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // SFID
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr,     // address
            (yyvsp[0].lsc_data_operand).shape,    // data
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0 base
            (yyvsp[-1].lsc_addr_operand).regs[1],  // src0 stride
            (yyvsp[0].lsc_data_operand).reg,      // src1
            CISAlineno);
    }
#line 4240 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 227: /* LscUntypedBlock2dStore: Predicate LSC_STORE_BLOCK2D_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscUntypedBlock2dAddrOperand LscDataOperand2D  */
#line 1710 "CISA.y"
    {
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand2d).shape2D.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_block2d_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_data_operand2d).shape2D,  // data2d
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs,     // src0 addrs
            (yyvsp[0].lsc_data_operand2d).reg,      // src1
            CISAlineno);
    }
#line 4261 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 228: /* LscUntypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_UNTYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscUntypedAddrOperand LscPayloadReg LscPayloadReg  */
#line 1736 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_untyped_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),                // op
            (yyvsp[-6].lsc_sfid),                // sfid
            (yyvsp[-5].lsc_caching_opts),                // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_addr_operand).addr,     // address info
            (yyvsp[-3].lsc_data_operand).shape,    // data type
            (yyvsp[-2].lsc_addr_operand).surface,  // surface
            (yyvsp[-3].lsc_data_operand).reg,      // dst data
            (yyvsp[-2].lsc_addr_operand).regs[0],  // src0 addr
            (yyvsp[-1].RawVar),          // src1 data
            (yyvsp[0].RawVar),          // src2 data (for icas/fcas)
            CISAlineno);
    }
#line 4285 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 229: /* LscTypedLoad: Predicate LSC_LOAD_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperand  */
#line 1768 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_LOAD_QUAD) {
            PARSE_ERROR("unsupported load operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[-1].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[0].lsc_addr_operand).addr.type,  // address model
            (yyvsp[0].lsc_addr_operand).addr.size,  // address size
            (yyvsp[-1].lsc_data_operand).shape,    // data type
            (yyvsp[0].lsc_addr_operand).surface,  // surface
            (yyvsp[-1].lsc_data_operand).reg,      // dst data
            (yyvsp[0].lsc_addr_operand).regs[0],  // src0_u
            (yyvsp[0].lsc_addr_operand).regs[1],  // src0_v
            (yyvsp[0].lsc_addr_operand).regs[2],  // src0_r
            (yyvsp[0].lsc_addr_operand).regs[3],  // feature (for example, LOD)
            nullptr,     // src1 data
            nullptr,     // src2 data
            CISAlineno);
    }
#line 4316 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 230: /* LscTypedStore: Predicate LSC_STORE_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscTypedAddrOperand LscDataOperand  */
#line 1808 "CISA.y"
    {
        if ((yyvsp[-5].lsc_subOpcode) != LSC_STORE_QUAD) {
            PARSE_ERROR("unsupported store operation for .tgm");
        }
        (yyvsp[-2].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-4].lsc_sfid), (yyvsp[-5].lsc_subOpcode), (yyvsp[0].lsc_data_operand).shape.order, (yyvsp[-2].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-6].pred_reg),  // predicate
            (yyvsp[-5].lsc_subOpcode),  // subop
            (yyvsp[-4].lsc_sfid),  // sfid
            (yyvsp[-3].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-2].emask_exec_size).exec_size),
            (yyvsp[-2].emask_exec_size).emask,
            (yyvsp[-1].lsc_addr_operand).addr.type,  // address model
            (yyvsp[-1].lsc_addr_operand).addr.size,  // address size
            (yyvsp[0].lsc_data_operand).shape,    // data type
            (yyvsp[-1].lsc_addr_operand).surface,  // surface
            nullptr,     // dst
            (yyvsp[-1].lsc_addr_operand).regs[0],  // src0_u
            (yyvsp[-1].lsc_addr_operand).regs[1],  // src0_v
            (yyvsp[-1].lsc_addr_operand).regs[2],  // src0_r
            (yyvsp[-1].lsc_addr_operand).regs[3],  // feature (for example, LOD)
            (yyvsp[0].lsc_data_operand).reg,      // src1 data
            nullptr,     // src2 data
            CISAlineno);
    }
#line 4347 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 231: /* LscTypedAtomic: Predicate LSC_ATOMIC_MNEMONIC LSC_SFID_TYPED_TOKEN LscCacheOpts ExecSize LscDataOperand LscTypedAddrOperand LscPayloadReg LscPayloadReg  */
#line 1848 "CISA.y"
    {
        (yyvsp[-4].emask_exec_size).exec_size =
            lscCheckExecSize(pBuilder, (yyvsp[-6].lsc_sfid), (yyvsp[-7].lsc_subOpcode), (yyvsp[-3].lsc_data_operand).shape.order, (yyvsp[-4].emask_exec_size).exec_size);
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-8].pred_reg),  // predicate
            (yyvsp[-7].lsc_subOpcode),  // subop
            (yyvsp[-6].lsc_sfid),  // sfid
            (yyvsp[-5].lsc_caching_opts),  // caching settings
            Get_VISA_Exec_Size_From_Raw_Size((yyvsp[-4].emask_exec_size).exec_size),
            (yyvsp[-4].emask_exec_size).emask,
            (yyvsp[-2].lsc_addr_operand).addr.type, // address model
            (yyvsp[-2].lsc_addr_operand).addr.size,  // address size
            (yyvsp[-3].lsc_data_operand).shape,    // data type
            (yyvsp[-2].lsc_addr_operand).surface,  // surface
            (yyvsp[-3].lsc_data_operand).reg,      // dst data
            (yyvsp[-2].lsc_addr_operand).regs[0],  // src0 addrs u
            (yyvsp[-2].lsc_addr_operand).regs[1],  // src0 addrs v
            (yyvsp[-2].lsc_addr_operand).regs[2],  // src0 addrs r
            (yyvsp[-2].lsc_addr_operand).regs[3],  // src0 addrs lod
            (yyvsp[-1].RawVar),          // src1 data
            (yyvsp[0].RawVar),          // src2 data
            CISAlineno);
    }
#line 4375 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 232: /* LscTypedReadStateInfo: Predicate LSC_READ_STATE_INFO_MNEMONIC LSC_SFID_TYPED_TOKEN LscPayloadReg LscRegAddrModel  */
#line 1879 "CISA.y"
   {
        LSC_CACHE_OPTS caching{LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};
        LSC_DATA_SHAPE dataShape{LSC_DATA_SIZE_32b,LSC_DATA_ORDER_NONTRANSPOSE};
        dataShape.elems = LSC_DATA_ELEMS_1;
        pBuilder->CISA_create_lsc_typed_inst(
            (yyvsp[-4].pred_reg),              // predicate
            (yyvsp[-3].lsc_subOpcode),              // subop
            (yyvsp[-2].lsc_sfid),              // sfid
            caching,         // caching settings
            EXEC_SIZE_1,
            vISA_EMASK_M1_NM,
            (yyvsp[0].lsc_addr_model).type,           // address model
            LSC_ADDR_SIZE_32b, // address size
            dataShape,         // data type
            (yyvsp[0].lsc_addr_model).surface,        // surface
            (yyvsp[-1].RawVar),                // dst data
            nullptr,           // src0 addrs u
            nullptr,           // src0 addrs v
            nullptr,           // src0 addrs r
            nullptr,           // src0 addrs lod
            nullptr,           // src1 data
            nullptr,           // src2 data
            CISAlineno);
   }
#line 4404 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 233: /* LscFence: LSC_FENCE_MNEMONIC LscSfid LSC_FENCE_OP_TYPE LSC_FENCE_SCOPE  */
#line 1912 "CISA.y"
    {
        pBuilder->CISA_create_lsc_fence((yyvsp[-2].lsc_sfid), (yyvsp[-1].lsc_fence_op), (yyvsp[0].lsc_scope), CISAlineno);
    }
#line 4412 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 236: /* LscCacheOpts: %empty  */
#line 1919 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {LSC_CACHING_DEFAULT,LSC_CACHING_DEFAULT};}
#line 4418 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 237: /* LscCacheOpts: LSC_CACHING_OPT  */
#line 1920 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {(yyvsp[0].lsc_caching_opt),LSC_CACHING_DEFAULT};}
#line 4424 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 238: /* LscCacheOpts: LSC_CACHING_OPT LSC_CACHING_OPT  */
#line 1921 "CISA.y"
                                    {(yyval.lsc_caching_opts) = {(yyvsp[-1].lsc_caching_opt),(yyvsp[0].lsc_caching_opt)};}
#line 4430 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 239: /* LscUntypedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt RBRACK LSC_ADDR_SIZE_TK  */
#line 1928 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-6].lsc_addr_model).surface,{(yyvsp[-3].RawVar)},{(yyvsp[-6].lsc_addr_model).type,(int)(yyvsp[-4].intval),(int)(yyvsp[-2].intval),(yyvsp[0].lsc_addr_size)}};
    }
#line 4438 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 240: /* LscUntypedStridedAddrOperand: LscAddrModelOpt LBRACK LscAddrImmScaleOpt LscPayloadNonNullReg LscAddrImmOffsetOpt COMMA LscVectorOpRegOrImm RBRACK LSC_ADDR_SIZE_TK  */
#line 1937 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-8].lsc_addr_model).surface,{(yyvsp[-5].RawVar),(yyvsp[-2].lsc_addr_surface_ident)},{(yyvsp[-8].lsc_addr_model).type,(int)(yyvsp[-6].intval),(int)(yyvsp[-4].intval),(yyvsp[0].lsc_addr_size)}};
    }
#line 4446 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 241: /* LscUntypedStridedAddrOperand: LscUntypedAddrOperand  */
#line 1940 "CISA.y"
                            {
        (yyval.lsc_addr_operand) = (yyvsp[0].lsc_addr_operand);
        (yyval.lsc_addr_operand).regs[1] = nullptr;
    }
#line 4455 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 242: /* LscUntypedBlock2dAddrOperand: LSC_AM_FLAT LBRACK LscVectorOpReg COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm COMMA LscVectorOpRegOrImm RBRACK  */
#line 1963 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {nullptr,{(yyvsp[-11].lsc_addr_surface_ident),(yyvsp[-9].lsc_addr_surface_ident),(yyvsp[-7].lsc_addr_surface_ident),(yyvsp[-5].lsc_addr_surface_ident),(yyvsp[-3].lsc_addr_surface_ident),(yyvsp[-1].lsc_addr_surface_ident)},{LSC_ADDR_TYPE_FLAT,1,0,LSC_ADDR_SIZE_64b}};
    }
#line 4463 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 243: /* LscTypedOneAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1975 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-4].lsc_addr_model).surface,{(yyvsp[-2].RawVar)},{(yyvsp[-4].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4471 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 244: /* LscTypedOneAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA BUILTIN_NULL COMMA BUILTIN_NULL COMMA BUILTIN_NULL RBRACK LSC_ADDR_SIZE_TK  */
#line 1985 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-10].lsc_addr_model).surface,{(yyvsp[-8].RawVar)},{(yyvsp[-10].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4479 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 245: /* LscTypedTwoAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 1997 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-6].lsc_addr_model).surface,{(yyvsp[-4].RawVar),(yyvsp[-2].RawVar)},{(yyvsp[-6].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4487 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 246: /* LscTypedTwoAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA BUILTIN_NULL COMMA BUILTIN_NULL RBRACK LSC_ADDR_SIZE_TK  */
#line 2007 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-10].lsc_addr_model).surface,{(yyvsp[-8].RawVar),(yyvsp[-6].RawVar)},{(yyvsp[-10].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4495 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 247: /* LscTypedThreeAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 2018 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-8].lsc_addr_model).surface,{(yyvsp[-6].RawVar),(yyvsp[-4].RawVar),(yyvsp[-2].RawVar)},{(yyvsp[-8].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4503 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 248: /* LscTypedThreeAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA BUILTIN_NULL RBRACK LSC_ADDR_SIZE_TK  */
#line 2028 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-10].lsc_addr_model).surface,{(yyvsp[-8].RawVar),(yyvsp[-6].RawVar),(yyvsp[-4].RawVar)},{(yyvsp[-10].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4511 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 249: /* LscTypedFourAddrOperand: LscRegAddrModel LBRACK LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA LscPayloadNonNullReg COMMA LscPayloadNonNullReg RBRACK LSC_ADDR_SIZE_TK  */
#line 2039 "CISA.y"
    {
        (yyval.lsc_addr_operand) = {(yyvsp[-10].lsc_addr_model).surface,{(yyvsp[-8].RawVar),(yyvsp[-6].RawVar),(yyvsp[-4].RawVar),(yyvsp[-2].RawVar)},{(yyvsp[-10].lsc_addr_model).type,1,0,(yyvsp[0].lsc_addr_size)}};
    }
#line 4519 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 254: /* LscAddrImmOffsetOpt: %empty  */
#line 2053 "CISA.y"
                     {(yyval.intval) =   0;}
#line 4525 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 255: /* LscAddrImmOffsetOpt: PLUS IntExpAdd  */
#line 2054 "CISA.y"
                     {(yyval.intval) =  (yyvsp[0].intval);}
#line 4531 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 256: /* LscAddrImmOffsetOpt: MINUS IntExpPrim  */
#line 2055 "CISA.y"
                     {(yyval.intval) = -(yyvsp[0].intval);}
#line 4537 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 257: /* LscAddrImmScaleOpt: %empty  */
#line 2062 "CISA.y"
                      {(yyval.intval) = 1;}
#line 4543 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 258: /* LscAddrImmScaleOpt: IntExpMul TIMES  */
#line 2063 "CISA.y"
                      {(yyval.intval) = (yyvsp[-1].intval);}
#line 4549 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 259: /* LscAddrModelOpt: %empty  */
#line 2066 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT,nullptr};}
#line 4555 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 260: /* LscAddrModelOpt: LSC_AM_FLAT  */
#line 2067 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_FLAT,nullptr};}
#line 4561 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 261: /* LscAddrModelOpt: LSC_AM_ARG  */
#line 2068 "CISA.y"
                 {(yyval.lsc_addr_model) = {LSC_ADDR_TYPE_ARG,nullptr};}
#line 4567 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 263: /* LscRegAddrModel: LscRegAddrModelKind LPAREN LscVectorOpRegOrImm RPAREN  */
#line 2073 "CISA.y"
                                                             {
        (yyval.lsc_addr_model) = {(yyvsp[-3].lsc_addr_type),(yyvsp[-1].lsc_addr_surface_ident)};
    }
#line 4575 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 264: /* LscRegAddrModelKind: LSC_AM_BSS  */
#line 2078 "CISA.y"
               {(yyval.lsc_addr_type) = LSC_ADDR_TYPE_BSS;}
#line 4581 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 265: /* LscRegAddrModelKind: LSC_AM_SS  */
#line 2079 "CISA.y"
               {(yyval.lsc_addr_type) = LSC_ADDR_TYPE_SS;}
#line 4587 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 266: /* LscRegAddrModelKind: LSC_AM_BTI  */
#line 2080 "CISA.y"
               {(yyval.lsc_addr_type) = LSC_ADDR_TYPE_BTI;}
#line 4593 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 269: /* LscVectorOpImm: IntExp  */
#line 2085 "CISA.y"
           {
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_immed((yyvsp[0].intval),ISA_TYPE_UD, CISAlineno);
    }
#line 4601 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 270: /* LscVectorOpReg: Var  */
#line 2090 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[0].string),
            0, 1, 0, // region
            0, 0, // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4613 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 271: /* LscVectorOpReg: Var DOT DEC_LIT  */
#line 2098 "CISA.y"
                    {
        ABORT_ON_FAIL((yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-2].string),
            0, 1, 0, // region
            0, (unsigned char)(yyvsp[0].intval), // row and col offset
            MODIFIER_NONE, CISAlineno));
    }
#line 4625 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 272: /* LscVectorOpReg: Var LPAREN IntExp COMMA IntExp RPAREN  */
#line 2106 "CISA.y"
                                          {
        MUST_HOLD((yyvsp[-3].intval) <= 255 || (yyvsp[-3].intval) >= 0, "row is out of bounds");
        MUST_HOLD((yyvsp[-1].intval) <= 255 || (yyvsp[-1].intval) >= 0, "col is out of bounds");
        (yyval.lsc_addr_surface_ident) = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-5].string),
            0, 1, 0,
            (unsigned char)(yyvsp[-3].intval), (unsigned char)(yyvsp[-1].intval), // row and col offset
            MODIFIER_NONE, CISAlineno);
        if ((yyval.lsc_addr_surface_ident) == nullptr) {
            PARSE_ERROR("cannot find surface variable");
        }
    }
#line 4642 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 273: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK  */
#line 2120 "CISA.y"
                                     {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4650 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 274: /* LscDataOperand: LscPayloadReg LSC_DATA_SHAPE_TK_CHMASK  */
#line 2124 "CISA.y"
                                            {
        (yyval.lsc_data_operand) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape)};
    }
#line 4658 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 275: /* LscDataOperand2D: LscPayloadReg LSC_DATA_SHAPE_TK_BLOCK2D  */
#line 2130 "CISA.y"
                                            {
        (yyval.lsc_data_operand2d) = {(yyvsp[-1].RawVar),(yyvsp[0].lsc_data_shape2d)};
    }
#line 4666 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 277: /* LscPayloadReg: Var  */
#line 2138 "CISA.y"
        {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4674 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 279: /* LscPayloadNonNullReg: VarNonNull  */
#line 2145 "CISA.y"
               {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[0].string), 0, CISAlineno));
    }
#line 4682 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 280: /* SwitchLabels: %empty  */
#line 2151 "CISA.y"
    {
    }
#line 4689 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 281: /* SwitchLabels: COMMA SwitchLabels  */
#line 2154 "CISA.y"
    {
    }
#line 4696 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 282: /* SwitchLabels: IDENT SwitchLabels  */
#line 2157 "CISA.y"
    {
        // parse rule means we see last label first
        switchLabels.push_front((yyvsp[-1].string));
    }
#line 4705 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 283: /* BranchInstruction: Predicate BRANCH_OP ExecSize IdentOrStringLit  */
#line 2164 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].opcode), (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), false, CISAlineno);
    }
#line 4713 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 284: /* BranchInstruction: Predicate CALL_OP ExecSize IdentOrStringLit  */
#line 2168 "CISA.y"
    {
        pBuilder->CISA_create_branch_instruction((yyvsp[-3].pred_reg), (yyvsp[-2].cisa_call).opcode, (yyvsp[-1].emask_exec_size).emask, (yyvsp[-1].emask_exec_size).exec_size, (yyvsp[0].string), (yyvsp[-2].cisa_call).is_fccall, CISAlineno);
    }
#line 4721 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 285: /* BranchInstruction: Predicate RET_OP ExecSize  */
#line 2172 "CISA.y"
    {
        pBuilder->CISA_Create_Ret((yyvsp[-2].pred_reg), (yyvsp[-1].opcode), (yyvsp[0].emask_exec_size).emask, (yyvsp[0].emask_exec_size).exec_size, CISAlineno);
    }
#line 4729 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 286: /* BranchInstruction: SWITCHJMP_OP ExecSize VecSrcOperand_G_I_IMM LPAREN SwitchLabels RPAREN  */
#line 2176 "CISA.y"
    {
        pBuilder->CISA_create_switch_instruction((yyvsp[-5].opcode), (yyvsp[-4].emask_exec_size).exec_size, (yyvsp[-3].genOperand).cisa_gen_opnd, switchLabels, CISAlineno);
        switchLabels.clear();
    }
#line 4738 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 287: /* BranchInstruction: Predicate FCALL ExecSize IDENT DEC_LIT DEC_LIT  */
#line 2182 "CISA.y"
    {
        pBuilder->CISA_create_fcall_instruction((yyvsp[-5].pred_reg), (yyvsp[-4].opcode), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size, (yyvsp[-2].string), (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4746 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 288: /* BranchInstruction: Predicate IFCALL ExecSize VecSrcOperand_G_I_IMM DEC_LIT DEC_LIT  */
#line 2187 "CISA.y"
    {
        pBuilder->CISA_create_ifcall_instruction(
        (yyvsp[-5].pred_reg), (yyvsp[-3].emask_exec_size).emask, (yyvsp[-3].emask_exec_size).exec_size,
        (yyvsp[-2].genOperand).cisa_gen_opnd, (unsigned)(yyvsp[-1].intval), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4756 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 289: /* BranchInstruction: FADDR IdentOrStringLit VecDstOperand_G_I  */
#line 2194 "CISA.y"
    {
        pBuilder->CISA_create_faddr_instruction((yyvsp[-1].string), (yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 4764 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 290: /* FILE: FILE_OP STRING_LIT  */
#line 2199 "CISA.y"
    {
        pBuilder->CISA_create_FILE_instruction((yyvsp[-1].opcode), (yyvsp[0].string), CISAlineno);
    }
#line 4772 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 291: /* LOC: LOC_OP DEC_LIT  */
#line 2204 "CISA.y"
    {
        pBuilder->CISA_create_LOC_instruction((yyvsp[-1].opcode), (unsigned)(yyvsp[0].intval), CISAlineno);
    }
#line 4780 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 292: /* RawSendInstruction: Predicate RAW_SEND_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2210 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, false, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4789 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 293: /* RawSendInstruction: Predicate RAW_SENDC_STRING ExecSize HEX_LIT DEC_LIT DEC_LIT VecSrcOperand_G_IMM RawOperand RawOperand  */
#line 2217 "CISA.y"
    {
        pBuilder->CISA_create_raw_send_instruction(ISA_RAW_SEND, true, (yyvsp[-6].emask_exec_size).emask, (yyvsp[-6].emask_exec_size).exec_size, (yyvsp[-8].pred_reg),
            (unsigned)(yyvsp[-5].intval), (unsigned char)(yyvsp[-4].intval), (unsigned char)(yyvsp[-3].intval), (yyvsp[-2].genOperand).cisa_gen_opnd, (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4798 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 294: /* LifetimeStartInst: LIFETIME_START_OP IDENT  */
#line 2224 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)0, (yyvsp[0].string), CISAlineno));
    }
#line 4806 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 295: /* LifetimeEndInst: LIFETIME_END_OP IDENT  */
#line 2230 "CISA.y"
    {
        ABORT_ON_FAIL(pBuilder->CISA_create_lifetime_inst((unsigned char)1, (yyvsp[0].string), CISAlineno));
    }
#line 4814 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 296: /* RawSendsInstruction: Predicate RAW_SENDS_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2236 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4825 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 297: /* RawSendsInstruction: Predicate RAW_SENDS_EOT_STRING ElemNum ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2244 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, false, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-11].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            (unsigned char)(yyvsp[-9].intval), (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4836 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 298: /* RawSendsInstruction: Predicate RAW_SENDSC_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2252 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, false, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4847 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 299: /* RawSendsInstruction: Predicate RAW_SENDSC_EOT_STRING ElemNum ElemNum ElemNum ExecSize VecSrcOperand_G_IMM VecSrcOperand_G_IMM RawOperand RawOperand RawOperand  */
#line 2260 "CISA.y"
    {
        pBuilder->CISA_create_raw_sends_instruction(
            ISA_RAW_SENDS, true, true, (yyvsp[-5].emask_exec_size).emask, (yyvsp[-5].emask_exec_size).exec_size, (yyvsp[-10].pred_reg), (yyvsp[-4].genOperand).cisa_gen_opnd,
            0, (unsigned char)(yyvsp[-8].intval), (unsigned char)(yyvsp[-7].intval), (unsigned char)(yyvsp[-6].intval),
            (yyvsp[-3].genOperand).cisa_gen_opnd, (yyvsp[-2].RawVar), (yyvsp[-1].RawVar), (yyvsp[0].RawVar), CISAlineno);
    }
#line 4858 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 300: /* NullaryInstruction: CACHE_FLUSH_OP  */
#line 2270 "CISA.y"
    {
        pBuilder->CISA_create_NO_OPND_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 4866 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 301: /* NullaryInstruction: WAIT_OP VecSrcOperand_G_IMM  */
#line 2275 "CISA.y"
    {
        pBuilder->CISA_create_wait_instruction((yyvsp[0].genOperand).cisa_gen_opnd, CISAlineno);
    }
#line 4874 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 302: /* NullaryInstruction: YIELD_OP  */
#line 2280 "CISA.y"
    {
        pBuilder->CISA_create_yield_instruction((yyvsp[0].opcode), CISAlineno);
    }
#line 4882 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 303: /* NullaryInstruction: FENCE_GLOBAL_OP  */
#line 2285 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x0, CISAlineno);
    }
#line 4890 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 304: /* NullaryInstruction: FENCE_GLOBAL_OP FENCE_OPTIONS  */
#line 2290 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options), CISAlineno);
    }
#line 4898 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 305: /* NullaryInstruction: FENCE_LOCAL_OP  */
#line 2295 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x20, CISAlineno);
    }
#line 4906 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 306: /* NullaryInstruction: FENCE_LOCAL_OP FENCE_OPTIONS  */
#line 2300 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[-1].opcode), (yyvsp[0].fence_options) | 0x20, CISAlineno);
    }
#line 4914 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 307: /* NullaryInstruction: FENCE_SW_OP  */
#line 2305 "CISA.y"
    {
        pBuilder->CISA_create_fence_instruction((yyvsp[0].opcode), 0x80, CISAlineno);
    }
#line 4922 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 308: /* OwordModifier: %empty  */
#line 2309 "CISA.y"
                      {(yyval.oword_mod) = false;}
#line 4928 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 310: /* Predicate: %empty  */
#line 2316 "CISA.y"
    {
        (yyval.pred_reg) = NULL;
    }
#line 4936 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 311: /* Predicate: LPAREN PredSign PredVar PredCtrlOpt RPAREN  */
#line 2321 "CISA.y"
    {
        (yyval.pred_reg) = pBuilder->CISA_create_predicate_operand((yyvsp[-2].vISADecl), (yyvsp[-3].pred_sign), (yyvsp[-1].pred_ctrl), CISAlineno);
    }
#line 4944 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 312: /* PredSign: %empty  */
#line 2325 "CISA.y"
                 {(yyval.pred_sign) = PredState_NO_INVERSE;}
#line 4950 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 313: /* PredSign: BANG  */
#line 2325 "CISA.y"
                                                     {(yyval.pred_sign) = PredState_INVERSE;}
#line 4956 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 314: /* PredCtrlOpt: %empty  */
#line 2327 "CISA.y"
                    {(yyval.pred_ctrl) = PRED_CTRL_NON;}
#line 4962 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 316: /* SatModOpt: %empty  */
#line 2330 "CISA.y"
                  {(yyval.sat) = false;}
#line 4968 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 317: /* SatModOpt: SAT  */
#line 2330 "CISA.y"
                                      {(yyval.sat) = true;}
#line 4974 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 318: /* SrcModifier: SRCMOD_NEG  */
#line 2333 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG;}
#line 4980 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 319: /* SrcModifier: SRCMOD_ABS  */
#line 2334 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_ABS;}
#line 4986 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 320: /* SrcModifier: SRCMOD_NEGABS  */
#line 2335 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NEG_ABS;}
#line 4992 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 321: /* SrcModifier: SRCMOD_NOT  */
#line 2336 "CISA.y"
                    {(yyval.src_mod).mod = MODIFIER_NOT;}
#line 4998 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 322: /* ConditionalModifier: %empty  */
#line 2338 "CISA.y"
                            {(yyval.cond_mod) = ISA_CMP_UNDEF;}
#line 5004 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 324: /* VecDstOperand_A: DstAddrOperand  */
#line 2343 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5010 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 325: /* VecDstOperand_G: DstGeneralOperand  */
#line 2344 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5016 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 326: /* VecDstOperand_G_I: DstGeneralOperand  */
#line 2346 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5022 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 327: /* VecDstOperand_G_I: DstIndirectOperand  */
#line 2347 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 5028 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 329: /* VecSrcOperand_G_I_IMM_A_AO: SrcAddrOfOperand  */
#line 2352 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 5034 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 331: /* VecSrcOperand_G_I_IMM_A: SrcAddrOperand  */
#line 2356 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5040 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 333: /* VecSrcOperand_G_I_IMM: SrcIndirectOperand  */
#line 2360 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_INDIRECT;}
#line 5046 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 334: /* VecSrcOperand_G_I_IMM: SrcImmOperand  */
#line 2361 "CISA.y"
                           {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5052 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 336: /* VecSrcOperand_G_IMM: SrcImmOperand  */
#line 2365 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5058 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 338: /* VecSrcOperand_G_IMM_AO: SrcImmOperand  */
#line 2369 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_IMMEDIATE;}
#line 5064 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 339: /* VecSrcOperand_G_IMM_AO: SrcAddrOfOperand  */
#line 2370 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESSOF;}
#line 5070 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 341: /* VecSrcOperand_G_A: SrcAddrOperand  */
#line 2374 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5076 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 343: /* VecSrcOperand_G_A_AO: SrcAddrOfOperand  */
#line 2378 "CISA.y"
                          {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_ADDRESS;}
#line 5082 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 344: /* VecSrcOperand_G: SrcGeneralOperand  */
#line 2380 "CISA.y"
                                   {(yyval.genOperand) = (yyvsp[0].genOperand); (yyval.genOperand).type = OPERAND_GENERAL;}
#line 5088 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 345: /* VecSrcOpndSimple: Var TwoDimOffset  */
#line 2383 "CISA.y"
    {
        // simple vector operand with no modifier that has an
        // implicit src region = <1,1,0>
        (yyval.genOperand).type = OPERAND_GENERAL;
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_gen_src_operand(
            (yyvsp[-1].string), 1, 1, 0, (yyvsp[0].offset).row, (yyvsp[0].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5100 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 346: /* VMEOpndIME: LPAREN DEC_LIT COMMA DEC_LIT RPAREN  */
#line 2393 "CISA.y"
    {
        (yyval.vmeOpndIvb).streamMode = (unsigned char)(yyvsp[-3].intval);
        (yyval.vmeOpndIvb).searchCtrl = (unsigned char)(yyvsp[-1].intval);
    }
#line 5109 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 347: /* VMEOpndFBR: LPAREN VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM COMMA VecSrcOperand_G_I_IMM RPAREN  */
#line 2400 "CISA.y"
    {
        (yyval.vmeOpndFbr).cisa_fbrMbMode_opnd = (yyvsp[-5].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubMbShape_opnd = (yyvsp[-3].genOperand).cisa_gen_opnd;
        (yyval.vmeOpndFbr).cisa_fbrSubPredMode_opnd = (yyvsp[-1].genOperand).cisa_gen_opnd;
    }
#line 5119 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 348: /* SrcStateOperand: Var LPAREN IntExp RPAREN  */
#line 2408 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, false));
    }
#line 5129 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 349: /* DstStateOperand: Var LPAREN IntExp RPAREN  */
#line 2416 "CISA.y"
    {
        MUST_HOLD((yyvsp[-1].intval) < 0x100, "offset out of bounds");
        (yyval.StateVar).offset = (unsigned char)(yyvsp[-1].intval);
        ABORT_ON_FAIL((yyval.StateVar).cisa_gen_opnd = pBuilder->CISA_create_state_operand((yyvsp[-3].string), (unsigned char)(yyvsp[-1].intval), CISAlineno, true));
    }
#line 5139 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 351: /* RawOperand: BUILTIN_NULL DOT DEC_LIT  */
#line 2447 "CISA.y"
    {
        MUST_HOLD((yyvsp[0].intval) == 0, "%null must have 0 as offset");
        (yyval.RawVar) = pBuilder->CISA_create_RAW_NULL_operand(CISAlineno); // can't fail
    }
#line 5148 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 352: /* RawOperandNonNull: VarNonNull RawOperandOffsetSuffix  */
#line 2454 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.RawVar) = pBuilder->CISA_create_RAW_operand((yyvsp[-1].string), (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5156 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 353: /* RawOperandOffsetSuffix: DOT DEC_LIT  */
#line 2465 "CISA.y"
                {
        MUST_HOLD((yyvsp[0].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5165 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 354: /* RawOperandOffsetSuffix: DOT LPAREN IntExp RPAREN  */
#line 2470 "CISA.y"
                             {
        MUST_HOLD((yyvsp[-1].intval) <= 0x10000, "offset out of bounds");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5174 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 355: /* RawOperandArray: %empty  */
#line 2478 "CISA.y"
    {
        (yyval.intval) = 0;
    }
#line 5182 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 356: /* RawOperandArray: RawOperandArray RawOperand  */
#line 2483 "CISA.y"
    {
        rawOperandArray[(yyvsp[-1].intval)++] = (VISA_RawOpnd*)(yyvsp[0].RawVar);
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5191 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 357: /* DstAddrOperand: AddrVarAccessWithWidth  */
#line 2491 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
          pBuilder->CISA_set_address_operand(
            (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, true, CISAlineno));
    }
#line 5201 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 358: /* DstGeneralOperand: Var TwoDimOffset DstRegion  */
#line 2499 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-2].string), (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5210 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 359: /* DstGeneralOperand: Var DstRegion  */
#line 2504 "CISA.y"
                  {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_dst_general_operand(
            (yyvsp[-1].string), 0, 0, (unsigned short)(yyvsp[0].intval), CISAlineno));
    }
#line 5219 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 360: /* DstIndirectOperand: IndirectVarAccess DstRegion DataType  */
#line 2510 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_indirect_dst(
            (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff, (unsigned short)(yyvsp[-1].intval), (yyvsp[0].type), CISAlineno));
    }
#line 5228 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 361: /* SrcAddrOfOperand: AddrOfVar  */
#line 2531 "CISA.y"
              {
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[0].regAccess).cisa_decl, 0, CISAlineno);
    }
#line 5236 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 362: /* SrcAddrOfOperand: AddrOfVar LBRACK IntExp RBRACK  */
#line 2535 "CISA.y"
                                   {
         MUST_HOLD((short)(yyvsp[-1].intval) == (yyvsp[-1].intval), "variable address offset is too large");
         (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_set_address_expression((yyvsp[-3].regAccess).cisa_decl, (short)(yyvsp[-1].intval), CISAlineno);
    }
#line 5245 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 363: /* AddrOfVar: AMP Var  */
#line 2541 "CISA.y"
            {
        // Both GENERAL_VAR and SURFACE_VAR are addressable
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.regAccess).cisa_decl == nullptr)
            PARSE_ERROR("unbound variable");
        (yyval.regAccess).row = 0;
        (yyval.regAccess).elem = 0;
    }
#line 5258 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 364: /* SrcAddrOperand: AddrVarAccessWithWidth  */
#line 2552 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_set_address_operand(
                (yyvsp[0].regAccess).cisa_decl, (yyvsp[0].regAccess).elem, (yyvsp[0].regAccess).row, false, CISAlineno));
    }
#line 5268 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 365: /* SrcGeneralOperand: Var TwoDimOffset SrcRegionDirect  */
#line 2560 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, MODIFIER_NONE, CISAlineno));
    }
#line 5278 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 366: /* SrcGeneralOperand: SrcModifier Var TwoDimOffset SrcRegionDirect  */
#line 2567 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_gen_src_operand(
                (yyvsp[-2].string), (yyvsp[0].cisa_region).v_stride, (yyvsp[0].cisa_region).width, (yyvsp[0].cisa_region).h_stride, (yyvsp[-1].offset).row, (yyvsp[-1].offset).elem, (yyvsp[-3].src_mod).mod, CISAlineno));
    }
#line 5288 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 367: /* SrcImmOperand: IntExpUnr DataTypeIntOrVector  */
#line 2577 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed((yyvsp[-1].intval), (yyvsp[0].type), CISAlineno);
    }
#line 5296 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 368: /* SrcImmOperand: HEX_LIT HFTYPE  */
#line 2582 "CISA.y"
                     {
        MUST_HOLD((yyvsp[-1].intval) < 0x10000, "literal too large for half float");
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_immed(
            (unsigned short)(yyvsp[-1].intval), ISA_TYPE_HF, CISAlineno);
    }
#line 5306 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 369: /* SrcImmOperand: FloatLit  */
#line 2590 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5314 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 370: /* SrcImmOperand: MINUS FloatLit  */
#line 2593 "CISA.y"
                     {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_F, CISAlineno);
    }
#line 5322 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 371: /* SrcImmOperand: DoubleFloatLit  */
#line 2599 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed((yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5330 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 372: /* SrcImmOperand: MINUS DoubleFloatLit  */
#line 2603 "CISA.y"
    {
        (yyval.genOperand).cisa_gen_opnd = pBuilder->CISA_create_float_immed(-(yyvsp[0].fltval), ISA_TYPE_DF, CISAlineno);
    }
#line 5338 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 374: /* FloatLit: DEC_LIT FTYPE  */
#line 2610 "CISA.y"
   {
        // "1:f" means 1.4e-45
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5349 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 375: /* FloatLit: HEX_LIT FTYPE  */
#line 2617 "CISA.y"
   {
        int number = (int)(yyvsp[-1].intval);
        float *fp = (float *)&number;
        (yyval.fltval) = *fp;
   }
#line 5359 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 377: /* DoubleFloatLit: DEC_LIT DFTYPE  */
#line 2625 "CISA.y"
                    {
        // "1:df" means 5e-324
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5370 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 378: /* DoubleFloatLit: HEX_LIT DFTYPE  */
#line 2631 "CISA.y"
                    {
        // to support 0x7ff0000000000000:df
        int64_t number = (yyvsp[-1].intval);
        double *fp = (double *)&number;
        (yyval.fltval) = *fp;
   }
#line 5381 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 379: /* SrcIndirectOperand: IndirectVarAccess SrcRegionIndirect DataType  */
#line 2642 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, MODIFIER_NONE, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5392 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 380: /* SrcIndirectOperand: SrcModifier IndirectVarAccess SrcRegionIndirect DataType  */
#line 2650 "CISA.y"
    {
        ABORT_ON_FAIL((yyval.genOperand).cisa_gen_opnd =
            pBuilder->CISA_create_indirect(
                (yyvsp[-2].regAccess).cisa_decl, (yyvsp[-3].src_mod).mod, (yyvsp[-2].regAccess).row, (yyvsp[-2].regAccess).elem, (yyvsp[-2].regAccess).immOff,
                (yyvsp[-1].cisa_region).v_stride, (yyvsp[-1].cisa_region).width, (yyvsp[-1].cisa_region).h_stride, (yyvsp[0].type), CISAlineno));
    }
#line 5403 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 381: /* DstRegion: LANGLE IntExpNRA RANGLE  */
#line 2659 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "Dst HorzStride must be 0, 1, 2, or 4");
        (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5413 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 382: /* SrcRegionDirect: LANGLE IntExp SEMI IntExp COMMA IntExpNRA RANGLE  */
#line 2677 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-5].intval) == 0 || (yyvsp[-5].intval) == 1 || (yyvsp[-5].intval) == 2 || (yyvsp[-5].intval) == 4 || (yyvsp[-5].intval) == 8 || (yyvsp[-5].intval) == 16 || (yyvsp[-5].intval) == 32),
                 "Src Region VertStride must be 0, 1, 2, 4, 8, 16, or 32");
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Src Region Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "Src Region HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = (unsigned)(yyvsp[-5].intval);
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5429 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 384: /* SrcRegionIndirect: LANGLE IntExp COMMA DEC_LIT RANGLE  */
#line 2694 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-3].intval) == 0 || (yyvsp[-3].intval) == 1 || (yyvsp[-3].intval) == 2 || (yyvsp[-3].intval) == 4 || (yyvsp[-3].intval) == 8 || (yyvsp[-3].intval) == 16),
                 "Width must be 0, 1, 2, 4, 8 or 16");
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
                 "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = (unsigned)(yyvsp[-3].intval);
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5443 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 385: /* SrcRegionIndirect: LANGLE IntExpNRA RANGLE  */
#line 2705 "CISA.y"
    {
        MUST_HOLD(((yyvsp[-1].intval) == 0 || (yyvsp[-1].intval) == 1 || (yyvsp[-1].intval) == 2 || (yyvsp[-1].intval) == 4),
             "HorzStride must be 0, 1, 2, or 4");
        (yyval.cisa_region).v_stride = -1;
        (yyval.cisa_region).width = -1;
        (yyval.cisa_region).h_stride = (unsigned)(yyvsp[-1].intval);
    }
#line 5455 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 386: /* IndirectVarAccess: IND_LBRACK AddrVarAccess COMMA IntExp RBRACK  */
#line 2715 "CISA.y"
                                                 {
        (yyval.regAccess) = (yyvsp[-3].regAccess);
        (yyval.regAccess).immOff = (int)(yyvsp[-1].intval);
    }
#line 5464 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 387: /* IndirectVarAccess: IND_LBRACK AddrVarAccess RBRACK  */
#line 2720 "CISA.y"
                                                 {
          (yyval.regAccess) = (yyvsp[-1].regAccess);
          (yyval.regAccess).immOff = 0;
    }
#line 5473 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 388: /* TwoDimOffset: LPAREN IntExp COMMA IntExp RPAREN  */
#line 2725 "CISA.y"
                                                {
        MUST_HOLD((yyvsp[-3].intval) >= 0, "row (register) offset must be positive");
        (yyval.offset).row = (int)(yyvsp[-3].intval);
        MUST_HOLD((yyvsp[-1].intval) >= 0 && (yyvsp[-1].intval) <= 0xFFFF, "sub-register offset out of bounds");
        (yyval.offset).elem = (int)(yyvsp[-1].intval);
    }
#line 5484 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 389: /* PredVar: Var  */
#line 2733 "CISA.y"
        {
        (yyval.vISADecl) = pBuilder->CISA_find_decl((yyvsp[0].string));
        if ((yyval.vISADecl) == nullptr)
            PARSE_ERROR((yyvsp[0].string), ": undefined predicate variable");
        if ((yyval.vISADecl)->type != PREDICATE_VAR)
            PARSE_ERROR((yyvsp[0].string), ": not a predicate variable");
    }
#line 5496 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 390: /* AddrVarAccess: Var LPAREN IntExp RPAREN  */
#line 2742 "CISA.y"
                             {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-3].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-3].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-3].string), ": not an address variable");
        }
        (yyval.regAccess).row = 1;
        (yyval.regAccess).elem = (int)(yyvsp[-1].intval);
    }
#line 5511 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 391: /* AddrVarAccessWithWidth: Var LPAREN IntExp RPAREN LANGLE IntExpNRA RANGLE  */
#line 2754 "CISA.y"
                                                     {
        (yyval.regAccess).cisa_decl = pBuilder->CISA_find_decl((yyvsp[-6].string));
        if ((yyval.regAccess).cisa_decl == nullptr) {
            PARSE_ERROR((yyvsp[-6].string), ": unbound variable");
        } else if ((yyval.regAccess).cisa_decl->type != ADDRESS_VAR) {
            PARSE_ERROR((yyvsp[-6].string), ": not an address variable");
        }
        (yyval.regAccess).row = (int)(yyvsp[-1].intval);
        (yyval.regAccess).elem = (int)(yyvsp[-4].intval);
    }
#line 5526 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 392: /* SIMDMode: %empty  */
#line 2768 "CISA.y"
           {(yyval.intval) = 0;}
#line 5532 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 393: /* SIMDMode: LPAREN DEC_LIT RPAREN  */
#line 2771 "CISA.y"
    {
       MUST_HOLD(((yyvsp[-1].intval) == 8 || (yyvsp[-1].intval) == 16 || (yyvsp[-1].intval) == 32),
                 "SIMD mode can only be 8, 16, or 32");
       (yyval.intval) = (yyvsp[-1].intval);
    }
#line 5542 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 394: /* ElemNum: DOT DEC_LIT  */
#line 2782 "CISA.y"
    {
        (yyval.intval) = (yyvsp[0].intval);
    }
#line 5550 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 395: /* ExecSize: LPAREN ExecSizeInt RPAREN  */
#line 2794 "CISA.y"
    {
        (yyval.emask_exec_size).emask = vISA_EMASK_M1;
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5559 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 396: /* ExecSize: LPAREN Var COMMA ExecSizeInt RPAREN  */
#line 2800 "CISA.y"
    {
        if (!ParseEMask((yyvsp[-3].string), (yyval.emask_exec_size).emask)) {
            PARSE_ERROR("invalid execution offset info");
        }
        (yyval.emask_exec_size).exec_size = (int)(yyvsp[-1].intval);
    }
#line 5570 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 397: /* ExecSizeInt: DEC_LIT  */
#line 2808 "CISA.y"
    {
        if ((yyvsp[0].intval) != 1 && (yyvsp[0].intval) != 2 && (yyvsp[0].intval) != 4 && (yyvsp[0].intval) != 8 && (yyvsp[0].intval) != 16 && (yyvsp[0].intval) != 32) {
            PARSE_ERROR("invalid execution size");
        }
        (yyval.intval) = (unsigned short)(yyvsp[0].intval);
    }
#line 5581 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 403: /* IntExpCond: IntExpAND QUESTION IntExpAND COLON IntExpCond  */
#line 2822 "CISA.y"
                                                    {(yyval.intval) = (yyvsp[-4].intval) ? (yyvsp[-2].intval) : (yyvsp[0].intval);}
#line 5587 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 405: /* IntExpAND: IntExpAND AMP IntExpXOR  */
#line 2825 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) & (yyvsp[0].intval);}
#line 5593 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 407: /* IntExpXOR: IntExpXOR CIRC IntExpOR  */
#line 2828 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) ^ (yyvsp[0].intval);}
#line 5599 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 409: /* IntExpOR: IntExpOR PIPE IntExpCmp  */
#line 2831 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) | (yyvsp[0].intval);}
#line 5605 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 411: /* IntExpCmp: IntExpRel EQ IntExpRel  */
#line 2834 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) == (yyvsp[0].intval);}
#line 5611 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 412: /* IntExpCmp: IntExpRel NEQ IntExpRel  */
#line 2835 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) != (yyvsp[0].intval);}
#line 5617 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 414: /* IntExpRel: IntExpNRA LANGLE IntExpNRA  */
#line 2838 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) < (yyvsp[0].intval);}
#line 5623 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 415: /* IntExpRel: IntExpNRA RANGLE IntExpNRA  */
#line 2839 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) > (yyvsp[0].intval);}
#line 5629 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 416: /* IntExpRel: IntExpNRA LEQ IntExpNRA  */
#line 2840 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) <= (yyvsp[0].intval);}
#line 5635 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 417: /* IntExpRel: IntExpNRA GEQ IntExpNRA  */
#line 2841 "CISA.y"
                                 {(yyval.intval) = (yyvsp[-2].intval) >= (yyvsp[0].intval);}
#line 5641 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 420: /* IntExpShift: IntExpAdd SHL IntExpAdd  */
#line 2864 "CISA.y"
                               {(yyval.intval) = (yyvsp[-2].intval) << (yyvsp[0].intval);}
#line 5647 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 421: /* IntExpShift: IntExpAdd SHRS IntExpAdd  */
#line 2865 "CISA.y"
                               {(yyval.intval) = (int64_t)(yyvsp[-2].intval) >> (int)(yyvsp[0].intval);}
#line 5653 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 422: /* IntExpShift: IntExpAdd SHRZ IntExpAdd  */
#line 2866 "CISA.y"
                               {(yyval.intval) = (int64_t)((uint64_t)(yyvsp[-2].intval) >> (uint64_t)(yyvsp[0].intval));}
#line 5659 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 424: /* IntExpAdd: IntExpAdd PLUS IntExpMul  */
#line 2869 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) + (yyvsp[0].intval);}
#line 5665 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 425: /* IntExpAdd: IntExpAdd MINUS IntExpMul  */
#line 2870 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) - (yyvsp[0].intval);}
#line 5671 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 427: /* IntExpMul: IntExpMul TIMES IntExpUnr  */
#line 2873 "CISA.y"
                                {(yyval.intval) = (yyvsp[-2].intval) * (yyvsp[0].intval);}
#line 5677 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 428: /* IntExpMul: IntExpMul SLASH IntExpUnr  */
#line 2874 "CISA.y"
                                {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) / (yyvsp[0].intval);
        }
#line 5687 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 429: /* IntExpMul: IntExpMul PERCENT IntExpUnr  */
#line 2879 "CISA.y"
                                  {
            if ((yyvsp[0].intval) == 0)
                PARSE_ERROR("division by 0");
            (yyval.intval) = (yyvsp[-2].intval) % (yyvsp[0].intval);
        }
#line 5697 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 431: /* IntExpUnr: MINUS IntExpUnr  */
#line 2886 "CISA.y"
                      {(yyval.intval) = -(yyvsp[0].intval);}
#line 5703 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 432: /* IntExpUnr: TILDE IntExpUnr  */
#line 2887 "CISA.y"
                      {(yyval.intval) = ~(yyvsp[0].intval);}
#line 5709 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 433: /* IntExpUnr: BANG IntExpUnr  */
#line 2888 "CISA.y"
                      {(yyval.intval) = !((yyvsp[0].intval));}
#line 5715 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 437: /* IntExpPrim: LPAREN IntExp RPAREN  */
#line 2896 "CISA.y"
                           {(yyval.intval) = (yyvsp[-1].intval);}
#line 5721 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 438: /* IntExpPrim: BUILTIN_SIZEOF IDENT  */
#line 2900 "CISA.y"
                           {
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[0].string), (yyval.intval)));
    }
#line 5730 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 439: /* IntExpPrim: BUILTIN_SIZEOF LPAREN IDENT RPAREN  */
#line 2904 "CISA.y"
                                         {
        // TODO: %AlignOf(...), %Max(..)
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_eval_sizeof_decl(CISAlineno, (yyvsp[-1].string), (yyval.intval)));
    }
#line 5740 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;

  case 440: /* IntExpPrim: BUILTIN_DISPATCH_SIMD_SIZE  */
#line 2910 "CISA.y"
                                 {
        // e.g. %DispatchSimdSize
        // N.B. %sizeof happens above
        (yyval.intval) = 0;
        ABORT_ON_FAIL(pBuilder->CISA_lookup_builtin_constant(CISAlineno, "%DispatchSimd", (yyval.intval)));
    }
#line 5751 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"
    break;


#line 5755 "/builddir/build/BUILD/intel-graphics-compiler-igc-1.0.13700.7/redhat-linux-build/IGC/visa/CISA.tab.cpp"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (pBuilder, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, pBuilder);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, pBuilder);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (pBuilder, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, pBuilder);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, pBuilder);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2928 "CISA.y"

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
//                        Utility Functions                                  //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////

void CISAerror(CISA_IR_Builder* pBuilder, char const *s)
{
    pBuilder->RecordParseError(CISAlineno, s);
}

static bool streq(const char *sym0, const char *sym1)
{
  return strcmp(sym0, sym1) == 0;
}

static bool ParseAlign(CISA_IR_Builder* pBuilder, const char *sym, VISA_Align &value)
{
    if (strcmp(sym, "byte") == 0) {
        value = ALIGN_BYTE;
    } else if (strcmp(sym, "word") == 0) {
        value = ALIGN_WORD;
    } else if (strcmp(sym, "dword") == 0) {
        value = ALIGN_DWORD;
    } else if (strcmp(sym, "qword") == 0) {
        value = ALIGN_QWORD;
    } else if (strcmp(sym, "oword") == 0) {
        value = ALIGN_OWORD;
    } else if (strcmp(sym, "GRF") == 0) {
        value = ALIGN_GRF;
    } else if (strcmp(sym, "GRFx2") == 0 || strcmp(sym, "2GRF") == 0) {
        value = ALIGN_2_GRF;
    } else if (strcmp(sym, "hword") == 0) {
        value = ALIGN_HWORD;
    } else if (strcmp(sym, "wordx32") == 0) {
        value = ALIGN_32WORD;
    } else if (strcmp(sym, "wordx64") == 0) {
        value = ALIGN_64WORD;
    } else {
        value = ALIGN_UNDEF;
        return false;
    }
    return true;
}


static VISA_Align AlignBytesToVisaAlignment(int bytes)
{
    VISA_Align val = ALIGN_UNDEF;
    switch (bytes) {
    case 1:   val = ALIGN_BYTE; break;
    case 2:   val = ALIGN_WORD; break;
    case 4:   val = ALIGN_DWORD; break;
    case 8:   val = ALIGN_QWORD; break;
    case 16:  val = ALIGN_OWORD; break;
    case 32:  val = ALIGN_HWORD; break;
    case 64:  val = ALIGN_32WORD; break;
    case 128: val = ALIGN_64WORD; break;
    default:  val = ALIGN_UNDEF; break;
    }
    return val;
}



static bool ParseEMask(
    const char* sym,
    VISA_EMask_Ctrl &emask)
{
    if (strcmp(sym, "NoMask") == 0) {
        emask = vISA_EMASK_M1_NM;
        return true;
    }
    for (int i = 0; i < vISA_NUM_EMASK +1; i++)
    {
        if (!strcmp(emask_str[i], sym))
        {
            emask = (VISA_EMask_Ctrl)i;
            return true;
        }
    }

    emask = vISA_NUM_EMASK;
    return false;
}

static int lscCheckExecSize(
    CISA_IR_Builder* pBuilder,
    LSC_SFID sfid,
    LSC_OP op,
    LSC_DATA_ORDER data_order,
    int exec_size)
{
    int is_vector_op =
        op != LSC_LOAD_BLOCK2D &&
        op != LSC_STORE_BLOCK2D;
        // other ops like LSC_LOAD_SURFACE_INFO may be SIMD1
    if (op == LSC_READ_STATE_INFO) {
        exec_size = 1;
    } else if (data_order == LSC_DATA_ORDER_NONTRANSPOSE && is_vector_op) {
        if (exec_size == UNDEFINED_EXEC_SIZE) {
            if (pBuilder->getPlatform() == Xe_DG2) // for DG2 typed is 8, untyped is 16
                exec_size = sfid == LSC_TGM ? 8 : 16;
            else if (pBuilder->getPlatform() >= Xe_PVC) // on PVC typed is 16, untyped is 32
                exec_size = sfid == LSC_TGM ? 16 : 32;
            else
                exec_size = 32; // the world is finally sane
        }
    } else {
        // block and transpose get SIMD by default
        if (exec_size == UNDEFINED_EXEC_SIZE) {
           exec_size = 1; // transpose is implicitly 1 if needed
        }
    }
    return exec_size;
}
